Package: NetSAM
Type: Package
Title: Network Seriation And Modularization
Version: 1.52.0
Date: 2023-03-23
Author: Jing Wang <jing.wang@bcm.edu>
Maintainer: Zhiao Shi <zhiao.shi@gmail.com>
Description: The NetSAM (Network Seriation and Modularization) package takes an edge-list representation of a weighted or unweighted network as an input, performs network seriation and modularization analysis, and generates as files that can be used as an input for the one-dimensional network visualization tool NetGestalt (http://www.netgestalt.org) or other network analysis. The NetSAM package can also generate correlation network (e.g. co-expression network) based on the input matrix data, perform seriation and modularization analysis for the correlation network and calculate the associations between the sample features and modules or identify the associated GO terms for the modules.
License: LGPL
LazyLoad: yes
Depends: R (>= 3.0.0), seriation (>= 1.0-6), igraph (>= 2.0.0), tools
        (>= 3.0.0), WGCNA (>= 1.34.0), biomaRt (>= 2.18.0)
Imports: methods, AnnotationDbi (>= 1.28.0), doParallel (>= 1.0.10),
        foreach (>= 1.4.0), survival (>= 2.37-7), GO.db (>= 2.10.0),
        R2HTML (>= 2.2.0), DBI (>= 0.5-1)
Suggests: RUnit, BiocGenerics, org.Sc.sgd.db, org.Hs.eg.db,
        org.Mm.eg.db, org.Rn.eg.db, org.Dr.eg.db, org.Ce.eg.db,
        org.Cf.eg.db, org.Dm.eg.db, org.At.tair.db, rmarkdown, knitr,
        markdown
Collate: zzz.R NetSAM.R NetAnalyzer.R MatNet.R MatSAM.R consensusNet.R
        mapToSymbol.R testFileFormat.R featureAssociation.R
        GOAssociation.R mergeDuplicate.R
NeedsCompilation: no
VignetteBuilder: knitr
Packaged: 2026-04-28 23:35:56 UTC; biocbuild
git_url: https://git.bioconductor.org/packages/NetSAM
git_branch: RELEASE_3_23
git_last_commit: e4e22cb
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28

Package: NetSAM
Type: Package
Title: Network Seriation And Modularization
Version: 1.38.0
Date: 2021-05-15
Author: Jing Wang <jing.wang@bcm.edu>
Maintainer: Zhiao Shi <zhiao.shi@gmail.com>
Description: The NetSAM (Network Seriation and Modularization) package takes an edge-list representation of a weighted or unweighted network as an input, performs network seriation and modularization analysis, and generates as files that can be used as an input for the one-dimensional network visualization tool NetGestalt (http://www.netgestalt.org) or other network analysis. The NetSAM package can also generate correlation network (e.g. co-expression network) based on the input matrix data, perform seriation and modularization analysis for the correlation network and calculate the associations between the sample features and modules or identify the associated GO terms for the modules.
License: LGPL
LazyLoad: yes
Depends: R (>= 3.0.0), seriation (>= 1.0-6), igraph (>= 0.6-1), tools
        (>= 3.0.0), WGCNA (>= 1.34.0), biomaRt (>= 2.18.0)
Imports: methods, AnnotationDbi (>= 1.28.0), doParallel (>= 1.0.10),
        foreach (>= 1.4.0), survival (>= 2.37-7), GO.db (>= 2.10.0),
        R2HTML (>= 2.2.0), DBI (>= 0.5-1)
Suggests: RUnit, BiocGenerics, org.Sc.sgd.db, org.Hs.eg.db,
        org.Mm.eg.db, org.Rn.eg.db, org.Dr.eg.db, org.Ce.eg.db,
        org.Cf.eg.db, org.Dm.eg.db, org.At.tair.db, rmarkdown, knitr,
        markdown
Collate: zzz.R NetSAM.R NetAnalyzer.R MatNet.R MatSAM.R consensusNet.R
        mapToSymbol.R testFileFormat.R featureAssociation.R
        GOAssociation.R mergeDuplicate.R
NeedsCompilation: no
VignetteBuilder: knitr
Packaged: 2022-11-01 22:11:57 UTC; biocbuild
git_url: https://git.bioconductor.org/packages/NetSAM
git_branch: RELEASE_3_16
git_last_commit: dd9a6db
git_last_commit_date: 2022-11-01
Date/Publication: 2022-11-01

GOAssociation <-
function(NetSAMOutput,outputHtmlFile,organism="hsapiens",outputType="significant",fdrmethod="BH",fdrth=0.05,topNum=5){
    
    #require("GO.db") || stop("package GO.db is required")
    
    if(is.null(NetSAMOutput$rulfile) || is.null(NetSAMOutput$hmifile)){
        stop("NetSAMOutput should be the output from NetSAM function, which contain rulfile, hmifile and network!\n")
    }
    
    if(length(which(outputType %in% c("significant","top")))==0){
        stop("The input 'outputType' is invalid! Please select a method from 'significant' and 'top'!\n")
    }
    
    organisms <- c("hsapiens","mmusculus","rnorvegicus","drerio","celegans","scerevisiae","cfamiliaris","dmelanogaster","athaliana")
    names(organisms) <- c("Hs","Mm","Rn","Dr","Ce","Sc","Cf","Dm","At")
    
    if(length(which(organisms==organism))==0){
        stop("Currently, the package supports the following nine organisms: hsapiens, mmusculus, rnorvegicus, drerio, celegans, scerevisiae, cfamiliaris, dmelanogaster and athaliana!")
    }

    or <- names(organisms)[which(organisms==organism)]
    
    #if(organism=="scerevisiae"){
    #    require("org.Sc.sgd.db") || stop("package org.Sc.sgd.db is required!!\n")
    #}else{
    #    if(organism=="athaliana"){
    #        require("org.At.tair.db") || stop("package org.At.tair.db is required!!\n")
    #    }else{
    #        require(paste("org.",or,".eg.db",sep=""),character.only = TRUE) || stop(paste("package org.", or, ".eg.db is required!!\n", sep=""))
    #    }

    #}
    
    if(length(which(fdrmethod %in% c("holm","hochberg","hommel","bonferroni","BH","BY","none")))==0){
        stop("The input 'fdrmethod' is invalid! Please select an option from 'holm','hochberg', 'hommel', 'bonferroni', 'BH', 'BY' and 'none'!\n")
    }
    
    if(organism=="scerevisiae"){
        .sql_bp <-  "select distinct t1.gene_name,t2.go_id from sgd as t1 inner join go_bp_all as t2 on t1._id=t2._id"
        .sql_cc <-  "select distinct t1.gene_name,t2.go_id from sgd as t1 inner join go_cc_all as t2 on t1._id=t2._id"
        .sql_mf <-  "select distinct t1.gene_name,t2.go_id from sgd as t1 inner join go_mf_all as t2 on t1._id=t2._id"
    }else{
        .sql_bp <-  "select distinct t1.symbol,t2.go_id from gene_info as t1 inner join go_bp_all as t2 on t1._id=t2._id"
        .sql_cc <-  "select distinct t1.symbol,t2.go_id from gene_info as t1 inner join go_cc_all as t2 on t1._id=t2._id"
        .sql_mf <-  "select distinct t1.symbol,t2.go_id from gene_info as t1 inner join go_mf_all as t2 on t1._id=t2._id"
    }
    if(organism=="scerevisiae"){
        conn <- org.Sc.sgd.db::org.Sc.sgd_dbconn()
    }else{
        if(organism=="athaliana"){
            conn <- org.At.tair.db::org.At.tair_dbconn()
        }else{
            conn <- eval(parse(text=paste("org.",or,".eg.db::","org.",or,".eg_dbconn()", sep = "")))
        }
    }
    generalAnn_BP <- dbGetQuery(conn, .sql_bp)
    generalAnn_BP <- generalAnn_BP[!is.na(generalAnn_BP[,1]),]
    bp_num <- tapply(generalAnn_BP[,1],generalAnn_BP[,2],length)
    bp_num <- bp_num[bp_num>=10 & bp_num<=2000]
    generalAnn_BP <- generalAnn_BP[generalAnn_BP[,2] %in% names(bp_num),]
    
    generalAnn_CC <- dbGetQuery(conn, .sql_cc)
    generalAnn_CC <- generalAnn_CC[!is.na(generalAnn_CC[,1]),]
    cc_num <- tapply(generalAnn_CC[,1],generalAnn_CC[,2],length)
    cc_num <- cc_num[cc_num>=10 & cc_num<=2000]
    generalAnn_CC <- generalAnn_CC[generalAnn_CC[,2] %in% names(cc_num),]
    
    generalAnn_MF <- dbGetQuery(conn, .sql_mf)
    generalAnn_MF <- generalAnn_MF[!is.na(generalAnn_MF[,1]),]
    mf_num <- tapply(generalAnn_MF[,1],generalAnn_MF[,2],length)
    mf_num <- mf_num[mf_num>=10 & mf_num<=2000]
    generalAnn_MF <- generalAnn_MF[generalAnn_MF[,2] %in% names(mf_num),]
    
    
    .sql <- "select distinct go_id goid,term name from go_term";
    conn <- get("GO_dbconn")()
    allTermName <- dbGetQuery(conn,.sql)



    rul <- NetSAMOutput$rulfile
    hmi <- NetSAMOutput$hmifile
    
    refGenes <- rul[,4]
    
    annRef_BP <- generalAnn_BP[generalAnn_BP[,1] %in% refGenes,]
    annRef_CC<- generalAnn_CC[generalAnn_CC[,1] %in% refGenes,]
    annRef_MF <- generalAnn_MF[generalAnn_MF[,1] %in% refGenes,]
    
    moduleEnrich <- data.frame(moduleName="",Ontology="",GOID="",GOName="",pvalue=0,fdr=0,stringsAsFactors=F)
    mi <- 1
    for(i in c(2:nrow(hmi))){
        mN <- hmi[i,4]
        s <- hmi[i,5]
        e <- hmi[i,6]
        
        g <- rul[s:e,4]
        
        annInterest_BP <- generalAnn_BP[generalAnn_BP[,1] %in% g,]
        annInterest_CC <- generalAnn_CC[generalAnn_CC[,1] %in% g,]
        annInterest_MF <- generalAnn_MF[generalAnn_MF[,1] %in% g,]
        
        t <- c()
        if(nrow(annInterest_BP)>0){
            termInfo <- .enrichmentFunction(annRef_BP, annInterest_BP,allTermName,fdrmethod)
            if(outputType=="significant"){
                termInfo <- termInfo[termInfo[,6]<fdrth,]
                if(nrow(termInfo)>0){
                    termInfo$ontology <- "Biological Process"
                    t <- rbind(t,termInfo)
                }
            }else{
                termInfo <- termInfo[order(termInfo[,5]),]
                termInfo <- termInfo[1:topNum,]
                termInfo$ontology <- "Biological Process"
                
                t <- rbind(t,termInfo)
            }
        }
        if(nrow(annInterest_CC)>0){
            termInfo <- .enrichmentFunction(annRef_CC, annInterest_CC,allTermName,fdrmethod)
            if(outputType=="significant"){
                termInfo <- termInfo[termInfo[,6]<fdrth,]
                if(nrow(termInfo)>0){
                    termInfo$ontology <- "Cellular Component"
                    t <- rbind(t,termInfo)
                }
            }else{
                termInfo <- termInfo[order(termInfo[,5]),]
                termInfo <- termInfo[1:topNum,]
                termInfo$ontology <- "Cellular Component"
                t <- rbind(t,termInfo)
            }
        }
        if(nrow(annInterest_MF)>0){
            termInfo <- .enrichmentFunction(annRef_MF, annInterest_MF,allTermName,fdrmethod)
            if(outputType=="significant"){
                termInfo <- termInfo[termInfo[,6]<fdrth,]
                if(nrow(termInfo)>0){
                    termInfo$ontology <- "Molecular Function"
                    t <- rbind(t,termInfo)
                }
            }else{
                termInfo <- termInfo[order(termInfo[,5]),]
                termInfo <- termInfo[1:topNum,]
                termInfo$ontology <- "Molecular Function"
                t <- rbind(t,termInfo)
            }
        }
        
        if(length(t)>0){
            moduleEnrich[mi:(mi+nrow(t)-1),1] <- mN
            moduleEnrich[mi:(mi+nrow(t)-1),2] <- t[,7]
            moduleEnrich[mi:(mi+nrow(t)-1),3] <- t[,1]
            moduleEnrich[mi:(mi+nrow(t)-1),4] <- t[,2]
            moduleEnrich[mi:(mi+nrow(t)-1),5] <- format(t[,5],scientific=TRUE,digits=3)
            moduleEnrich[mi:(mi+nrow(t)-1),6] <- format(t[,6],scientific=TRUE,digits=3)
            mi <- mi + nrow(t)
        }

    }

    if(moduleEnrich[1,1]!=""){
        .createHTML_GO(outputHtmlFile,moduleEnrich,outputType,fdrmethod,fdrth,topNum)
        cat("The associated GO terms for each module can be found at ",outputHtmlFile,".html!\n",sep="")
        return(moduleEnrich)
    }else{
        cat("There is no associated GO term for each module based on the input parameters!\n")
        return(NULL)
    }

}


.enrichmentFunction <- function(annRef, annInterest, allTermName, fdrmethod)
{
    allRefnum <- length(unique(annRef[,1]))
    allInterestnum <- length(unique(annInterest[,1]))
    
    allAnnterm <- unique(annRef[,2])
    allAnntermL <- length(allAnnterm)
    
    
    refTermCount <- tapply(annRef[,1],annRef[,2],length)
    
    refTermName <- allTermName[allTermName[,1] %in% unique(annRef[,2]),]
    rownames(refTermName) <- refTermName[,1]
    refTermName <- refTermName[names(refTermCount),]
    
    refTermCount <- data.frame(goid=names(refTermCount),name=refTermName[,2],refnum=refTermCount,stringsAsFactors=F)
    refTermCount <- refTermCount[order(refTermCount[,1]),]
    interestTermCount <- tapply(annInterest[,1],annInterest[,2],length)
    interestTermCount <- data.frame(goid=names(interestTermCount),interestnum=interestTermCount,stringsAsFactors=F)
    interestTermCount <- interestTermCount[order(interestTermCount[,1]),]
    
    ref_interest_TermCount <- refTermCount
    
    ref_interest_TermCount$interestnum = array(0,dim=c(length(ref_interest_TermCount$goid),1))
    ref_interest_TermCount[ref_interest_TermCount$goid %in% interestTermCount[,1],4]=interestTermCount$interestnum
    
    
    n <- nrow(ref_interest_TermCount)
    pv <- array(0,dim=c(n,1))
    for (i in c(1:n)){
        p <- 1-phyper(ref_interest_TermCount[i,4]-1,allInterestnum,allRefnum-allInterestnum,ref_interest_TermCount[i,3],lower.tail = TRUE,log.p= FALSE)
        pv[i,1] <- p
    }
    ref_interest_TermCount$pvalue <- pv
    adp <- p.adjust(pv,method=fdrmethod)
    ref_interest_TermCount$FDR <- adp
    return(ref_interest_TermCount)
}





.createHTML_GO <- function(outputHtmlFile,moduleEnrich,outputType,fdrmethod,fdrth,topNum){
    
    outputDir <- dirname(outputHtmlFile)
    htmlFileName <- basename(outputHtmlFile)
    
    target <- HTMLInitFile(outputDir, filename=htmlFileName, BackGroundColor="#BBBBEE")
    HTML("<h2>The associated GO terms for each module", file=target)
    if(outputType=="significant"){
        HTML(paste("<h2>The GO terms for each Ontology were identified under FDR ",fdrth," based on ",fdrmethod,"</h2>",sep=""), file=target)
    }else{
        HTML(paste("<h2>Top ",topNum," GO terms for each Ontology were selected as the related GO terms</h2>",sep=""), file=target)
    }
    
    moduleEnrich <- moduleEnrich[order(moduleEnrich[,1],moduleEnrich[,2],moduleEnrich[,5]),]
    
    modules <- unique(moduleEnrich[,1])
    
    de <- '<table><tr><th width="15%" align="left">Module Name</th><th width="15%" align="left">Ontology</th><th width="15%" align="left">GO ID</th><th width="35%" align="left">GO Name</th><th width="10%" align="center">P Value</th><th width="10%" align="center">FDR</th></tr>'

    HTML(de, file=target)
    
    for(i in c(1:length(modules))){
        info <- moduleEnrich[moduleEnrich[,1]==modules[i],]
        gohref <- paste("http://amigo.geneontology.org/amigo/term/",info[i,3],sep="")
        de <- paste('<tr><td>',info[1,1],'</td><td>',info[1,2],'</td><td><a href="',gohref,'" target="_blank">',info[1,3],"</a></td><td>",info[1,4],'</td><td align="center">',info[1,5],'</td><td align="center">',info[1,6],"</td></tr>",sep="")
        HTML(de,file=target)
        
        if(nrow(info)>1){
            for(j in c(2:nrow(info))){
                 de <- paste('<tr><td> </td><td>',info[j,2],'</td><td><a href="',gohref,'" target="_blank">',info[j,3],"</a></td><td>",info[j,4],'</td><td align="center">',info[j,5],'</td><td align="center">',info[j,6],"</td></tr>",sep="")
                 HTML(de,file=target)
            }
        }
        
        de <- "<tr><td> </td><td> </td><td> </td><td> </td><td> </td><td> </td><td> </td><td> </td></tr>"
        HTML(de,file=target)
        HTML(de,file=target)
        
    }
    HTML("</table><br/><br/>",file=target)
    
    HTMLEndFile()
    
    #browseURL(file.path(outputDir,paste(htmlFileName,".html",sep="")))

}

consensusNet <- function(data, organism="hsapiens",bootstrapNum=100, naPer=0.5, meanPer=0.8,varPer=0.8,method="rank_unsig",value=3/1000,pth=1e-6, 
                         nMatNet=2, nThreads=4){
# there are two levels of parallelism here
# level 1: the number of concurrent running MatNet processes
# level 2: for each MatNet process, how many threads can be use 


#  entrezId <- IDMapping(organism=organism,dataType="list",
#                       inputGene=rownames(data), sourceIdType="genesymbol", 
#                       targetIdType="entrezgene", hostName=hostName)
#
#  entrezId <- entrezId$mapped
#  data <- data[entrezId[,1],]
#  rownames(data) <- entrezId[,4]

  cl <- makeCluster(nMatNet, outfile="")
  registerDoParallel(cl)

  sampleName <- colnames(data)
  
  message("Creating random networks.....")
  bN <- foreach(i=1:bootstrapNum) %dopar% {
    ransample <- sample(sampleName,length(sampleName),replace=TRUE)
    ranData <- data[,ransample]

    if(method=="rank"){
      ranNetwork <- MatNet(inputMat=ranData, naPer=naPer, meanPer=meanPer,varPer=varPer,corrType="spearman",matNetMethod=method,rankBest=value,nThreads=nThreads)
    }

    if(method=="value"){
      ranNetwork <- MatNet(inputMat=ranData, naPer=naPer, meanPer=meanPer,varPer=varPer,corrType="spearman",matNetMethod=method,valueThr=value,nThreads=nThreads)
    }

    if(method=="rank_unsig"){
      ranNetwork <- MatNet(inputMat=ranData, naPer=naPer, meanPer=meanPer,varPer=varPer,corrType="spearman",matNetMethod="rank",rankBest=value,netFDRThr=1,nThreads=nThreads)
    }
    return(ranNetwork)
  }

  stopCluster(cl)

  message("Calculating consensus network .....")
  consensusNetwork <- .calculateConsensusNetwork(ranNetList=bN,pth=pth)
  return(consensusNetwork)
}


.normalizeNetwork <- function(network){
    x <- network[,c(2,1)]
    colnames(x) <- colnames(network)
    x <- rbind(x,network)
    x <- x[x[,1]<x[,2],]
    x <- unique(x)
    return(x)
}


.calculateConsensusNetwork <- function(ranNetList,pth){
  bootStrapNum <- length(ranNetList)
  ranEdgeNum <- c()

  allEdge <- c()

  for(i in c(1:bootStrapNum)){
    ranNet <- ranNetList[[i]]
    ranNet <- .normalizeNetwork(ranNet)
    ranEdgeNum <- c(ranEdgeNum,nrow(ranNet))

    ranNet <- paste(ranNet[,1],ranNet[,2],sep="__")
    allEdge <- c(allEdge,ranNet)
  }

  totalEdgeNum <- length(unique(allEdge))

  cat("Bonferroni 0.05:",0.05/totalEdgeNum,"\n")

  prob <- ranEdgeNum/totalEdgeNum

  mu <- sum(prob)
  sigma <- sqrt(sum(prob*(1-prob)))

  edgeRe <- table(allEdge)
  edgeReZ <- (edgeRe-mu)/sigma
  edgeReP <- pnorm(edgeReZ,mean=0,sd=1,lower.tail=FALSE)

  edgeReP <- edgeReP[edgeReP<pth]
  if(length(edgeReP)==0){
    return(NULL)
  }else{
    consensusNetwork <- names(edgeReP)
    consensusNetwork <- do.call(rbind,strsplit(consensusNetwork,"__"))
    return(consensusNetwork)
  }
}

.getClass <- function(obj) {
   cls <- class(obj)
   return(cls[1])
}

MatSAM <- function(inputMat, sampleAnn=NULL, outputFileName, outputFormat="msm", organism="hsapiens", map_to_symbol=FALSE, idType="auto", collapse_mode="maxSD", naPer=0.7, meanPer=0.8, varPer=0.8, corrType="spearman", matNetMethod="rank", valueThr=0.5, rankBest=0.003, networkType="signed", netFDRMethod="BH", netFDRThr=0.05, minModule=0.003, stepIte=FALSE, maxStep=4, moduleSigMethod="cutoff", modularityThr=0.2, ZRanNum=10, PerRanNum=100, ranSig=0.05, idNumThr=(-1), nThreads=3){
    
    #require(tools) || stop("Package tools version 3.0.0 is required!")
    
    organisms <- c("hsapiens","mmusculus","rnorvegicus","drerio","celegans","scerevisiae","cfamiliaris","dmelanogaster", "athaliana")
    names(organisms) <- c("Hs","Mm","Rn","Dr","Ce","Sc","Cf","Dm","At")
    
    if(outputFormat != "none" && missing(outputFileName)){
        stop("Please input the output file name!\n")
    }else{
        if(substr(outputFileName,nchar(outputFileName),nchar(outputFileName))=="/"){
            stop("Please input the output file name!\n")
        }
    }
    
    if(length(which(outputFormat %in% c("msm","gmt","multiple","none")))==0){
        stop("The input 'outputFormat' is invalid! Please select an output format from 'nsm', 'gmt', 'multiple' and 'none'!\n")
    }

    
    if(length(which(organisms==organism))==0){
        stop("Currently, the package supports the following nine organisms: hsapiens, mmusculus, rnorvegicus, drerio, celegans, scerevisiae, cfamiliaris, dmelanogaster and athaliana!")
    }
    
    if(length(which(collapse_mode %in% c("mean","median","maxSD","maxIQR","max","min")))==0){
        stop("The input 'collapse_mode' is not valide! Please select an option from 'mean', 'median', 'maxSD',  'maxIQR', 'max' and 'min' (use mean, median, max standard derivation, max interquartile range, maximum and minimum of duplicate genes for each sample)!\n")
    }


    if(meanPer>1 || meanPer<0 || .getClass(meanPer)!="numeric"){
        stop("The input 'meanPer' is invalid! 'meanPer' should be a positive number and less than 1!\n")
    }
    
    if(varPer>1 || varPer<0 || .getClass(varPer)!="numeric"){
        stop("The input 'varPer' is invalid! 'varPer' should be a positive number and less than 1!\n")
    }
    
    
    if(length(which(corrType %in% c("pearson","spearman")))==0){
		stop("The input 'corrType' is invalid! Please select a method from 'pearson' and 'spearman'!\n")
	}
    
    if(length(which(matNetMethod %in% c("value","rank")))==0){
		stop("The input 'matNetMethod' is invalid! Please select a method from 'value' and 'rank'!\n")
	}
    
    if(valueThr>1 || valueThr<0 || .getClass(valueThr)!="numeric"){
        stop("The input 'valueThr' is invalid! 'valueThr' should be a positive number and less than 1!\n")
    }
    
    if(rankBest<0 || rankBest>1){
        stop("The input 'rankBest' is invalid! 'rankBest' should be from 0 to 1!\n")
    }
    
    
    if(length(which(networkType %in% c("signed","unsigned")))==0){
		stop("The input 'networkType' is invalid! Please select from 'signed' and 'unsigned'!\n")
	}
    
    if(length(which(netFDRMethod %in% c("holm","hochberg","hommel","bonferroni","BH","BY","none")))==0){
		stop("The input 'netFDRMethod' is invalid! Please select an option from 'holm','hochberg', 'hommel', 'bonferroni', 'BH', 'BY' and 'none'!\n")
	}
    
    if(netFDRThr>1 || .getClass(netFDRThr)!="numeric"){
        stop("The input 'netFDRThr' is invalid! 'netFDRThr' should be a number and less than 1!\n")
    }
    
    
    if(minModule<0 || minModule>0.2){
        stop("The input 'minModule' is invalid! 'minModule' should be from 0 to 0.2!\n")
    }
    
    if(maxStep<2 || .getClass(maxStep)!="numeric"){
        stop("The input 'maxStep' is invalid! 'maxStep' should be a number and larger than 2!\n")
    }
    
	if(length(which(moduleSigMethod %in% c("cutoff","zscore","permutation")))==0){
		stop("The input 'moduleSigMethod' is invalid! Please select an option from 'cutoff','zscore' and 'permutation'!\n")
	}
    
    if(modularityThr>1 || modularityThr<0 || .getClass(modularityThr)!="numeric"){
        stop("The input 'modularityThr' is invalid! 'modularityThr' should be a positive number and less than 1!\n")
    }
    
    if(ZRanNum<10 || .getClass(ZRanNum)!="numeric"){
        stop("The input 'ZRanNum' is invalid! 'ZRanNum' should be a number and larger than 10!\n")
    }
    
    if(PerRanNum<10 || .getClass(PerRanNum)!="numeric"){
        stop("The input 'PerRanNum' is invalid! 'PerRanNum' should be a number and larger than 10!\n")
    }
    
    if(ranSig>1 || ranSig <0 || .getClass(ranSig)!="numeric"){
        stop("The input 'ranSig' is invalid! 'ranSig' should be a positive number and less than 1!\n")
    }
    
    if(idNumThr<(-1) || .getClass(idNumThr)!="numeric"){
        stop("The input 'idNumThr' is invalid! 'idNumThr' should be -1 or a positive number!\n")
    }
    
    if(nThreads<1 || .getClass(nThreads)!="numeric"){
        stop("The input 'nThreads' is invalid! 'nThreads' should be a number and greater than 1!\n")
    }
    
    
    ###################Get the whole gene symbols for the given organism###################
    if(organism=="scerevisiae"){
      #require("org.Sc.sgd.db") || stop("package org.Sc.sgd.db is required!!\n")
      genesymbol <- keys(eval(parse(text="org.Sc.sgd.db::org.Sc.sgdCOMMON2ORF")))
    }else{
        if(organism=="athaliana"){
            #require("org.At.tair.db") || stop("package org.At.tair.db is required!!\n")
            genesymbol <- unlist(as.list(eval(parse(text="org.At.tair.db::org.At.tairSYMBOL"))))
            names(genesymbol) <- NULL
            genesymbol <- unique(genesymbol)
            genesymbol <- genesymbol[!is.na(genesymbol)]
            
        }else{
            or <- names(organisms)[which(organisms==organism)]
            #require(paste("org.",or,".eg.db",sep=""),character.only = TRUE) || stop(paste("package org.", or, ".eg.db is required!!\n", sep=""))
            genesymbol <- keys(eval(parse(text=paste("org.",or,".eg.db::","org.",or,".egSYMBOL2EG",sep=""))))
        }
    }
    ################################Identify whether the input matrix and annotation file have the correct format##############################
    
    #cat("Test file\n")
    
    re <- testFileFormat(inputMat=inputMat,sampleAnn=sampleAnn,collapse_mode=collapse_mode)
    inputMat <- re$inputMat
    
    #cat("Dimension1:",dim(inputMat),"\n")
    
    is_sample <- 0
    if(!is.null(sampleAnn)){
        sampleAnn <- re$sampleAnn
        is_sample <- 1
    }
    
    geneid <- rownames(inputMat)
    sampleName <- colnames(inputMat)
    
    
    ###############Identify whether the IDs in the expression data are gene symbols###############
    
    #cat("Gene Symbol \n")
    
    is.genesymbol <- FALSE
    if(length(intersect(geneid,genesymbol))>0.6*length(geneid)){
        is.genesymbol <- TRUE
    }else{
        is.genesymbol <- FALSE
    }

        
    idmap <- NULL
    mapping.status <- 1
    if(map_to_symbol==TRUE){
        
        re <- mapToSymbol(inputData=inputMat, organism=organism, inputType="matrix", idType=idType, collapse_mode=collapse_mode, verbose=TRUE)
        
        if(!is.null(re)){
            inputMat <- re$data_symbol
            mapping.status <- 0
            idmap <- re$idmap
        }
    }else{
        if(is.genesymbol==TRUE){
            mapping.status <- 0
        }else{
            if(idType==""){      #NONE OF THE ABOVE
                mapping.status <- 1
            }else{
                re <- mapToSymbol(inputData=inputMat, organism=organism, inputType="matrix", idType=idType, collapse_mode=collapse_mode, verbose=FALSE)
             
                if(is.null(re)){
                    stop("The input idType can not match the id type of the input data! Please check whether the inut idType is correct!\n")
                }else{
                    idmap <- re$idmap
                    mapping.status <- 2
                }
            }
        }
    }
    
    ###########################Construct co-expression network##################################
    
    #cat("MatNet\n")
    
    inputMat <- as.matrix(inputMat)
    
    coExp <- MatNet(inputMat=inputMat,collapse_mode=collapse_mode,naPer=naPer,meanPer=meanPer,varPer=varPer,corrType=corrType,matNetMethod=matNetMethod,valueThr=valueThr,rankBest=rankBest,networkType=networkType,netFDRMethod=netFDRMethod,netFDRThr=netFDRThr,idNumThr=idNumThr,nThreads=nThreads)
    filtered_gene <- union(coExp[,1],coExp[,2])
    
    filteredExp <- inputMat[filtered_gene,]
    
    #############################Identify Modules###########################
    
    #cat("NetSAM\n")
    
    netgestalt <- NetSAM(inputNetwork=coExp, outputFileName=outputFileName, outputFormat="none", edgeType="unweighted", map_to_genesymbol=FALSE, organism=organism, idType=idType, minModule=minModule, stepIte=stepIte, maxStep=maxStep, moduleSigMethod=moduleSigMethod, modularityThr=modularityThr, ZRanNum=ZRanNum, PerRanNum=PerRanNum, ranSig=ranSig, edgeThr=(-1), nodeThr=(-1), nThreads=nThreads)
    
    #############################Calcualte relationship between module and sample annotation#########
    hmi <- netgestalt$hmifile
    
    hmi[,7] <- ""
    colnames(hmi)[7] <- "AssociatedFeatures"
    
    if(is_sample==1){
        cat("Calculate the associations between modules and annotations...\n")
        moduleAsso <- featureAssociation(filteredExp,sampleAnn,netgestalt,paste(outputFileName,"_featureAsso",sep=""))
        attrName <- c("FeatureName","Type","StatisticMethod","GroupComparison","Statistics","Direction","PValue","FDR")
    
        if(!is.null(moduleAsso)){
    
            for(i in c(2:nrow(hmi))){
                mN <- hmi[i,4]
                fe <- moduleAsso[moduleAsso[,1]==mN,2:ncol(moduleAsso)]
                fe <- apply(fe,1,.paste_dataframe,attrName,collapse="|")
                fe <- paste(fe,collapse=";")
                hmi[i,7] <- fe
            }
        }
    }
    
    netgestalt$hmifile <- hmi
    
    ########################Identify the most significant GO terms############
    
    if(mapping.status!=1){
        cat("Identify the associated GO Terms for each module...\n")
        goAsso <- GOAssociation(netgestalt,paste(outputFileName,"_GOAsso",sep=""),organism=organism,outputType="top",topNum=1)
        hmi <- netgestalt$hmifile
        
        hmi[,8] <- ""
        colnames(hmi)[8] <- "Related GO Terms"
        
        attrName <- c("Ontology","GOID","GOName","PValue","FDR")
        
        if(!is.null(goAsso)){
            
            for(i in c(2:nrow(hmi))){
                mN <- hmi[i,4]
                fe <- goAsso[goAsso[,1]==mN,2:ncol(goAsso)]
                fe <- apply(fe,1,.paste_dataframe,attrName,collapse="|")
                fe <- paste(fe,collapse=";")
                hmi[i,8] <- fe
            }
        }
        netgestalt$hmifile <- hmi

    }else{
        cat("Because the Ids in the matrix can not be transformed to gene symbol, GO analysis can not be performed!\n")
    }
    
    ##############################Output###################################
    
    d <- dist(t(filteredExp))
    h <- hclust(d)
    filteredExp <- filteredExp[,h$order]
    
    
    exp_output <- cbind(rownames(filteredExp),filteredExp)
    colnames(exp_output)[1] <- "GeneSymbol"
    
    netgestalt$expression <- filteredExp
    
    if(is_sample==1){
        rownames(sampleAnn) <- sampleAnn[,1]
        
        
        if(sampleAnn[2,1]=="category"){
            reo <- c("data_type","category",colnames(filteredExp))
            sampleAnn <- sampleAnn[reo,]
            hierarchicalCluster <- c("CON","cluster",1:ncol(filteredExp))
            sampleAnn <- cbind(sampleAnn,hierarchicalCluster)
        }else{
            reo <- c("data_type",colnames(filteredExp))
            sampleAnn <- sampleAnn[reo,]
            hierarchicalCluster <- c("CON",1:ncol(filteredExp))
            sampleAnn <- cbind(sampleAnn,hierarchicalCluster)
        }
    }
    
    
    if(outputFormat=="msm"){
        outputFile <- paste(outputFileName,".msm",sep="")
        note <- "##  Ruler file  ##"
        write.table(note,file=outputFile,row.names=F,col.names=F,quote=F)
        suppressWarnings(write.table(netgestalt$rulfile,file=outputFile,row.names=F,col.names=T,append=T,quote=F,sep="\t"))
        note <- "##  HMI file ##"
        write.table(note,file=outputFile,row.names=F,col.names=F,quote=F,append=T)
        suppressWarnings(write.table(netgestalt$hmifile,file=outputFile,row.names=F,col.names=T,quote=F,append=T,sep="\t"))
        note <- "##  Network file  ##"
        write.table(note,file=outputFile,row.names=F,col.names=F,quote=F,append=T)
        write.table(netgestalt$network,file=outputFile,row.names=F,col.names=F,quote=F,append=T,sep="\t")
    
        note <- "##  Expression data  ##"
        write.table(note,file=outputFile,row.names=F,col.names=F,quote=F,append=T)
    
                suppressWarnings(write.table(exp_output,file=outputFile,row.names=F,col.names=T,quote=F,append=T,sep="\t"))
    
    
        if(is_sample==1){
            
            note <- "##  Sample Annotation  ##"
            write.table(note,file=outputFile,row.names=F,col.names=F,quote=F,append=T)
            suppressWarnings(write.table(sampleAnn,file=outputFile,row.names=F,col.names=T,quote=F,append=T,sep="\t"))
            netgestalt$sampleAnn <- sampleAnn
        }
    
        note <- "##  Mapping Status  ##"
        write.table(note,file=outputFile,row.names=F,col.names=F,quote=F,append=T)
        suppressWarnings(write.table(paste("mapping.status=",mapping.status,sep=""),file=outputFile,row.names=F,col.names=F,quote=F,append=T,sep="\t"))
        netgestalt$mapping.status <- mapping.status
    
        if(mapping.status==2){
            note <- "##  Gene Annotation  ##"
            write.table(note,file=outputFile,row.names=F,col.names=F,quote=F,append=T)
            suppressWarnings(write.table(idmap,file=outputFile,row.names=F,col.names=T,quote=F,append=T,sep="\t"))
            netgestalt$geneAnn <- idmap
        }
    }
    
    if(outputFormat=="multiple"){
        outputFile <- paste(outputFileName,"_rulerFile.rul",sep="")
        write.table(netgestalt$rulfile,file=outputFile,row.names=F,col.names=T,quote=F,sep="\t")
        outputFile <- paste(outputFileName,"_hmiFile.hmi",sep="")
        write.table(netgestalt$hmifile,file=outputFile,row.names=F,col.names=T,quote=F,sep="\t")
        outputFile <- paste(outputFileName,"_corrNet.net",sep="")
        write.table(netgestalt$network,file=outputFile,row.names=F,col.names=F,quote=F,sep="\t")
        outputFile <- paste(outputFileName,"_filteredMatrix.cct",sep="")
        write.table(exp_output,file=outputFile,row.names=F,col.names=T,quote=F,sep="\t")
        if(is_sample==1){
            
            outputFile <- paste(outputFileName,"_standardizedSampleAnn.tsi",sep="")
            write.table(sampleAnn,file=outputFile,row.names=F,col.names=T,quote=F,sep="\t")
            netgestalt$sampleAnn <- sampleAnn
        }
    }
    
    if(outputFormat=="gmt"){
        gmtFile <- .createGMTFile(netgestalt$hmifile,netgestalt$rulfile)
        outputFile1 <- paste(outputFileName,".gmt",sep="")
        write.table(gmtFile,file=outputFile1,row.names=F,col.names=F,sep="\t",quote=F)
        netgestalt$gmt <- gmtFile
    }
    
    return(netgestalt)
    
}


.paste_dataframe <- function(dataframe,attrName,collapse){
    vector <- as.vector(as.matrix(dataframe))
    vector <- paste(attrName,vector,sep=":")
    vector <- paste(vector,collapse=collapse)
    return(vector)
}

.createGMTFile <- function(hmiFile,geneorder){
    allgene <- geneorder[,4]
    allgene <- paste(allgene,collapse="\t")
    humancatfile <- data.frame(name="01",childnum=1,gene=allgene,start=1,end=nrow(geneorder),level=0,stringsAsFactors=F)
    
    for(i in c(2:nrow(hmiFile))){
        st <- hmiFile[i,5]
        en <- hmiFile[i,6]
        l <- hmiFile[i,2]
        for(j in c(1:nrow(humancatfile))){
            pl <- humancatfile[j,6]
            if(pl==(l-1)){
                ps <- humancatfile[j,4]
                pe <- humancatfile[j,5]
                if(st>=ps && en<=pe){
                    pcu <- humancatfile[j,1]
                    pcu_c <- humancatfile[j,2]
                    if(pcu_c < 10){
                        pcu_c <- paste("0",pcu_c,sep="")
                    }else{
                        pcu_c <- as.character(pcu_c)
                    }
                    
                    c_cu <- paste(pcu,pcu_c,sep="-")
                    humancatfile[j,2] <- humancatfile[j,2] + 1
                    humancatfile[i,1] <- c_cu
                    humancatfile[i,2] <- 1
                    cg <- geneorder[c(st:en),4]
                    cg <- paste(cg,collapse="\t")
                    humancatfile[i,3] <- cg
                    humancatfile[i,4] <- st
                    humancatfile[i,5] <- en
                    humancatfile[i,6] <- l
                    break
                }
            }
        }
    }
    humancatfile[,7] <- humancatfile[,5]-humancatfile[,4]+1
    gmtFile <- humancatfile[,c(1,7,3)]
    return(gmtFile)
}

testFileFormat <- function(inputMat=NULL,sampleAnn=NULL,collapse_mode="maxSD"){
    
    re <- list(inputMat=NULL,sampleAnn=NULL)
    
    if(length(which(collapse_mode %in% c("mean","median","maxSD","maxIQR","max","min")))==0){
        stop("The input 'collapse_mode' is not valide! Please select an option from 'mean', 'median', 'maxSD',  'maxIQR', 'max' and 'min' (use mean, median, max standard derivation, max interquartile range, maximum and minimum of duplicate genes for each sample)!\n")
    }
    
    if(!is.null(inputMat) || !is.null(sampleAnn)){
        if(!is.null(inputMat)){
            inputMat <- .testCCTFormat(inputMat=inputMat,collapse_mode=collapse_mode)
            re$inputMat <- inputMat
        }
        if(!is.null(sampleAnn)){
            sampleAnn <- .testTSIFormat(inputMat=inputMat,sampleAnn=sampleAnn)
            re$sampleAnn <- sampleAnn
        }
        return(re)
    }else{
        stop("Please input at least data matrix or sample annotation data!")
    }
}


.getClass <- function(obj) {
   cls <- class(obj)
   return(cls[1])
}


.testCCTFormat <- function(inputMat, collapse_mode="maxSD"){
    
    if(.getClass(inputMat)=="character"){
        if(file_ext(inputMat)!="cct" && file_ext(inputMat)!="cbt"){
            stop("The extension of the input file should be 'cct' or 'cbt'. The detail of the 'cct' or 'cbt' file format can be found in the NetGestalt (www.netgestalt.org)!\n")
        }else{
            inputMat <- read.table(inputMat,header=TRUE,sep="\t",stringsAsFactors=FALSE,check.names=FALSE)
            geneid <- inputMat[,1]
            
            if(length(geneid)!=length(unique(geneid))){
                cat("The input data contain duplicate Id. The function will use ",collapse_mode," to collapse duplicate Id in each sample!\n",sep="")
                inputMat <- mergeDuplicate(geneid,inputMat[,2:ncol(inputMat)] ,collapse_mode)
            }else{
                inputMat <- inputMat[,c(2:ncol(inputMat))]
                rownames(inputMat) <- geneid
            }
        }
    }else{
        if(.getClass(inputMat) != "matrix" && .getClass(inputMat) != "data.frame"){
            stop("The type of input data should be a matrix or data.frame object. Other types of data are not supported by this package.!\n")
        }else{
            x <- apply(inputMat,2,function(e) return(.getClass(e)=="numeric" || .getClass(e)=="integer"))
            y <- all(x==TRUE)
            if(y==FALSE){
                stop("The input matrix or data.frame object should only contain numeric or integer values.\n")
            }
        }
    }
    
    if(ncol(inputMat)<6){
        stop("The data should contain at least six samples!\n")
    }
    
    if(length(which(inputMat %in% c("Inf","-Inf")))>0){
        stop("The input data contain Inf which may be gernated by some wrong operation, such as log(0) or 1/0. Please re-process the data and remove the Inf\n")
    }
    
    return(inputMat)
}

.testTSIFormat <- function(inputMat,sampleAnn){
    
    if(.getClass(sampleAnn)=="character"){
        if(file_ext(sampleAnn)!="tsi"){
            stop("The extension of the input annotation file should be 'tsi'. The detail of the 'tsi' file format can be found in the NetGestalt (www.netgestalt.org)!\n")
        }else{
            sampleAnn <- read.table(sampleAnn,header=TRUE,sep="\t",stringsAsFactors=FALSE,check.names=FALSE)
        }
    }else{
        if(.getClass(sampleAnn) != "data.frame"){
            stop("The type of input annotation data should be a data.frame object. Other types of data are not supported by this package.!\n")
        }
    }
    
    data_type <- sampleAnn[1,2:ncol(sampleAnn)]
    if(length(setdiff(unique(data_type),c("BIN","CAT","CON","SUR")))>0){
        stop("The second row of the tsi file is the data type of the annotations! The current version supports four types of features: BIN, CAT, CON, SUR. The input annotation file also contains other types:",setdiff(unique(data_type),c("BIN","CAT","CON","SUR")),".\n")
    }
    
    if(sampleAnn[2,1]=="category"){
        data <- sampleAnn[3:nrow(sampleAnn),2:ncol(sampleAnn)]
        annSampleName <- sampleAnn[3:nrow(sampleAnn),1]
        startR <- 3
    }else{
        data <- sampleAnn[2:nrow(sampleAnn),2:ncol(sampleAnn)]
        annSampleName <- sampleAnn[2:nrow(sampleAnn),1]
        startR <- 2
    }
    
    sampleName <- colnames(inputMat)
    sampleName <- data.frame(id=c(1:length(sampleName)),name=sampleName,stringsAsFactors=FALSE)
    sampleName <- sampleName[order(sampleName[,2]),]
    annSampleName <- data.frame(id=c(1:length(annSampleName)),name=annSampleName,stringsAsFactors=FALSE)
    annSampleName <- annSampleName[order(annSampleName[,2]),]
    
    if(sum(sampleName[,2]==annSampleName[,2])!=nrow(sampleName)){
        stop("The sample names in the matrix data and annotation data should be exactly same!")
    }
    
    
    for(i in c(1:length(data_type))){
        dt <- data_type[i]
        d <- data[,i]
        if(dt=="BIN"){
            d <- d[!is.na(d)]
            if(length(unique(d))!=2){
                stop(paste("column ",i+1,": Binary type must have 2 distinct values, current column contains ",length(unique(d))," values!\n",sep=""))
            }
        }
        if(dt=="CAT"){
            d <- d[!is.na(d)]
            if(length(d)<3){
                stop(paste("column ",i+1,": Category type must have at least 3 distinct values, current column contains ",length(d)," distinct values!\n",sep=""))
            }
        }
        if(dt=="CON"){
            d[is.na(d)] <- 0
            d <- as.numeric(d)
            if(length(which(is.na(d)))>0){
                stop(paste("column ",i+1,": Contenous type must only contain numbers. Row ",which(is.na(d))+startR," contain characters!\n",sep=""))
            }
        }
        if(dt=="SUR"){
            if(length(which(is.na(d)))>0){
                stop(paste("column ",i+1,": the format of 'NA' for survival information is 'NA,NA' instead of just 'NA'!. Row ",which(is.na(d))+startR," contain 'NA'.\n",sep=""))
            }
            d <- strsplit(d,",",fixed=TRUE)
            l <- lapply(d,function(e){return(length(e))})
            l <- unlist(l)
            if(length(which(l==1))>0){
                stop(paste("column ",i+1,": the format of the survival information is 'time,event'. Row ",which(l==1)+startR," only contain time or event.\n",sep=""))
            }
            d <- do.call(rbind,d)
            d1 <- d[,1]
            d2 <- d[,2]
            
            d1_in <- which(d1=="NA")
            d2_in <- which(d2=="NA")
            if(suppressWarnings(sum(d1_in==d2_in))!=length(d1_in)){
                stop(paste("column ",i+1,": if the survial time is NA, the corresponding event should be NA. Row ",c(setdiff(d1_in,d2_in),setdiff(d2_in,d1_in))," only contain one NA for time or event!\n",sep=""))
            }
            
            d1[d1=="NA"] <- 10
            d1 <- as.numeric(d1)
            if(length(which(is.na(d1)))>0){
                stop(paste("column ",i+1,": the survival time must only be numeric. Row ",which(is.na(d1))+startR," contain characters!\n",sep=""))
            }
            d2 <- d[,2]
            d2[d2=="NA"] <- 0
            d2 <- as.numeric(d2)
            if(length(which(is.na(d2)))>0){
                stop(paste("column ",i+1,": the survival event must only be 0 or 1. Row ",which(is.na(d2))+startR," contain characters!\n",sep=""))
            }
            d2 <- unique(d2)
            if(length(d2)>2){
                stop(paste("column ",i+1,": the survival event must only be 0 or 1. The current data contain ",length(d2)," values!\n",sep=""))
            }
        }
    }
    
    x <- cbind(sampleName,annSampleName)
    x <- x[order(x[,1]),]
    if(sampleAnn[2,1]=="category"){
        y <- sampleAnn[3:nrow(sampleAnn),]
        y <- y[x[,3],]
        sampleAnn <- rbind(sampleAnn[1:2,],y)
    }else{
        y <- sampleAnn[2:nrow(sampleAnn),]
        y <- y[x[,3],]
        sampleAnn <- rbind(sampleAnn[1,],y)
    }
    colnames(sampleAnn)[1] <- "Barcode"
    
    return(sampleAnn)
}

mergeDuplicate <- function(id,data,collapse_mode="maxSD"){
    
    data <- as.data.frame(data)
    if(!is.vector(id)){
        stop("The input id should be a vector object!\n")
    }
    
    if(!is.matrix(data) && !is.data.frame(data)){
        stop("The input data matrix should be a matrix or data.frame object!\n")
    }
    
    
    if(length(which(collapse_mode %in% c("mean","median","maxSD","maxIQR","max","min")))==0){
        stop("The input 'collapse_mode' is not valide! Please select an option from 'mean', 'median', 'maxSD',  'maxIQR', 'max' and 'min' (use mean, median, max standard derivation, max interquartile range, maximum and minimum of duplicate genes for each sample)!\n")
    }
    
    
    if(ncol(data)==1){
    	if(collapse_mode=="maxSD" || collapse_mode=="maxIQR"){
    		collapse_mode <- "mean"
    	}
    }
    
    mergeR <- c()
    
    if(ncol(data)==1){
    	data <- data.frame(id=id,data=data[,1],stringsAsFactors=F)
    	data <- tapply(data[,2],data[,1],collapse_mode,na.rm=TRUE)
    	return(data)
    	
   	}else{
    
    	if(collapse_mode=="mean" || collapse_mode=="median" || collapse_mode=="max" || collapse_mode=="min"){
    	
    		mergeR <- lapply(split(c(1:nrow(data)),id),function(u){return(apply(data[u,],2,collapse_mode,na.rm=TRUE))})
        
        data <- do.call(rbind,mergeR)
        return(data)
    	}
    
    
   	 if(collapse_mode=="maxSD" || collapse_mode=="maxIQR"){
        if(collapse_mode=="maxSD"){
            mergeR <- apply(data,1,sd,na.rm=TRUE)
        }
        
        if(collapse_mode=="maxIQR"){
            mergeR <- apply(data,1,IQR,na.rm=TRUE)
        }
        
        mergeR <- data.frame(id=id,score=mergeR,pos=c(1:length(mergeR)),stringsAsFactors=F)
        mergeR <- mergeR[order(mergeR[,1],-mergeR[,2]),]
        finalPos <- tapply(mergeR[,3],mergeR[,1],.returnMaxPos)
        data <- data[finalPos,]
        id <- id[finalPos]
        
        rownames(data) <- id
        return(data)
        
    	}
    }
    
}

.returnMaxPos <- function(pos){
    return(pos[1])
}

.getClass <- function(obj) {
   cls <- class(obj)
   return(cls[1])
}

MatNet <-
function(inputMat, collapse_mode="maxSD", naPer=0.7, meanPer=0.8, varPer=0.8, corrType="spearman", matNetMethod="rank", valueThr=0.5, rankBest=0.003, networkType="signed", netFDRMethod="BH", netFDRThr=0.05, idNumThr=(-1), nThreads=3){
	
    #require(igraph) || stop("Package igraph version 0.6 is required!")
    #require(WGCNA) || stop("Package WGCNA version 1.34.0 is required!")
    #require(tools) || stop("Package tools version 3.0.0 is required!")
    
    #load expression data
    
    re <- testFileFormat(inputMat=inputMat,collapse_mode=collapse_mode)
    inputMat <- re$inputMat
    inputMat <- as.matrix(inputMat)
    
    if(naPer>1 || naPer<0 || .getClass(meanPer)!="numeric"){
        stop("The input 'naPer' is invalid! 'naPer' should be a positive number and less than 1!\n")
    }
    
    if(meanPer>1 || meanPer<0 || .getClass(meanPer)!="numeric"){
        stop("The input 'meanPer' is invalid! 'meanPer' should be a positive number and less than 1!\n")
    }
    
    if(varPer>1 || varPer<0 || .getClass(varPer)!="numeric"){
        stop("The input 'varPer' is invalid! 'varPer' should be a positive number and less than 1!\n")
    }
    
    
    if(length(which(corrType %in% c("pearson","spearman")))==0){
		stop("The input 'corrType' is invalid! Please select an option from 'pearson' and 'spearman'!\n")
	}
    
    if(length(which(matNetMethod %in% c("value","rank","directed")))==0){
		stop("The input 'matNetMethod' is invalid! Please select an option from 'value','rank' and 'directed'!\n")
	}
    
    if(valueThr>1 || valueThr<0 || .getClass(valueThr)!="numeric"){
        stop("The input 'valueThr' is invalid! 'valueThr' should be a positive number and less than 1!\n")
    }
    
    if(rankBest<0 || rankBest>1){
        stop("The input 'rankBest' is invalid! 'rankBest' should be from 0 to 1!\n")
    }
    
    if(length(which(networkType %in% c("signed","unsigned")))==0){
		stop("The input 'networkType' is invalid! Please select from 'signed' and 'unsigned'!\n")
	}
    
    if(length(which(netFDRMethod %in% c("holm","hochberg","hommel","bonferroni","BH","BY","none")))==0){
		stop("The input 'netFDRMethod' is invalid! Please select a method from 'holm','hochberg', 'hommel', 'bonferroni', 'BH', 'BY' and 'none'!\n")
	}
    
    if(netFDRThr>1 || .getClass(netFDRThr)!="numeric"){
        stop("The input 'netFDRThr' is invalid! 'netFDRThr' should be a number and less than 1!\n")
    }
    
    if(idNumThr<(-1) || .getClass(idNumThr)!="numeric"){
        stop("The input 'idNumThr' is invalid! 'idNumThr' should be -1 or a positive number!\n")
    }
    
    if(nThreads<1 || .getClass(nThreads)!="numeric"){
        stop("The input 'nThreads' is invalid! 'nThreads' should be a number and greater than 1!\n")
    }
    
    missing <- 0
    
	if(length(which(is.na(inputMat)))>0){
		cat("The input data contain ",nrow(inputMat)," ids and ",ncol(inputMat)," samples. The data contain missing values.\n",sep="")
		missing <- 1
	}else{
		cat("The input data contain ",nrow(inputMat)," ids and ",ncol(inputMat)," samples. No missing values in the data.\n",sep="")
	}
    
    #filter genes
    #cat("Remove low expressed genes and less variable genes...\n")
    
    if(missing==1){
    
        naG <- apply(inputMat,1,.calculateNANum)
        if(length(naG[naG>naPer])>0){
            cat(paste("Each of ",length(naG[naG>naPer])," ids has over ",naPer*100,"% missing values in all ",ncol(inputMat)," samples.The function will remove these ids.\n",sep=""))
            naG <- naG[naG<=naPer]
            filterData <- inputMat[names(naG),]
        }else{
            filterData <- inputMat
        }
    }else{
        filterData <- inputMat
    }
    
    meanG <- apply(filterData,1,mean,na.rm=T)
    sdG <- apply(filterData,1,sd,na.rm=T)
    
    if(length(which(sdG==0))>0){
        x <- sdG[sdG==0]
        cat(paste("The function removed ",length(x)," ids with standard deviation 0.\n",sep=""))
        sdG <- sdG[sdG!=0]
        meanG <- meanG[names(sdG)]
        filterData <- filterData[names(sdG),]
    }
    
    
    meanG <- sort(meanG,decreasing=T)
    meanG <- meanG[c(1:round(meanPer*nrow(filterData)))]
    sdG <- sdG[names(meanG)]
    sdG <- sort(sdG,decreasing=T)
    sdG <- sdG[c(1:round(varPer*length(meanG)))]
    
    if(idNumThr!=(-1)){
        if(length(sdG)>idNumThr){
            cat(paste("After filtering based on parameters 'naPer', 'meanPer' and 'varPer', the number of remaining ids is still larger than parameter 'idNumThr'. Thus, the function only selects the top ",idNumThr," ids with the largest variance\n",sep=""))
            sdG <- sdG[c(1:idNumThr)]
        }
    }
    
    cat("After removing ids based on parameters 'naPer', 'meanPer' and 'varPer', ",length(sdG)," ids are remained!\n",sep="")
    
    
    filterData <- filterData[names(sdG),]
    rm(meanG,sdG,inputMat)
    gc()
    
    allowWGCNAThreads(nThreads=nThreads)
	
    
	#calculate  correlation
	cat("Calculating ",corrType," correlation for each pair of ids...\n",sep="")
	threNum <- WGCNAnThreads()
	
	if(threNum>nThreads){
		threNum <- nThreads
	}
    
    if(missing==0){
        corrM <- WGCNA::cor(t(filterData),nThreads=threNum,method=corrType)
    }else{
        corrM <- WGCNA::cor(t(filterData),nThreads=threNum,use="pairwise.complete.obs",method=corrType)
    }
    
	disableWGCNAThreads()
    
    corrM[is.na(corrM)] <- 0
    corrM[corrM==1] <- 0.99999999999999999999
    corrM[corrM==(-1)] <- (-0.99999999999999999999)
    
    rankBest <- round(rankBest*nrow(corrM))
    if(rankBest==0){
        rankBest <- 1
    }
    
    if(matNetMethod=="value"){
        sigNetwork <- .valueBasedCoexp(corrM,valueThr,networkType)
        cat("Base on value-based method, an undirected network with ",length(union(sigNetwork[,1],sigNetwork[,2]))," nodes and ",nrow(sigNetwork)," edges was identified under threshold ",valueThr,".\n",sep="")
    }
    
    if(matNetMethod=="rank"){
        sigNetwork <- .rankBasedCoexp(filterData,corrM,rankBest,matNetMethod,networkType,netFDRMethod,netFDRThr)
        cat("Base on rank-based method, an undirected network with ",length(union(sigNetwork[,1],sigNetwork[,2]))," nodes and ",nrow(sigNetwork)," edges was identified when selecting most similar ",rankBest," nodes.\n",sep="")
    }
    
    if(matNetMethod=="directed"){
        sigNetwork <- .rankBasedCoexp(filterData,corrM,rankBest=1,matNetMethod,networkType,netFDRMethod,netFDRThr)
        cat("Base on directed-based method, a directed network with ",length(union(sigNetwork[,1],sigNetwork[,2]))," nodes and ",nrow(sigNetwork)," edges was identified when only selecting most similar node. \n",sep="")

    }
    
    return(sigNetwork)
}


.valueBasedCoexp <- function(corrArray,valueThr,networkType){
    
    diag(corrArray) <- 0
    
    if(networkType=="unsigned"){
        corrArray <- abs(corrArray)
    }
    
    corrArray[lower.tri(corrArray)] <- 0
    
    sigIndex <- which(corrArray>valueThr,arr.ind=TRUE)
    
    sigPair <- array(rownames(corrArray)[sigIndex],dim=dim(sigIndex))
    return(sigPair)
}

.rankBasedCoexp <- function(filterData,corrArray,rankBest,matNetMethod,networkType,netFDRMethod,netFDRThr){
    
    
    corrArray <- .calculateSigCorr(filterData,corrArray,netFDRMethod,netFDRThr)
    
    
    #calculatePosition <- function(sindex,rownum){
    #     col <- ceiling(sindex/rownum)
    #       correctI <- sindex-cumsum(1:col)[col]
    #       return(correctI)
    #   }
    
    
    if(networkType=="unsigned"){
        corrArray <- abs(corrArray)
    }
    
    diag(corrArray) <- 0
    
    bestNeighbor <- apply(corrArray,1,.findBestNeighbor,rankBest)
    
    corrArray[corrArray!=0] <- 0
    
    
    for(i in c(1:nrow(corrArray))){
        if(!is.null(bestNeighbor[[i]][[1]])){
            x <- bestNeighbor[[i]][[1]]
            corrArray[i,x] <- 1
        }
    }
    
    if(matNetMethod=="rank"){
        corrArray <- corrArray+t(corrArray)
        corrArray[lower.tri(corrArray)] <- 0
        sigIndex <- which(corrArray==2,arr.ind=TRUE)
    }
    
    if(matNetMethod=="directed"){
        sigIndex <- which(corrArray==1,arr.ind=TRUE)
    }
    
    sigPair <- array(rownames(corrArray)[sigIndex],dim=dim(sigIndex))

    return(sigPair)
}

.calculateSigCorr <- function(filterData,corrArray,netFDRMethod,netFDRThr){
    n <- t(!is.na(t(filterData))) %*% (!is.na(t(filterData)))
    suppressWarnings(t <- (corrArray * sqrt(n - 2))/sqrt(1 - corrArray^2))
    suppressWarnings(corrP <- 2 * (1 - pt(abs(t), (n - 2))))
    rm(n,t)
    gc()
    corrP[is.na(corrP)] <- 0
    corrP[corrP>1] <- 1
    diag(corrP) <- (-1)
    corrSig <- apply(corrP,1,.fdrFilter,netFDRMethod,netFDRThr)
    corrSig <- t(corrSig)
    rm(corrP)
    gc()
    corrArray <- corrArray*corrSig
    return(corrArray)

}

.fdrFilter <- function(vector,netFDRMethod,netFDRThr){
    a <- vector[vector>=0]
    adjp <- p.adjust(a,method=netFDRMethod)
    vector[names(adjp)] <- adjp
    vector[vector==(-1)] <- 1
    sigP <- ifelse(vector<=netFDRThr,1,0)
    return(sigP)
}



.findBestNeighbor <- function(corrList,rankBest){
    
    corrList <- corrList[corrList!=0]
    
    if(length(corrList)==0){
        return(NULL)
    }else{
    
        if(length(corrList)<rankBest){
            return(list(names(corrList)))
        }else{
            corrList <- sort(corrList,decreasing=T)
            return(list(names(corrList)[1:rankBest]))
        }
    }
}

.calculateNANum <- function(vector){
    return(sum(is.na(vector))/length(vector))
}

.getClass <- function(obj) {
   cls <- class(obj)
   return(cls[1])
}

NetSAM <- function(inputNetwork, outputFileName, outputFormat="nsm", edgeType="unweighted", map_to_genesymbol=FALSE, organism="hsapiens", idType="auto", minModule=0.003, stepIte=FALSE, maxStep=4, moduleSigMethod="cutoff", modularityThr=0.2, ZRanNum=10, PerRanNum=100, ranSig=0.05, edgeThr=(-1), nodeThr=(-1), nThreads=3){
  organisms <- c("hsapiens","mmusculus","rnorvegicus","drerio","celegans","scerevisiae","cfamiliaris","dmelanogaster","athaliana")
  names(organisms) <- c("Hs","Mm","Rn","Dr","Ce","Sc","Cf","Dm","At")

  if(length(which(organisms==organism))==0){
    stop("Currently, the package supports the following nine organisms: hsapiens, mmusculus, rnorvegicus, drerio, celegans, scerevisiae, cfamiliaris, dmelanogaster and athaliana!")
  }

  if(missing(inputNetwork)){
    stop("Please input the network!\n")
  }

  #load Network
  if(.getClass(inputNetwork)=="character"){
    if(file_ext(inputNetwork)!="net"){
      stop("The extension of the input file should be 'net'!\n")
    }else{
      network <- read_graph_ncol(inputNetwork)
      if(edgeType=="weighted"){
        if(is.null(E(network)$weight)){
          stop("The input network does not contain edge weights. Please add the edge weights or change parameter 'edgeType' to 'unweigthed'!")
        }
      }else{
        if(!is.null(E(network)$weight)){
          stop("The input network contains edge weights. Please remove the edge weights or change parameter 'edgeType' to 'weigthed'!")
        }
      }
    }
  }else{
    if(.getClass(inputNetwork)=="data.frame" || .getClass(inputNetwork)=="matrix"){
      if(edgeType=="weighted"){
        if(ncol(inputNetwork)!=3){
          stop("Data object should contain three columns: interactor1, interactor2 and edge weight!")
        }else{
          weight <- inputNetwork[,3]
          if(!is.numeric(weight)){
            stop("The edge weight should be numeric!")
          }else{
            inputNetwork <- as.matrix(inputNetwork[,c(1,2)])
            inputNetwork_S <- as.character(inputNetwork)
            inputNetwork_S <- array(inputNetwork_S,dim=dim(inputNetwork))
            network <- graph.edgelist(inputNetwork_S,directed=F)
            E(network)$weight <- weight
          }
        }
      }else{
        if(ncol(inputNetwork)!=2){
          stop("data object should contain two columns!\n");
        }else{
          inputNetwork <- as.matrix(inputNetwork)
          inputNetwork_S <- as.character(inputNetwork)
          inputNetwork_S <- array(inputNetwork_S,dim=dim(inputNetwork))
          network <- graph.edgelist(inputNetwork_S,directed=F)
        }
      }
      rm(inputNetwork,inputNetwork_S)
      gc()
    }else{
      if(.getClass(inputNetwork)=="igraph"){
        if(edgeType=="unweighted"){
          if(!is.null(E(inputNetwork)$weight)){
            stop("The input network contains edge weights. Please remove the edge weights or change parameter 'edgeType' to 'weigthed'!")
          }else{
            network <- inputNetwork
          }
        }else{
          if(is.null(E(inputNetwork)$weight)){
            stop("The input network does not contain edge weights. Please add the edge weights or change parameter 'edgeType' to 'unweigthed'!")
          }else{
            network <- inputNetwork
          }
        }
        rm(inputNetwork)
        gc()
      }else{
        if(.getClass(inputNetwork)=="graphNEL"){
          network <- igraph.from.graphNEL(inputNetwork)
          if(edgeType=="unweighted"){
            if(!is.null(E(network)$weight)){
              stop("The input network contains edge weights. Please remove the edge weights or change parameter 'edgeType' to 'weigthed'!")
            }
          }else{
            if(is.null(E(network)$weight)){
              stop("The input network does not contain edge weights. Please add the edge weights or change parameter 'edgeType' to 'unweigthed'!")
            }
          }
          rm(inputNetwork)
          gc()
        }else{
          stop("The input network should be from a file or a data object with data.frame, matrix, graphNEL or igraph class. Other types of input are invalid!\n")
        }

      }
    }
  }

  if(outputFormat != "none" && missing(outputFileName)){
    stop("Please input the output file name!\n")
  }else{
    if(substr(outputFileName,nchar(outputFileName),nchar(outputFileName))=="/"){
      stop("Please input the output file name!\n")
    }
  }

  if(!(outputFormat %in% c("nsm","gmt","multiple","none"))){
    stop("The input 'outputFormat' is invalid! Please select an output format from 'nsm', 'gmt', 'multiple' and 'none'!\n")
  }

  if(!is.logical(map_to_genesymbol)){
    stop("The input 'map_to_genesymbol' is invalid! 'map_to_genesymbol' should only be TRUE or FALSE!\n")
  }

  if(!(organism %in% organisms)){
    stop("Currently, the package supports the following nine organisms: hsapiens, mmusculus, rnorvegicus, drerio, celegans, scerevisiae, cfamiliaris, dmelanogaster and athaliana!")
  }

  if(minModule<0 || minModule>0.2){
    stop("The input 'minModule' is invalid! 'minModule' should be between 0 and  0.2!\n")
  }

  if(maxStep<2 || .getClass(maxStep)!="numeric"){
    stop("The input 'maxStep' is invalid! 'maxStep' should be a number and larger than 2!\n")
  }

  if(!(moduleSigMethod %in% c("cutoff","zscore","permutation"))){
    stop("The input 'moduleSigMethod' is invalid! Please select an option from 'cutoff','zscore' and 'permutation'!\n")
  }

  if(modularityThr>1 || modularityThr<0 || .getClass(modularityThr)!="numeric"){
    stop("The input 'modularityThr' is invalid! 'modularityThr' should be a positive number and less than 1!\n")
  }

  if(ZRanNum<10 || .getClass(ZRanNum)!="numeric"){
    stop("The input 'ZRanNum' is invalid! 'ZRanNum' should be a number and larger than 10!\n")
  }

  if(PerRanNum<10 || .getClass(PerRanNum)!="numeric"){
    stop("The input 'PerRanNum' is invalid! 'PerRanNum' should be a number and larger than 10!\n")
  }

  if(ranSig>1 || ranSig <0 || .getClass(ranSig)!="numeric"){
    stop("The input 'ranSig' is invalid! 'ranSig' should be a positive number and less than 1!\n")
  }

  if(edgeThr<(-1) || .getClass(edgeThr)!="numeric"){
    stop("The input 'edgeThr' is invalid! 'edgeThr' should be -1 or a positive number!\n")
  }

  if(nodeThr<(-1) || .getClass(nodeThr)!="numeric"){
    stop("The input 'nodeThr' is invalid! 'nodeThr' should be -1 or a positive number!\n")
  }

  if(nThreads<1 || .getClass(nThreads)!="numeric"){
    stop("The input 'nThreads' is invalid! 'nThreads' should be a number and greater than 1!\n")
  }

  if(!is.simple(network)){
    warning("The input network contain loop or multiple edges. For unweighted network, NetSAM will remove loop or multiple edges. For weighted network, NetSAM will sum the weights from loop or multiple edges!!!")
    network <- simplify(network)
  }

  if(nodeThr!=(-1)){
    if(vcount(network)>nodeThr){
      stop("The number of nodes in the network is over the threshold ",nodeThr,". Please adjust the parameters to decrease the network size!\n")
    }
  }

  if(edgeThr!=(-1)){
    if(ecount(network)>edgeThr){
      stop("The number of edges in the network is over the threshold ",edgeThr,". Please adjust the parameters to decrease the network size!\n")
    }
  }


  ###################Get the whole gene symbols for the given organism###################
  if(organism=="scerevisiae"){
    #require("org.Sc.sgd.db") || stop("package org.Sc.sgd.db is required!!\n")
    genesymbol <- keys(eval(parse(text="org.Sc.sgd.db::org.Sc.sgdCOMMON2ORF")))
  }else{
    if(organism=="athaliana"){
      #require("org.At.tair.db") || stop("package org.At.tair.db is required!!\n")
      genesymbol <- unlist(as.list(eval(parse(text="org.At.tair.db::org.At.tairSYMBOL"))))
      names(genesymbol) <- NULL
      genesymbol <- unique(genesymbol)
      genesymbol <- genesymbol[!is.na(genesymbol)]
    }else{
      or <- names(organisms)[which(organisms==organism)]
      #require(paste("org.",or,".eg.db",sep=""),character.only = TRUE) || stop(paste("package org.", or, ".eg.db is required!!\n", sep=""))
      genesymbol <- keys(eval(parse(text=paste("org.",or,".eg.db::","org.",or,".egSYMBOL2EG",sep=""))))
    }
  }
  ########################################################################################

  geneid <- V(network)$name

  is.genesymbol <- FALSE
  if(length(intersect(geneid,genesymbol))>0.6*length(geneid)){
    is.genesymbol <- TRUE
  }else{
    is.genesymbol <- FALSE
  }

  mapping.status <- 0

  if(map_to_genesymbol==TRUE){
    ne <- mapToSymbol(inputData=network,organism=organism,inputType="network",idType=idType, edgeType=edgeType, verbose=TRUE)
    if(!is.null(ne)){
      network_edgelist <- ne$network
      netMat <- as.matrix(network_edgelist[,c(1,2)])
      network <- graph.edgelist(netMat,directed=FALSE)
      if(edgeType=="weighted"){
        E(network)$weight <- network_edgelist[,3]
      }
      mapping.status <- 0
    }else{
      stop("Please check the parameter 'idType' or set the parameter 'map_to_genesymbol' as FALSE!\n")
    }
  }else{
    if(is.genesymbol==TRUE){
      mapping.status <- 0
    }else{
      if(idType==""){     #NONE OF THE ABOVE
        mapping.status <- 1
      }else{
        ne <- mapToSymbol(inputData=network,organism=organism,inputType="network",idType=idType,edgeType=edgeType,verbose=FALSE)
        if(!is.null(ne)){
          idmap <- ne$idmap
          mapping.status <- 2
        }else{
          mapping.status <- 1
        }
      }
    }
  }

  minModule <- round(vcount(network)*minModule)
  if(minModule<5){
    minModule <- 5
  }

  allowWGCNAThreads(nThreads=nThreads)
  threNum <- WGCNAnThreads()
  if(threNum>nThreads){
    threNum <- nThreads
  }

  network_module <- .identifyModule(network,minModule,stepIte,maxStep,moduleSigMethod,modularityThr,ZRanNum,PerRanNum,ranSig,threNum,edgeType)
  geneorder <- network_module$geneorder
  disableWGCNAThreads()

  if(outputFormat=="nsm" || outputFormat=="none" || outputFormat=="multiple"){

    network_edges <- get.edgelist(network)
    if(edgeType=="weighted"){
      if(ecount(network)>500000){
        warning("The input weighted network contain over 500,000 edges. Because nsm file contains edge information, remaining all edges of the network will cause a very large size of nsm file, which will be difficult to upload to NetGestalt. NetSAM only remains top 500,000 edges based on the edge weights from largest to smallest!!\n")
        w <- E(network)$weight
        w <- order(w,decreasing=T)
        network_edges <- network_edges[w,]
        network_edges <- network_edges[1:500000,]
      }
    }

    hmiFile <- .createHMIFile(network_module$allHir,geneorder)

    rownames(geneorder) <- geneorder[,4]
    netgestalt <- list(rulfile=geneorder,hmifile=hmiFile,network=network_edges)

    if(outputFormat=="multiple"){
      outputFile <- paste(outputFileName,"_rulerfile.rul",sep="")
      write.table(geneorder,file=outputFile,row.names=F,col.names=T,sep="\t",quote=F)

      outputFile <- paste(outputFileName,"_hmifile.hmi",sep="")
      write.table(hmiFile,file=outputFile,row.names=F,col.names=T,sep="\t",quote=F)

      outputFile <- paste(outputFileName,"_network.net",sep="")
      write.table(network_edges,file=outputFile,row.names=F,col.names=F,sep="\t",quote=F)

    }

    if(outputFormat=="nsm"){
      outputFile <- paste(outputFileName,".nsm",sep="")
      note <- "##  Ruler file  ##"
      write.table(note,file=outputFile,row.names=F,col.names=F,quote=F)
      suppressWarnings(write.table(geneorder,file=outputFile,row.names=F,col.names=T,append=T,quote=F,sep="\t"))
      note <- "##  HMI file ##"
      write.table(note,file=outputFile,row.names=F,col.names=F,quote=F,append=T)
      suppressWarnings(write.table(hmiFile,file=outputFile,row.names=F,col.names=T,quote=F,append=T,sep="\t"))
      note <- "##  Network file  ##"
      write.table(note,file=outputFile,row.names=F,col.names=F,quote=F,append=T)
      write.table(network_edges,file=outputFile,row.names=F,col.names=F,quote=F,append=T,sep="\t")

      netgestalt$mapping.status <- mapping.status

      note <- "##  Mapping Status  ##"
      write.table(note,file=outputFile,row.names=F,col.names=F,quote=F,append=T)
      suppressWarnings(write.table(paste("mapping.status=",mapping.status,sep=""),file=outputFile,row.names=F,col.names=F,quote=F,append=T,sep="\t"))


      if(mapping.status==2){
        note <- "##  Gene Annotation  ##"
        write.table(note,file=outputFile,row.names=F,col.names=F,quote=F,append=T)
        suppressWarnings(write.table(idmap,file=outputFile,row.names=F,col.names=T,quote=F,append=T,sep="\t"))
        netgestalt$geneAnn <- idmap
      }

    }

    cat("NetSAM identified ",(nrow(hmiFile)-1)," modules in ",(length(unique(hmiFile[,2]))-1)," levels!\n",sep="")
    cat("Processing completed!\n\n")
    return(netgestalt)


  }else{
    hmiFile <- .createHMIFile(network_module$allHir,geneorder)
    gmtFile <- .createGMTFile(hmiFile,geneorder)
    outputFile1 <- paste(outputFileName,".gmt",sep="")
    write.table(gmtFile,file=outputFile1,row.names=F,col.names=F,sep="\t",quote=F)
    result <- gmtFile
    cat("NetSAM identified ",(nrow(hmiFile)-1)," modules in ",(length(unique(hmiFile[,2]))-1)," levels!\n",sep="")
    cat("Processing completed!\n\n")
    return(result)
  }

}


.identifyModule <- function(network, minModule, stepIte, maxStep, moduleSigMethod, modularityThr, ZRanNum, PerRanNum, ranSig, threNum, edgeType){

  cat("\nIdentifying the hierarchical modules of the network...\n")
  overlap_genesymbol_networkP <- V(network)$name
  subnetworkInfo <- list()
  subnetworkInfo_index <- 1
  network_cluster <- clusters(network)
  network_cluster_size <- network_cluster$csize

  if(length(network_cluster_size[network_cluster_size>=minModule])==0){
    stop("The size of all subnetworks are less than ",minModule,". Please adjust the parameter 'minModule'!\n\n")
  }

  network_cluster_size <- data.frame(id=c(1:length(network_cluster_size)),cluster_size=network_cluster_size,stringsAsFactors=F)
  network_cluster_size <- network_cluster_size[order(-network_cluster_size[,2]),]
  network_cluster_membership <- network_cluster$membership

  network_ordered_node <- vector()
  subnetwork_id <- 1
  for(i in c(1:nrow(network_cluster_size))){
    sub_network_size <- network_cluster_size[i,2]
    if(sub_network_size>=minModule){
      cat("Starting to analysis connected component ",subnetwork_id,"!\n",sep="")
      subnetwork_id <- subnetwork_id+1
      subnetwork_node <- overlap_genesymbol_networkP[which(network_cluster_membership==network_cluster_size[i,1])]
      subnetwork <- .extractSubNetwork(network,subnetwork_node,edgeType)
      allHir <- .identifyHierOr(subnetwork, minModule, stepIte, maxStep, moduleSigMethod, modularityThr, ZRanNum, PerRanNum, ranSig, threNum, edgeType)
      subnetworkInfo[[subnetworkInfo_index]] <- allHir
      subnetworkInfo_index <- subnetworkInfo_index+1
      network_ordered_node <- c(network_ordered_node,subnetwork_node)
      cat("\n")
    }
  }
  cat("\nReordering the genes in the one dimentional layout...\n")
  geneorder <- data.frame(ruler_id=c(1:length(overlap_genesymbol_networkP)),node_type="Gene",node_db="Entrez Gene",node_db_id=overlap_genesymbol_networkP,node_name=overlap_genesymbol_networkP,stringsAsFactors=F)
  rownames(geneorder) <- overlap_genesymbol_networkP
  unann_node <- setdiff(overlap_genesymbol_networkP,network_ordered_node)
  if(length(unann_node) !=0){
    network_ordered_node <- c(network_ordered_node,unann_node)
  }
  geneorder <- geneorder[network_ordered_node,]


  geneorder <- .orderDiffLevel(subnetworkInfo,geneorder)

  result <- list(network=network,allHir=subnetworkInfo,geneorder=geneorder)
  return(result)
}


.calculateRandomWalkerAdjectMatrix <- function(network_igraph,step,edgeType){

  #calculate the random walk distance for the network
  protein_in_ppi <- V(network_igraph)$name
  if(edgeType=="unweighted"){
    E(network_igraph)$weight <- rep(1,ecount(network_igraph))
  }

  nweight <- graph.strength(network_igraph,mode="all")
  V(network_igraph)$weight <- as.numeric(nweight)


  eweight <- E(network_igraph)$weight

  degree_node <- igraph::degree(network_igraph)
  network_igraph <- add.edges(network_igraph,rbind(protein_in_ppi,protein_in_ppi)) #walktrap algorithm adds all self interactions for each node
  E(network_igraph)$weight <- c(eweight,V(network_igraph)$weight/degree_node)
  V(network_igraph)$weight <- V(network_igraph)$weight+ V(network_igraph)$weight/degree_node

  nweight <- V(network_igraph)$weight

  adjMatrix <- get.adjacency(network_igraph,attr="weight")
  adjMatrix <- as.matrix(adjMatrix)

  W_weighted <- adjMatrix/nweight

  rm(adjMatrix,network_igraph,eweight,degree_node)
  gc()

  #cat("Create transition Matrix...\n")

  tranM <- W_weighted

  if(step>1){
    for(i in c(1:(step-1))){
      tranM <- tranM%*%W_weighted
    }
  }

  rm(W_weighted)
  gc()

  #tranM <- as.matrix(tranM)

  tranM <- t(tranM)/sqrt(nweight)
  tranM <- t(tranM)

  #cat("Calculate EU distance...\n")

  smat <- apply(tranM,1,crossprod)
  mat1 <- matrix(smat,nrow=length(protein_in_ppi),ncol=length(protein_in_ppi))
  mat3 <- tcrossprod(tranM)
  mat4 <- mat1+t(mat1)-2*mat3
  rm(smat,mat1,mat3,tranM)
  gc()
  mat4[mat4<0] <- 0
  diag(mat4) <- 0
  mat4 <- sqrt(mat4)

  return(mat4)
}


.transformFromWalktrapToHclust <- function(walktrap){

  #transform walktrap to hclust

  merge <- walktrap$merges
  name <- walktrap$names
  N <- length(name)

  merge[which(merge[,1]<=N),1] <- (-merge[which(merge[,1]<=N),1])
  merge[which(merge[,2]<=N),2] <- (-merge[which(merge[,2]<=N),2])

  merge[which(merge[,1]>N),1] <- (merge[which(merge[,1]>N),1]-N)
  merge[which(merge[,2]>N),2] <- (merge[which(merge[,2]>N),2]-N)

  height <- c(1:(N-1))

  dend <- as.dendrogram(walktrap)
  order <- order.dendrogram(dend)

  labels <- name

  ht <- list(merge=merge,height=height,order=order,labels=labels,method="walktrap",call=match.call(),dist.method="randomwalk")

  class(ht) <- "hclust"

  return(ht)
}

.walktrapcommunity <- function(network_igraph,steps,edgeType){
  if(edgeType=="weighted"){
    network_walktrap <- walktrap.community(network_igraph,weights=E(network_igraph)$weight,steps=steps)
  }else{
    network_walktrap <- walktrap.community(network_igraph,steps=steps)
  }
  return(network_walktrap)
}

.evaluateWalktrapStep <- function(network_igraph,stepIte,maxStep,level,threNum,edgeType,subM){

  #evaluate the optimal Step for the network

  if(stepIte==FALSE || maxStep==2 || level==1){
    network_walktrap <- .walktrapcommunity(network_igraph,steps=maxStep,edgeType)
    network_adjMatrix <- .calculateRandomWalkerAdjectMatrix(network_igraph,maxStep,edgeType)
    rm(network_igraph)
    gc()
    network_adjMatrix <- as.dist(network_adjMatrix)
    network_hclust <- .transformFromWalktrapToHclust(network_walktrap)
    network_order <- seriate(network_adjMatrix,method="OLO",control=list(hclust=network_hclust))
    network_order <- get_order(network_order)
    network_info <- list(gene=network_walktrap$names,membership=network_walktrap$membership,modularity=max(network_walktrap$modularity),step=maxStep,order=network_order,level=level)
    return(network_info)
  }else{

    if(maxStep < threNum){
      threNum <- maxStep
      perN <- 1
    }else{
      perN <- floor((maxStep-1)/threNum)
    }


    cl <- makeCluster(threNum)
    registerDoParallel(cl)


    i <- 1
    optimalM <- foreach(i=1:threNum, .packages="igraph") %dopar% {
      finalStep <- data.frame(step=0,modularity=1,stringsAsFactors=F)
      fi <- 1
      if(i==1){
        step_start <- 2
        step_end <- i*perN+1
      }else{
        step_start <- i*perN-(perN-2)
        if(i==threNum){
          step_end <- maxStep
        }else{
          step_end <- i*perN+1
        }
      }
      for(j in c(step_start:step_end)){
        if(edgeType=="weighted"){
          w <- walktrap.community(network_igraph,weights=E(network_igraph)$weight,steps=j)
        }else{
          w <- walktrap.community(network_igraph,steps=j)
        }
        m <- max(w$modularity)
        finalStep[fi,1] <- j
        finalStep[fi,2] <- m
        fi <- fi + 1
      }

      return(finalStep)
    }
    stopCluster(cl)

    finalStep <- data.frame(step=0,modularity=1,stringsAsFactors=F)
    for(i in c(1:length(optimalM))){
      finalStep <- rbind(finalStep,optimalM[[i]])
    }
    finalStep <- finalStep[finalStep[,1]!=0,]
    finalStep <- finalStep[order(-finalStep[,2],finalStep[,1]),]

    optimalStep <- finalStep[1,1]
    cat("The optimal Step of network ",subM," is ",optimalStep," !\n",sep="")

    optimalwalktrap <- .walktrapcommunity(network_igraph,steps=optimalStep,edgeType)
    network_adjMatrix <- .calculateRandomWalkerAdjectMatrix(network_igraph,optimalStep,edgeType)
    rm(network_igraph)
    gc()
    network_adjMatrix <- as.dist(network_adjMatrix)
    network_hclust <- .transformFromWalktrapToHclust(optimalwalktrap)
    network_order <- seriate(network_adjMatrix,method="OLO",control=list(hclust=network_hclust))
    network_order <- get_order(network_order)
    maxWalktrap <- list(gene=optimalwalktrap$names,membership=optimalwalktrap$membership,modularity=max(optimalwalktrap$modularity),step=optimalStep,order=network_order,level=level)
    return(maxWalktrap)
  }
}


.identifySig_Unweighted <- function(network_igraph,network_modularity,step,moduleSigMethod,modularityThr, ZRanNum, PerRanNum, ranSig, threNum){

  #identify whether the network can be separated again

  degree <- igraph::degree(network_igraph)
  sig <- 0
  i <- 1

  if(moduleSigMethod=="cutoff"){
    if(network_modularity>modularityThr){
      sig <- 1
    }
  }

  if(moduleSigMethod=="zscore"){

    if(ZRanNum<threNum){
      threNum <- ZRanNum
      perN <- 1
    }else{
      perN <- floor(ZRanNum/threNum)
    }


    cl <- makeCluster(threNum)
    registerDoParallel(cl)

    ranmodu <- foreach(i=1:threNum, .combine="c", .packages="igraph") %dopar%{

      randomM <- c()

      rN <- perN
      if(i==threNum){
        rN <- ZRanNum-(i-1)*perN
      }

      for(j in c(1:rN)){
        suppressWarnings(rannet <- degree.sequence.game(degree,method="vl"))
        ran_walktrap <- walktrap.community(rannet,steps=step)
        ranModularity <- max(ran_walktrap$modularity)
        randomM <- c(randomM,ranModularity)
      }
      return(randomM)
    }
    stopCluster(cl)

    ranmodu_mean <- mean(ranmodu)
    ranmodu_sd <- sd(ranmodu)
    if(ranmodu_sd == 0){
      if(network_modularity>ranmodu_mean){
        sig <- 1
      }
    }else{
      Z_network_modularity <- (network_modularity-ranmodu_mean)/ranmodu_sd
      p <- pnorm(Z_network_modularity,mean=0,sd=1,lower.tail=F)
      if(p<ranSig){
        sig <- 1
      }
    }
  }

  if(moduleSigMethod=="permutation"){

    if(PerRanNum<threNum){
      threNum <- PerRanNum
      perN <- 1
    }else{
      perN <- floor(PerRanNum/threNum)
    }


    cl <- makeCluster(threNum)
    registerDoParallel(cl)

    ranmodu <- foreach(i=1:threNum, .combine="c", .packages="igraph") %dopar%{

      randomM <- c()

      rN <- perN
      if(i==threNum){
        rN <- PerRanNum-(i-1)*perN
      }

      for(j in c(1:rN)){

        suppressWarnings(rannet <- degree.sequence.game(degree,method="vl"))
        ran_walktrap <- walktrap.community(rannet,steps=step)
        ranModularity <- max(ran_walktrap$modularity)
        randomM <- c(randomM,ranModularity)
      }
      return(randomM)
    }
    stopCluster(cl)

    p <- length(ranmodu[ranmodu>=network_modularity])/PerRanNum
    if(p<ranSig){
      sig <- 1
    }
  }

  return(sig)
}


.identifySig_Weighted <- function(network_igraph, network_modularity, step, moduleSigMethod, modularityThr, ZRanNum, PerRanNum, ranSig, threNum){

  #identify whether the network can be separated again


  sig <- 0
  i <- 1
  if(moduleSigMethod=="cutoff"){
    if(network_modularity>modularityThr){
      sig <- 1
    }
  }

  if(moduleSigMethod=="zscore"){

    #network_igraph <- network_info$network
    weight <- E(network_igraph)$weight
    #ranmodu <- vector()
    #step <- network_info$step

    if(ZRanNum<threNum){
      threNum <- ZRanNum
      perN <- 1
    }else{
      perN <- floor(ZRanNum/threNum)
    }

    cl <- makeCluster(threNum)
    registerDoParallel(cl)

    ranmodu <- foreach(i=1:threNum, .combine="c", .packages="igraph") %dopar%{

      randomM <- c()

      rN <- perN
      if(i==threNum){
        rN <- ZRanNum-(i-1)*perN
      }

      for(j in c(1:rN)){

        ranWeight <- sample(weight,length(weight))
        ranModularity <- max(walktrap.community(network_igraph,weights=ranWeight,steps=step)$modularity)
        randomM <- c(randomM,ranModularity)
      }
      return(randomM)
    }
    stopCluster(cl)
    rm(network_igraph,weight)
    gc()
    #cat("randomMo:",ranmodu,"\n")
    ranmodu_mean <- mean(ranmodu)
    ranmodu_sd <- sd(ranmodu)
    if(ranmodu_sd == 0){
      if(network_modularity>ranmodu_mean){
        sig <- 1
      }
    }else{
      Z_network_modularity <- (network_modularity-ranmodu_mean)/ranmodu_sd
      p <- pnorm(Z_network_modularity,mean=0,sd=1,lower.tail=F)
      if(p<ranSig){
        sig <- 1
      }
    }
  }

  if(moduleSigMethod=="permutation"){

    #network_igraph <- network_info$network
    weight <- E(network_igraph)$weight
    #step <- network_info$step

    if(PerRanNum<threNum){
      threNum <- PerRanNum
      perN <- 1
    }else{
      perN <- floor(PerRanNum/threNum)
    }

    cl <- makeCluster(threNum)
    registerDoParallel(cl)

    ranmodu <- foreach(i=1:threNum, .combine="c", .packages="igraph") %dopar%{

      randomM <- c()

      rN <- perN
      if(i==threNum){
        rN <- PerRanNum-(i-1)*perN
      }

      for(j in c(1:rN)){

        ranWeight <- sample(weight,length(weight))
        ranModularity <- max(walktrap.community(network_igraph,weights=ranWeight,steps=step)$modularity)
        randomM <- c(randomM,ranModularity)
      }
      return(randomM)
    }
    stopCluster(cl)
    rm(network_igraph,weight)
    gc()

    p <- length(ranmodu[ranmodu>=network_modularity])/PerRanNum
    if(p<ranSig){
      sig <- 1
    }
  }

  return(sig)
}


.identifySig <- function(network_igraph, network_modularity, step, moduleSigMethod, modularityThr, ZRanNum, PerRanNum, ranSig, threNum, edgeType){
  if(edgeType=="weighted"){
    sig <- .identifySig_Weighted(network_igraph, network_modularity, step, moduleSigMethod, modularityThr, ZRanNum, PerRanNum, ranSig, threNum)
  }else{
    sig <- .identifySig_Unweighted(network_igraph, network_modularity, step, moduleSigMethod, modularityThr, ZRanNum, PerRanNum, ranSig, threNum)
  }

  return(sig)
}


.identifyHierOr <- function(network_maxComponent, minModule, stepIte, maxStep, moduleSigMethod, modularityThr, ZRanNum, PerRanNum, ranSig, threNum, edgeType){

  #identify hierarchical organization of network

  allHir <- list()
  ai <- 1
  sigHir <- vector()
  si <- 1

  start <- 1

  cat("Evaluating networks in Level 1 ...\n")

  levelid <- 2

  network_info <- .evaluateWalktrapStep(network_maxComponent, stepIte, maxStep, level=1, threNum, edgeType, subM=1)
  cat("Network modularity: ",network_info$modularity,"\n\n",sep="")

  network_sig <- .identifySig(network_maxComponent, network_info$modularity, network_info$step, moduleSigMethod, modularityThr, ZRanNum, PerRanNum, ranSig, threNum, edgeType)

  allHir[[ai]] <- network_info
  rm(network_info)
  gc()


  if(network_sig==1){
    sigHir <- c(sigHir,ai)
    si <- si+1
  }

  ai <- ai+1

  while(length(sigHir)>0 && start!=si){
    currentPos <- sigHir[start]
    currentNetwork <- allHir[[currentPos]]
    start <- start+1

    currentNetwork_level <- currentNetwork$level
    currentNetwork_node <- currentNetwork$gene

    currentNetwork_membership <- currentNetwork$membership
    currentNetwork_membership <- data.frame(node=currentNetwork_node,membership=currentNetwork_membership,stringsAsFactors=F)
    currentNetwork_membership_count <- tapply(currentNetwork_membership[,1],currentNetwork_membership[,2],length)
    currentNetwork_membership_count <- currentNetwork_membership_count[currentNetwork_membership_count>=minModule]

    if(length(currentNetwork_membership_count)==0){
      next
    }

    currentNetwork_membership_group <- as.integer(names(currentNetwork_membership_count))
    rm(currentNetwork_membership_count,currentNetwork_node)
    gc()

    subLevel <- currentNetwork_level+1
    if(subLevel==levelid){
      cat("Evaluating networks in Level ",levelid," ...\n",sep="")
      levelid <- levelid+1
      subM <- 1
    }
    for(i in c(1:length(currentNetwork_membership_group))){
      subnetwork_node <- currentNetwork_membership[currentNetwork_membership[,2]==currentNetwork_membership_group[i],1]
      subnetwork_igraph <- .extractSubNetwork(network_maxComponent,subnetwork_node,edgeType)
      subnetwork_info <- .evaluateWalktrapStep(subnetwork_igraph, stepIte, maxStep, subLevel, threNum, edgeType, subM)
      cat("Modularity of network ",subM,": ",subnetwork_info$modularity,"\n\n",sep="")
      subnetwork_sig <- .identifySig(subnetwork_igraph, subnetwork_info$modularity, subnetwork_info$step, moduleSigMethod, modularityThr, ZRanNum, PerRanNum, ranSig, threNum, edgeType)

      allHir[[ai]] <- subnetwork_info
      rm(subnetwork_node,subnetwork_igraph,subnetwork_info)
      gc()

      if(subnetwork_sig==1){
        sigHir <- c(sigHir,ai)
        si <- si+1
      }

      ai <- ai+1
      subM <- subM + 1
    }
  }

  return(allHir)
}


.orderDiffLevel <- function(subnetworkInfo,geneorder){

  #reorder all genes in the network according to the optimal position in each level

  for(l in c(1:length(subnetworkInfo))){
    allHir <- subnetworkInfo[[l]]

    for(i in c(1:length(allHir))){
      ori <- allHir[[i]]$order
      node <- allHir[[i]]$gene
      node <- node[ori]
      node <- data.frame(id=c(1:length(node)),name=node,stringsAsFactors=F)
      node <- node[order(node[,2]),]

      geneorder_subpos <- which(geneorder[,5] %in% node[,2])
      geneorder_sub <- geneorder[geneorder_subpos,]
      geneorder_sub <- geneorder_sub[order(geneorder_sub[,5]),]
      geneorder_sub <- cbind(geneorder_sub,node[,1])
      geneorder_sub <- geneorder_sub[order(geneorder_sub[,6]),]
      geneorder_sub <- geneorder_sub[,c(1:5)]
      geneorder[geneorder_subpos,] <- geneorder_sub

    }

  }
  geneorder[,1] <- c(1:nrow(geneorder))
  return(geneorder)
}

.createHMIFile <- function(subnetworkInfo,geneorder){
  #create HMI file
  hmiFile <- data.frame(best="N",level=0,order=1,name="ALL",start=1,end=nrow(geneorder),stringsAsFactors=F)
  hi <- 2
  for(l in c(1:length(subnetworkInfo))){
    allHir <- subnetworkInfo[[l]]
    for(i in c(1:length(allHir))){
      node <- allHir[[i]]$gene
      position <- which(geneorder[,5] %in% node)
      start <- min(position)
      end <- max(position)
      level <- allHir[[i]]$level
      if(level==2){
        best <- "Y"
      }else{
        best <- "N"
      }
      hmiFile[hi,1] <- best
      hmiFile[hi,2] <- level
      hmiFile[hi,3] <- 0
      hmiFile[hi,4] <- ""
      hmiFile[hi,5] <- start
      hmiFile[hi,6] <- end
      hi <- hi+1
    }
  }

  hmiFile <- hmiFile[order(hmiFile[,2],hmiFile[,5]),]
  allLevel <- sort(unique(hmiFile[,2]))
  for(i in c(1:length(allLevel))){
    position <- which(hmiFile[,2]==allLevel[i])
    start <- min(position)
    end <- max(position)
    hmiFile[start:end,3] <- c(1:(end-start+1))
  }
  hmiFile[,4] <- paste("Level",hmiFile[,2],"Module",hmiFile[,3],sep="_")
  return(hmiFile)
}


.createGMTFile <- function(hmiFile,geneorder){
  allgene <- geneorder[,4]
  allgene <- paste(allgene,collapse="\t")
  humancatfile <- data.frame(name="01",childnum=1,gene=allgene,start=1,end=nrow(geneorder),level=0,stringsAsFactors=F)

  for(i in c(2:nrow(hmiFile))){
    st <- hmiFile[i,5]
    en <- hmiFile[i,6]
    l <- hmiFile[i,2]
    for(j in c(1:nrow(humancatfile))){
      pl <- humancatfile[j,6]
      if(pl==(l-1)){
        ps <- humancatfile[j,4]
        pe <- humancatfile[j,5]
        if(st>=ps && en<=pe){
          pcu <- humancatfile[j,1]
          pcu_c <- humancatfile[j,2]
          if(pcu_c < 10){
            pcu_c <- paste("0",pcu_c,sep="")
          }else{
            pcu_c <- as.character(pcu_c)
          }

          c_cu <- paste(pcu,pcu_c,sep="-")
          humancatfile[j,2] <- humancatfile[j,2] + 1
          humancatfile[i,1] <- c_cu
          humancatfile[i,2] <- 1
          cg <- geneorder[c(st:en),4]
          cg <- paste(cg,collapse="\t")
          humancatfile[i,3] <- cg
          humancatfile[i,4] <- st
          humancatfile[i,5] <- en
          humancatfile[i,6] <- l
          break
        }
      }
    }
  }
  humancatfile[,7] <- humancatfile[,5]-humancatfile[,4]+1
  gmtFile <- humancatfile[,c(1,7,3)]
  return(gmtFile)
}


.extractSubNetwork <- function(network,subList,edgeType){
  if(edgeType=="unweighted"){
    x <- get.edgelist(network)
    x <- x[x[,1] %in% subList & x[,2] %in% subList,]
    network <- graph.edgelist(x,directed=F)
  }else{
    x <- get.edgelist(network)
    weight <- get.edge.attribute(network,"weight")
    ind <- which(x[,1] %in% subList & x[,2] %in% subList)
    x <- x[ind,]
    weight <- weight[ind]
    network <- graph.edgelist(x,directed=F)
    E(network)$weight <- weight
  }
  return(network)
}

featureAssociation <-
function(inputMat,sampleAnn,NetSAMOutput,outputHtmlFile,CONMethod="spearman",CATMethod="kruskal",BINMethod="ranktest",fdrmethod="BH",pth=0.05,collapse_mode="maxSD"){
    
    #require(WGCNA)
    #require(survival)
    #require(R2HTML)
    
   #if(missing(inputMat) || missing(sampleAnn) || sampleAnn==""){
   if(missing(inputMat) || missing(sampleAnn)){
        stop("Please input the data matrix and sample annotation file!\n")
    }

    re <- testFileFormat(inputMat=inputMat, sampleAnn=sampleAnn, collapse_mode=collapse_mode)
    inputMat <- re$inputMat
    sampleAnn <- re$sampleAnn
    
    
    if(length(which(CONMethod %in% c("pearson","spearman")))==0){
        stop("The input 'CONMethod' is invalid! Please select a method from 'pearson' and 'spearman'!\n")
    }
    
    if(length(which(CATMethod %in% c("anova","kruskal")))==0){
        stop("The input 'CATMethod' is invalid! Please select a method from 'anova' and 'kruskal'!\n")
    }
    
    if(length(which(BINMethod %in% c("ttest","ranktest")))==0){
        stop("The input 'BINMethod' is invalid! Please select a method from 'ttest' and 'ranktest'!\n")
    }
    
    if(is.null(NetSAMOutput$rulfile) || is.null(NetSAMOutput$hmifile)){
        stop("NetSAMOutput should be the output from NetSAM function, which contain rulfile, hmifile and network!\n")
    }
    
    if(length(which(collapse_mode %in% c("mean","median","maxSD","maxIQR","max","min")))==0){
        stop("The input 'collapse_mode' is not valide! Please select an option from 'mean', 'median', 'maxSD',  'maxIQR', 'max' and 'min' (use mean, median, max standard derivation, max interquartile range, maximum and minimum of duplicate genes for each sample)!\n")
    }

    
    if(sampleAnn[2,1]=="category"){
        sampleAnn <- sampleAnn[c(1,3:nrow(sampleAnn)),]
    }
    
    

    rule <- NetSAMOutput$rulfile
    hmi <- NetSAMOutput$hmifile
    
    
    if(length(setdiff(rule[,4],rownames(inputMat)))>0){
        stop("All ids in the 'NetSAMOutput' should be cotained in the row names of the input matrix!\n")
    }
    
    module_pc <- apply(hmi[2:nrow(hmi),],1,.prcomp_WGCNA,inputMat,rule)
    module_pc <- t(module_pc)
    rownames(module_pc) <- hmi[2:nrow(hmi),4]
    colnames(module_pc) <- colnames(inputMat)
    
    moduleInfo <-data.frame(moduleName="",featureName="",featureType="",method="",compare="",statistic="",direction=0,pvalue="",fdr="",stringsAsFactors=F)
    mi <- 1
    for(i in c(2:ncol(sampleAnn))){
        
        featureName <- colnames(sampleAnn)[i]
        sampleInfo <- sampleAnn[,i]
        sampleType <- sampleInfo[1]
        sampleInfo <- sampleInfo[2:length(sampleInfo)]
        com <- ""
        sig <- ""
        method <- ""
        if(sampleType=="BIN"){
            re <- .BINTest(module_pc,sampleInfo,BINMethod,fdrmethod,pth)
            method <- BINMethod
            if(!is.null(re)){
                com <- re$dir
                sig <- re$module_sig
            }
        }
        if(sampleType=="CAT"){
            re <- .CATTest(module_pc,sampleInfo,CATMethod,fdrmethod,pth)
            method <- CATMethod
            if(!is.null(re)){
                com <- re$dir
                sig <- re$module_sig
            }

        }
        
        if(sampleType=="CON"){
            sampleInfo <- as.numeric(sampleInfo)
            re <- .CONTest(module_pc,sampleInfo,CONMethod,fdrmethod,pth)
            method <- CONMethod
            if(!is.null(re)){
                com <- ""
                sig <- re
            }
        }
        if(sampleType=="SUR"){
            re <- .SURTest(module_pc,sampleInfo,fdrmethod,pth)
            method <- "Cox model"
            if(!is.null(re)){
                com <- ""
                sig <- re
            }
            
        }
        if(!is.null(nrow(sig))){
            moduleInfo[c(mi:(mi+nrow(sig)-1)),1] <- rownames(sig)
            moduleInfo[c(mi:(mi+nrow(sig)-1)),2] <- rep(featureName,nrow(sig))
            moduleInfo[c(mi:(mi+nrow(sig)-1)),3] <- rep(sampleType,nrow(sig))
            moduleInfo[c(mi:(mi+nrow(sig)-1)),4] <- rep(method,nrow(sig))
            moduleInfo[c(mi:(mi+nrow(sig)-1)),5] <- rep(com,nrow(sig))
            moduleInfo[c(mi:(mi+nrow(sig)-1)),6] <- format(sig[,1],scientific=TRUE, digits=3)
            moduleInfo[c(mi:(mi+nrow(sig)-1)),7] <- sig[,2]
            moduleInfo[c(mi:(mi+nrow(sig)-1)),8] <- format(sig[,3],scientific=TRUE, digits=3)
            moduleInfo[c(mi:(mi+nrow(sig)-1)),9] <- format(sig[,4],scientific=TRUE, digits=3)
            mi <- mi + nrow(sig)
        }
    }
    
    if(moduleInfo[1,1]!=""){
        .createHTML_feature(outputHtmlFile,moduleInfo,pth)
        cat("The assocaitaions between modules and features can be found at ",outputHtmlFile,".html!\n",sep="")
        return (moduleInfo)
    }else{
        cat("There is no assocation between modules and features!\n")
        return(NULL)
    }

}



.prcomp_WGCNA <- function(hmivector,exp,rulef) {
    
    st <- as.numeric(hmivector[5])
    en <- as.numeric(hmivector[6])
    ge <- rulef[st:en,4]
    
    module_exp <- exp[ge,]
    
    col <- rep("black",nrow(module_exp))
    pc <- moduleEigengenes(t(module_exp),col)
    pc <- pc$eigengenes
    
    pc <- as.vector(as.matrix(pc))
    return(pc)
}

.BINTest <- function(module_pc,sampleInfo,method,fdrmethod,pth){
    
    sampleInfo_in <- which(!is.na(sampleInfo))
    sampleInfo <- sampleInfo[sampleInfo_in]
    module_pc_f <- module_pc[,sampleInfo_in]
    
    sampleD <- unique(sampleInfo)
    dir <- paste(sampleD[1],"/",sampleD[2],sep="")
    
    in1 <- which(sampleInfo==sampleD[1])
    in2 <- which(sampleInfo==sampleD[2])
    
    module_sta <- apply(module_pc_f,1,.BINTest_single,in1,in2,method)
    module_sta <- t(module_sta)
    fdrp <- p.adjust(module_sta[,3],method=fdrmethod)
    module_sta <- data.frame(statistic=module_sta[,1],direction=module_sta[,2],pvalue=module_sta[,3],fdr=fdrp,stringsAsFactors=F)
    module_sta_sig <- module_sta[module_sta[,3]<pth,]
    if(nrow(module_sta_sig)>0){
        re <- list(module_sig=module_sta_sig,dir=dir)
        return(re)
    }else{
        return(NULL)
    }
}

.BINTest_single <- function(module_pc_vector,in1,in2,method){
    if(method=="ttest"){
        t <- t.test(module_pc_vector[in1],module_pc_vector[in2])
        statistic <- t$statistic
        direction <- sign(statistic)
        pv <- t$p.value
    }
    if(method=="ranktest"){
        r <- wilcox.test(module_pc_vector[in1],module_pc_vector[in2])
        statistic <- r$statistic
        direction <- ifelse(mean(module_pc_vector[in1])>=mean(module_pc_vector[in2]),1,-1)
        pv <- r$p.value
    }

    re <- c(statistic,direction,pv)
    return(re)

}


.CATTest <- function(module_pc,sampleInfo,method,fdrmethod,pth){
    sampleInfo_in <- which(!is.na(sampleInfo))
    sampleInfo <- sampleInfo[sampleInfo_in]
    module_pc_f <- module_pc[,sampleInfo_in]
    
    sampleD <- unique(sampleInfo)
    if(length(sampleD)<10){
        sampleD <- paste(sampleD,collapse="/")
    }else{
        sampleD <- length(sampleD)
    }
    
    module_sta <- apply(module_pc_f,1,.CATTest_single,sampleInfo,method)
    module_sta <- t(module_sta)
    mediansta <- median(module_sta[,1])
    
    dir <- sign(module_sta[,1]-mediansta)
    fdrp <- p.adjust(module_sta[,2],method=fdrmethod)
    module_sta <- data.frame(statistic=module_sta[,1],direction=dir,pvalue=module_sta[,2],fdr=fdrp,stringsAsFactors=F)
    module_sta_sig <- module_sta[module_sta[,3]<pth,]
    if(nrow(module_sta_sig)>0){
        re <- list(module_sig=module_sta_sig,dir=sampleD)
        return(re)
    }else{
        return(NULL)
    }
}


.CATTest_single <- function(module_pc_vector,group,method){
    
    data <- data.frame(pc=module_pc_vector,group=group)
    
    if(method=="anova"){
        a <- aov(pc ~ group, data=data)
        a <- summary(a)[[1]]
        pv <- a[["Pr(>F)"]][1]
        statistic <- a[["F value"]][1]
    }
    if(method=="kruskal"){
        k <- kruskal.test(pc ~ group,data=data)
        statistic <- k$statistic
        pv <- k$p.value
    }
    
    re <- c(statistic,pv)
    return(re)
    
}

.CONTest <- function(module_pc,sampleInfo,method,fdrmethod,pth){
    sampleInfo_in <- which(!is.na(sampleInfo))
    sampleInfo <- sampleInfo[sampleInfo_in]
    module_pc_f <- module_pc[,sampleInfo_in]
    
    sampleInfo <- as.numeric(sampleInfo)
    
    module_sta <- apply(module_pc_f,1,.CONTest_single,sampleInfo,method)
    module_sta <- t(module_sta)
    fdrp <- p.adjust(module_sta[,3],method=fdrmethod)
    module_sta <- data.frame(statistic=module_sta[,1],direction=module_sta[,2],pvalue=module_sta[,3],fdr=fdrp,stringsAsFactors=F)
    module_sta_sig <- module_sta[module_sta[,3]<pth,]
    if(nrow(module_sta_sig)>0){
        return(module_sta_sig)
    }else{
        return(NULL)
    }
}

.CONTest_single <- function(module_pc_vector,sampleInfo,method){
    c <- cor.test(module_pc_vector,sampleInfo,method=method)
    statistic <- c$estimate
    pv <- c$p.value
    direction <- sign(statistic)
    re <- c(statistic,direction,pv)
    return(re)
}


.SURTest <- function(module_pc,sampleInfo,fdrmethod,pth){
    sampleInfo <- strsplit(sampleInfo,",",fixed=TRUE)
    sampleInfo <- do.call(rbind,sampleInfo)
    time <- sampleInfo[,1]
    event <- sampleInfo[,2]
    time <- suppressWarnings(as.numeric(time))
    event <- suppressWarnings(as.numeric(event))
    time_in <- which(!is.na(time))
    time_f <- time[time_in]
    event_f <- event[time_in]
    module_pc_f <- module_pc[,time_in]
    
    module_sta <- apply(module_pc_f,1,.SURTest_single,time_f,event_f)
    module_sta <- t(module_sta)
    fdrp <- p.adjust(module_sta[,3],method=fdrmethod)
    module_sta <- data.frame(statistic=module_sta[,1],direction=module_sta[,2],pvalue=module_sta[,3],fdr=fdrp,stringsAsFactors=F)
    module_sta_sig <- module_sta[module_sta[,3]<pth,]
    if(nrow(module_sta_sig)>0){
        return(module_sta_sig)
    }else{
        return(NULL)
    }
    
}

.SURTest_single <- function(module_pc_vector,time,event){
    s <- coxph(Surv(time,event) ~ module_pc_vector)
    s <- summary(s)
    statistic <- s$coefficients[1]
    p_ll <- s$logtest[3]
    
    dir <- sign(statistic)
    re <- c(statistic,dir,p_ll)
    return(re)
}


.createHTML_feature <- function(outputHtmlFile,moduleInfo,pth){
    
    outputDir <- dirname(outputHtmlFile)
    htmlFileName <- basename(outputHtmlFile)
    
    target <- HTMLInitFile(outputDir, filename=htmlFileName, BackGroundColor="#BBBBEE")
    HTML(paste("<h2>The associated modules for each feature, p<",pth,"</h2>",sep=""), file=target)
    
    moduleInfo <- moduleInfo[order(moduleInfo[,2],moduleInfo[,8]),]
    
    features <- unique(moduleInfo[,2])
    
    de <- '<table><tr><th width="10%" align="left">Feature</th><th width="10%" align="left">Feature Type</th><th width="10%" align="left">Method</th><th width="20%" align="left">Compare</th><th width="15%" align="left">Module Name</th><th width="10%" align="center">Statistic</th><th width="5%" align="center">Direction</th><th width="10%" align="center">P Value</th><th width="10%" align="center">FDR</th></tr>'
    HTML(de, file=target)
    
    for(i in c(1:length(features))){
        info <- moduleInfo[moduleInfo[,2]==features[i],]
        de <- paste('<tr><td><a name="',info[1,2],'">',info[1,2],"</a></td><td>",info[1,3],"</td><td>",info[1,4],"</td><td>",info[1,5],'</td><td><a href="#',info[1,1],'">',info[1,1],'</a></td><td align="center">',info[1,6],'</td><td align="center">',info[1,7],'</td><td align="center">',info[1,8],'</td><td align="center">',info[1,9],'</td></tr>',sep="")
        HTML(de,file=target)
        if(nrow(info)>1){
            for(j in c(2:nrow(info))){
                de <- paste('<tr><td> </td><td> </td><td> </td><td> </td><td><a href="#',info[j,1],'">',info[j,1],'</a></td><td align="center">',info[j,6],'</td><td align="center">',info[j,7],'</td><td align="center">',info[j,8],'</td><td align="center">',info[j,9],'</td></tr>',sep="")
                HTML(de,file=target)
            }
        }
        
        de <- "<tr><td> </td><td> </td><td> </td><td> </td><td> </td><td> </td><td> </td><td> </td><td> </td></tr>"
        HTML(de,file=target)
        HTML(de,file=target)
    }
    
    HTML("</table><br/><br/>",file=target)
    
    HTML(paste("<h2>The associated features for each module, p<",pth,"</h2>",sep=""), file=target)
    moduleInfo <- moduleInfo[order(moduleInfo[,1],moduleInfo[,8]),]
    modules <- unique(moduleInfo[,1])
    
    de <- '<table><tr><th width="15%" align="left">Module Name</th><th width="10%" align="left">Feature</th><th width="10%" align="left">Feature Type</th><th width="10%" align="left">Method</th><th width="20%" align="left">Compare</th><th width="10%" align="center">Statistic</th><th width="5%" align="center">Direction</th><th width="10%" align="center">P Value</th><th width="10%" align="center">FDR</th></tr>'

    HTML(de, file=target)
    
    for(i in c(1:length(modules))){
        info <- moduleInfo[moduleInfo[,1]==modules[i],]
        de <- paste('<tr><td><a name="',info[1,1],'">',info[1,1],'</a></td><td><a href="#',info[1,2],'">',info[1,2],"</a></td><td>",info[1,3],"</td><td>",info[1,4],"</td><td>",info[1,5],'</td><td align="center">',info[1,6],'</td><td align="center">',info[1,7],'</td><td align="center">',info[1,8],'</td><td align="center">',info[1,9],'</td></tr>',sep="")
        HTML(de,file=target)
        
        if(nrow(info)>1){
            for(j in c(2:nrow(info))){
                de <- paste('<tr><td> </td><td><a href="#',info[j,2],'">',info[j,2],"</a></td><td>",info[j,3],"</td><td>",info[j,4],"</td><td>",info[j,5],'</td><td align="center">',info[j,6],'</td><td align="center">',info[j,7],'</td><td align="center">',info[j,8],'</td><td align="center">',info[j,9],'</td></tr>',sep="")
                HTML(de,file=target)
            }
        }
        
        de <- "<tr><td> </td><td> </td><td> </td><td> </td><td> </td><td> </td><td> </td><td> </td><td> </td></tr>"
        HTML(de,file=target)
        HTML(de,file=target)
        
    }
    HTML("</table><br/><br/>",file=target)
    
    HTMLEndFile()
    
    #browseURL(file.path(outputDir,paste(htmlFileName,".html",sep="")))

}

## ----setup, include=FALSE-----------------------------------------------------
knitr::opts_chunk$set(echo = TRUE)
knitr::opts_chunk$set(eval = FALSE)
knitr::opts_chunk$set(tidy.opts=list(width.cutoff=65),tidy=TRUE)

## -----------------------------------------------------------------------------
# install.packages("igraph")
# install.packages("seriation")
# install.packages("WGCNA")
# install.packages("snow")
# install.packages("doSNOW")
# install.packages("foreach")
# source("http://bioconductor.org/biocLite.R")
# biocLite("biomaRt")
# biocLite("GO.db")
# install.packages("R2HTML")
# install.packages("survival")

## ----eval=FALSE---------------------------------------------------------------
# library("NetSAM")
# inputNetworkDir <- system.file("extdata","exampleNetwork.net",package="NetSAM")
# outputFileName <- paste(getwd(),"/NetSAM",sep="")
# result <- NetSAM(inputNetwork=inputNetworkDir, outputFileName=outputFileName, outputFormat="nsm",
# edgeType="unweighted", map_to_genesymbol=FALSE, organism="hsapiens", idType="auto", minModule=0.003,
# stepIte=FALSE, maxStep=4, moduleSigMethod="cutoff", modularityThr=0.2, ZRanNum=10,
# PerRanNum=100, ranSig=0.05, edgeThr=(-1), nodeThr=(-1), nThreads=3)

## -----------------------------------------------------------------------------
# library("NetSAM")
# inputNetwork <- system.file("extdata","exampleNetwork.net",package="NetSAM")
# outputFileName <- paste(getwd(),"/NetSAM",sep="")
# NetAnalyzer(inputNetwork,outputFileName,"unweighted")

## -----------------------------------------------------------------------------
# library("NetSAM")
# inputMatDir <- system.file("extdata","exampleExpressionData_nonsymbol.cct",package="NetSAM")
# inputMat <- read.table(inputMatDir,header=TRUE,sep="\t",stringsAsFactors=FALSE,check.names=FALSE)
# mergedData <- mergeDuplicate(id=inputMat[,1],data=inputMat[,2:ncol(inputMat)],collapse_mode="maxSD")

## -----------------------------------------------------------------------------
# library("NetSAM")
# print("transform ids from a gene list to gene symbols...")
# geneListDir <- system.file("extdata","exampleGeneList.txt",package="NetSAM")
# geneList <- read.table(geneListDir,header=FALSE,sep="\t",stringsAsFactors=FALSE)
# geneList <- as.vector(as.matrix(geneList))
# geneList_symbol <- mapToSymbol(inputData=geneList, organism="hsapiens", inputType="genelist",idType="affy_hg_u133_plus_2")
# 
# print("transform ids in the input network to gene symbols...")
# inputNetwork <- system.file("extdata","exampleNetwork_nonsymbol.net",package="NetSAM")
# network_symbol <- mapToSymbol(inputData=inputNetwork,organism="hsapiens",inputType="network",idType="entrezgene",edgeType="unweighted")
# 
# print("transform ids in the input matrix to gene symbols...")
# inputMatDir <- system.file("extdata","exampleExpressionData_nonsymbol.cct",package="NetSAM")
# matrix_symbol <- mapToSymbol(inputData=inputMatDir,organism="hsapiens",inputType="matrix",idType="affy_hg_u133_plus_2",collapse_mode="maxSD")
# 
# print("transform ids in the sbt file to gene symbols...")
# inputSBTDir <- system.file("extdata","exampleSBT.sbt",package="NetSAM")
# sbt_symbol <- mapToSymbol(inputData= inputSBTDir,organism="hsapiens",inputType="sbt",idType="affy_hg_u133_plus_2")
# 
# print("transform ids in the sct file to gene symbols...")
# inputSCTDir <- system.file("extdata","exampleSCT.sct",package="NetSAM")
# sct_symbol <- mapToSymbol(inputData= inputSCTDir,organism="hsapiens",inputType="sct",idType="affy_hg_u133_plus_2",collapse_mode="min")

## -----------------------------------------------------------------------------
# library("NetSAM")
# inputMatDir <- system.file("extdata","exampleExpressionData.cct",package="NetSAM")
# matNetwork <- MatNet(inputMat=inputMatDir, collapse_mode="maxSD", naPer=0.7, meanPer=0.8, varPer=0.8,
# corrType="spearman", matNetMethod="rank", valueThr=0.6, rankBest=0.003, networkType="signed",
# netFDRMethod="BH", netFDRThr=0.05, idNumThr=(-1), nThreads=3)

## -----------------------------------------------------------------------------
# library("NetSAM")
# inputMatDir <- system.file("extdata","exampleExpressionData.cct",package="NetSAM")
# data <- read.table(inputMatDir, header=TRUE, row.names=1, stringsAsFactors=FALSE)
# net <- consensusNet(data=data, organism="hsapiens",bootstrapNum=10, naPer=0.5, meanPer=0.8,varPer=0.8,method="rank_unsig",value=3/1000,pth=1e-6, nMatNet=2, nThreads=4)

## -----------------------------------------------------------------------------
# library("NetSAM")
# inputMatDir <- system.file("extdata","exampleExpressionData.cct",package="NetSAM")
# sampleAnnDir <- system.file("extdata","sampleAnnotation.tsi",package="NetSAM")
# formatedData <- testFileFormat(inputMat=inputMatDir,sampleAnn=sampleAnnDir,collapse_mode="maxSD")

## -----------------------------------------------------------------------------
# library("NetSAM")
# inputMatDir <- system.file("extdata","exampleExpressionData.cct",package="NetSAM")
# sampleAnnDir <- system.file("extdata","sampleAnnotation.tsi",package="NetSAM")
# data(NetSAMOutput_Example)
# outputHtmlFile <- paste(getwd(),"/featureAsso_HTML",sep="")
# featureAsso <- featureAssociation(inputMat=inputMatDir, sampleAnn=sampleAnnDir, NetSAMOutput=netsam_output, outputHtmlFile=outputHtmlFile, CONMethod="spearman", CATMethod="kruskal", BINMethod="ranktest", fdrmethod="BH",pth=0.05,collapse_mode="maxSD")

## -----------------------------------------------------------------------------
# library("NetSAM")
# data(NetSAMOutput_Example)
# outputHtmlFile <- paste(getwd(),"/GOAsso_HTML",sep="")
# GOAsso <- GOAssociation(NetSAMOutput=netsam_output, outputHtmlFile=outputHtmlFile, organism="hsapiens", fdrmethod="BH", fdrth=0.05, topNum=5)

## -----------------------------------------------------------------------------
# library("NetSAM")
# inputMatDir <- system.file("extdata","exampleExpressionData.cct",package="NetSAM")
# sampleAnnDir <- system.file("extdata","sampleAnnotation.tsi",package="NetSAM")
# outputFileName <- paste(getwd(),"/MatSAM",sep="")
# matModule <- MatSAM(inputMat=inputMatDir, sampleAnn=sampleAnnDir,
#                     outputFileName = outputFileName, outputFormat="msm",
#                     organism="hsapiens", map_to_symbol=FALSE, idType="auto", collapse_mode="maxSD", naPer=0.7, meanPer=0.8, varPer=0.8,
# corrType="spearman", matNetMethod="rank",
# valueThr=0.6, rankBest=0.003, networkType="signed", netFDRMethod="BH",
# netFDRThr=0.05, minModule=0.003, stepIte=FALSE,
# maxStep=4, moduleSigMethod="cutoff", modularityThr=0.2, ZRanNum=10, PerRanNum=100, ranSig=0.05, idNumThr=(-1), nThreads=3)

.getClass <- function(obj) {
   cls <- class(obj)
   return(cls[1])
}

mapToSymbol <- function(inputData,organism="hsapiens",inputType="genelist",idType="auto",edgeType="unweighted", collapse_mode="maxSD", is_outputFile=FALSE, outputFileName="", verbose=TRUE){
    
    organisms <- c("hsapiens","mmusculus","rnorvegicus","drerio","celegans","scerevisiae","cfamiliaris","dmelanogaster","athaliana")
    
    if(length(which(organisms==organism))==0){
        stop("Currently, the package supports the following nine organisms: hsapiens, mmusculus, rnorvegicus, drerio, celegans, scerevisiae, cfamiliaris, dmelanogaster and athaliana!")
    }

    
    if(length(which(inputType %in% c("genelist","network","sbt","sct","matrix")))==0){
        stop("The input 'inputType' is invalide! Please select an option from 'genelist', 'netwrok', 'sbt', 'sct', and 'matrix'!\n")
    }
    
    if(length(which(collapse_mode %in% c("mean","median","maxSD","maxIQR","max","min")))==0){
        stop("The input 'collapse_mode' is invalide! Please select an option from 'mean', 'median', 'maxSD',  'maxIQR', 'max' and 'min' (use mean, median, max standard derivation, max interquartile range, maximum and minimum of duplicate genes for each sample)!\n")
    }
    
    if(inputType=="genelist"){
        
        if(is_outputFile==TRUE && outputFileName==""){
            outputFileName <- "geneList_symbol.txt"
        }
        
        mapresult <- .GeneToSymbol(geneList=inputData,organism=organism,idType=idType,verbose=verbose)
        
        if(is.null(mapresult)){
            if(verbose==TRUE){
                stop("The ids can not be transformed to gene symbols! Please check whether the inut idType is correct!\n",sep="")
            }
            
        }else{
            if(.getClass(mapresult)=="numeric"){
                if(verbose==TRUE){
                    stop(paste("Only ",round(mapresult*100),"% ids can be transformed to gene symbols. Please check whether the inut idType is correct!\n",sep=""))
                }
                mapresult <- NULL
            }else{
                if(is_outputFile==TRUE){
                    write.table(mapresult,file=outputFileName,row.names=F,col.names=F,sep="\t",quote=F)
                }
            }
        }
    }
    
    if(inputType=="network"){
        
        if(is_outputFile==TRUE && outputFileName==""){
            outputFileName <- "network_symbol.net"
        }

        mapresult <- .NetToSymbol(inputNetwork=inputData, organism=organism, idType=idType, edgeType=edgeType, verbose=verbose)
        
        if(is.null(mapresult)){
            if(verbose==TRUE){
                stop("The ids in the input network can not be transformed to gene symbols! Please check whether the inut idType is correct!\n",sep="")
            }

        }else{
            if(.getClass(mapresult)=="numeric"){
                if(verbose==TRUE){
                    stop(paste("Only ",round(mapresult*100),"% ids in the input network can be transformed to gene symbols. Please check whether the inut idType is correct!\n",sep=""))
                }
                mapresult <- NULL
            }else{
                if(is_outputFile==TRUE){
                    net <- mapresult$network
                    write.table(net,file=outputFileName,row.names=F,col.names=F,sep="\t",quote=F)
                }
            }
        }
    }
    
    if(inputType=="matrix"){
        
        if(is_outputFile==TRUE && outputFileName==""){
            outputFileName <- "matrix_symbol.cct"
        }
        
        mapresult <- .MatToSymbol(inputMat=inputData, organism=organism, idType=idType, collapse_mode=collapse_mode, verbose=verbose)
        
        if(is.null(mapresult)){
            if(verbose==TRUE){
                stop("The ids in the input matrix can not be transformed to gene symbols! Please check whether the inut idType is correct!\n")
            }
        }else{
            if(.getClass(mapresult)=="numeric"){
                if(verbose==TRUE){
                    stop(paste("Only ",round(mapresult*100),"% ids in the input matrix can be transformed to gene symbols. Please check whether the inut idType is correct!\n",sep=""))
                }
                mapresult <- NULL
            }else{
                if(is_outputFile==TRUE){
                    matrix <- mapresult$data_symbol
                    matrix <- cbind(rownames(matrix),matrix)
                    colnames(matrix)[1] <- "GeneSymbol"
                    write.table(matrix,file=outputFileName,row.names=F,col.names=T,sep="\t",quote=F)
                }
            }
        }
    }
    
    if(inputType=="sbt"){
        if(is_outputFile==TRUE && outputFileName==""){
            outputFileName <- "sbt_symbol.sbt"
        }

        mapresult <- .sbtToSymbol(inputFile=inputData, organism=organism, idType=idType, verbose=verbose)
        
        if(is.null(mapresult)){
            if(verbose==TRUE){
                stop("The ids in the SBT file can not be transformed to gene symbols! Please check whether the inut idType is correct!\n")
            }
        }else{
            l <- mapresult$oriLength
            mapresult <- mapresult$transformedData
            
            if(l!=nrow(mapresult)){
                if(verbose==TRUE){
                    warning(paste("The ids in ",nrow(mapresult)," tracks among all ",l," tracks in the input SBT file can be transformed to gene symbols!\n",sep=""))
                }
            }
            
            if(is_outputFile==TRUE){
                    write.table(mapresult,file=outputFileName,row.names=F,col.names=F,sep="\t",quote=F)
            }
        }
    }
    
    if(inputType=="sct"){
        
        if(is_outputFile==TRUE && outputFileName==""){
            outputFileName <- "sct_symbol.sct"
        }

        
        mapresult <- .sctToSymbol(inputFile=inputData, organism=organism, idType=idType, verbose=verbose, collapse_mode=collapse_mode)
        
        if(is.null(mapresult)){
            if(verbose==TRUE){
                stop("The ids in the SCT file can not be transformed to gene symbols! Please check whether the inut idType is correct!\n")
            }
        }else{
            if(.getClass(mapresult)=="numeric"){
                if(verbose==TRUE){
                    stop(paste("Only ",round(mapresult*100),"% ids in the SCT file can be transformed to gene symbols. Please check whether the inut idType is correct!\n",sep=""))
                }
                mapresult <- NULL
            }else{
            		sctM <- mapresult$sct_symbol
            		sctM <- cbind(rownames(sctM),sctM)
            		colnames(sctM)[1] <- "GeneSymbol"
                if(is_outputFile==TRUE){
                    write.table(sctM,file=outputFileName,row.names=F,col.names=T,sep="\t",quote=F)
                }
            }
        }
    }
    
    return(mapresult)
}

.GeneToSymbol <-
function(geneList, organism="hsapiens", idType="auto",verbose=TRUE){
	
    
    
    #require(biomaRt) || stop("Package biomaRt version 2.18.0 is required!")
    
    if(!is.null(dim(geneList))){
        stop("The input gene list should be a vector!!\n")
    }
   
   if(organism=="athaliana"){
       mart <- useMart("plants_mart",host="plants.ensembl.org")
       m <- try(mart <- useDataset(paste(organism,"_eg_gene",sep=""),mart),silent=TRUE)
   }else{
       mart <- useMart("ENSEMBL_MART_ENSEMBL",host="https://www.ensembl.org")
       m <- try(mart <- useDataset(paste(organism,"_gene_ensembl",sep=""),mart),silent=TRUE)
   }
   
    
    if(.getClass(m)=="try-error"){
        stop(paste("The function can not connect to Biomart. Please try again!\n",sep=""))
    }
    
    
    allMartAttr <- listAttributes(mart)
    allFilter <- listFilters(mart)
    
    finalAttr <- intersect(allMartAttr[,1],allFilter[,1])
    
    genesymbol <- ""
    
    if(organism=="hsapiens"){
        noAttr <- c("strand","transcript_status","atlas_diseasestate","transcript_count","phenotype_description","source","go_id","transcript_source","goslim_goa_accession","ens_hs_gene","chromosome_name","status","mim_morbid_accession","atlas_celltype","germ_line_variation_source")
        genesymbol <- "hgnc_symbol"
    }
    
    if(organism=="mmusculus"){
        noAttr <- c("chromosome_name","go_id","goslim_goa_accession","strand","ikmcs_no_products_available_yet","status","germ_line_variation_source","hgnc_id","hgnc_symbol","hgnc_transcript_name","prints","phenotype_description","source")
        genesymbol <- "mgi_symbol"
    }
    
    if(organism=="rnorvegicus"){
        noAttr <- c("chromosome_name","go_id","goslim_goa_accession","strand","status","germ_line_variation_source","mgi_id","mgi_symbol","mgi_transcript_name","prints","source","transcript_source","transcript_count","transcript_biotype","transcript_status")
        genesymbol <- "rgd_symbol"
    }
    
    if(organism=="drerio"){
        noAttr <- c("chromosome_name","go_id","goslim_goa_accession","strand","status","status","germ_line_variation_source","hgnc_id","hgnc_symbol","hgnc_transcript_name","prints","phenotype_description","source","transcript_source","transcript_count","transcript_biotype","transcript_status")
        genesymbol <- "zfin_symbol"
    }
    
    if(organism=="celegans"){
         noAttr <- c("chromosome_name","go_id","prints","source","status","strand","transcript_source","transcript_count","transcript_biotype","transcript_status")
         genesymbol <- "wormbase_locus"
    }
    
    if(organism=="scerevisiae"){
        noAttr <- c("chromosome_name","germ_line_variation_source","go_id","goslim_goa_accession","prints","source","status","strand","transcript_source","transcript_count","transcript_biotype","transcript_status")
        genesymbol <- "external_gene_name"
    }
    
    if(organism=="cfamiliaris"){
        noAttr <- c("chromosome_name","germ_line_variation_source","go_id","goslim_goa_accession","hgnc_id","hgnc_symbol","hgnc_transcript_name","phenotype_description","prints","source","status","strand","transcript_source","transcript_count","transcript_biotype","transcript_status")
        genesymbol <- "external_gene_name"
    }
    
    if(organism=="dmelanogaster"){
        noAttr <- c("chromosome_name","germ_line_variation_source","go_id","goslim_goa_accession","prints","source","status","strand","transcript_source","transcript_count","transcript_biotype","transcript_status")
        genesymbol <- "external_gene_name"
    }
    
    if(organism=="athaliana"){
        noAttr <- c("chromosome_name","prints_pf","strand")
        genesymbol <- "tair_symbol"

    }
    
    finalAttr <- setdiff(finalAttr,noAttr)
    
    finalAttr <- sort(finalAttr)
    
    if(idType!="auto" && length(which(finalAttr==idType))==0){
        cat("The input 'idType' is not supported by Biomart. Please select one id type from the following list:\n")
        cat(finalAttr,sep="\n")
        stop("The users can also set 'idType' as 'auto' and the function will automatically search idtype based on the input data. However, this function may take 20-60 minutes based on users' internet speed\n")
    }
    
    if(idType=="auto"){
        idtype <- .autoSearchIdType(geneList,finalAttr,mart,genesymbol,verbose)
        if(!is.null(idtype)){
            idmap <- getBM(attributes=c(idtype,genesymbol),filters=idtype,values=geneList,mart=mart)
            idmap <- idmap[idmap[,2]!="",]
            
            t <- tapply(idmap[,2],idmap[,1],paste,collapse="|")
            
            idmap <- data.frame(id=names(t),genesymbol=t,stringsAsFactors=F)
            
            return(idmap)
        }else{
            return(NULL)
        }
    }else{
        idmap <- getBM(attributes=c(idType,genesymbol),filters=idType,values=geneList,mart=mart)
        
        if(nrow(idmap)==0){
            return(NULL)
        }else{
            idmap <- idmap[idmap[,2]!="",]
        
            t <- tapply(idmap[,2],idmap[,1],paste,collapse="|")
        
            idmap <- data.frame(id=names(t),genesymbol=t,stringsAsFactors=F)
            
            if(nrow(idmap)/length(geneList)<0.1){
                return(nrow(idmap)/length(geneList))
            }else{
                return(idmap)
            }
        }
    }
}

.autoSearchIdType <- function(geneList,finalAttr,mart,genesymbol,verbose=TRUE){
    if(length(geneList)>40){
        randomNum <- 40
    }else{
        randomNum <- length(geneList)
    }
    
    if(verbose==TRUE){
        cat("\nSearching the array type...\n")
    }
    
    randomId <- sample(geneList,randomNum)
    
    
    finalIdtype <- c()
    tempIdtype <- data.frame(id="",rate=0,stringsAsFactors=F)
    ti <- 1
    
    rang <- ifelse(length(finalAttr)>10,10,length(finalAttr))
    
    startA <- 1
    endA <- rang
    
    startB <- length(finalAttr)-rang+1
    endB <- length(finalAttr)
    
    
    l <- 0
    
    
    u <- 0
    fi <- 0
    while(u<length(finalAttr)){
        if(l==0){
            s <- startA
            e <- endA
        }else{
            s <- startB
            e <- endB
        }
        for(i in c(s:e)){
            idtype <- finalAttr[i]
            idmap <- getBM(attributes=c(idtype,genesymbol),filters=idtype,values=randomId,mart=mart)
            if(length(unique(idmap[,1]))>(0.8*length(randomId))){
                finalIdtype <- idtype
                fi <- 1
                break
            }else{
                if(length(unique(idmap[,1]))>(0.6*length(randomId))){
                    tempIdtype[ti,1] <- idtype
                    tempIdtype[ti,2] <- (length(unique(idmap[,1]))/length(randomId))
                    ti <- ti + 1
                }
            }
        }
        if(fi==1){
            break
        }
        
        if(l==0){
            l <- 1
            u <- u+endA-startA+1
            startA <- startA + rang
            endA <- startA + rang - 1
            if(endA>=startB){
                endA <- startB-1
            }
        }else{
            l <- 0
            u <- u+endB-startB+1
            endB <- startB-1
            startB <- endB - rang + 1
            if(startB<endA){
                startB <- endA+1
            }
        }
        
    }
    
    is.map <- TRUE
    if(length(finalIdtype)>0){
        idtype <- finalIdtype
        is.map <- TRUE
        
    }else{
        if(tempIdtype[1,1]!=""){
            tempIdtype <- tempIdtype[order(-tempIdtype[,2]),]
            idtype <- tempIdtype[1,1]
            is.map <- TRUE
        }else{
            is.map <- FALSE
        }
    }
    
    if(is.map==TRUE){
        
        if(verbose==TRUE){
            cat("The input Ids can map to ",idtype, "!\n")
        }
        
        return(idtype)
        
    }else{
        if(verbose==TRUE){
            cat("The function can not find the matched id type from biomart!\n")
        }
        return(NULL)
    }
}


.NetToSymbol <-
function(inputNetwork, organism="hsapiens", idType="auto", edgeType="unweighted", verbose=TRUE){
    
    
    #require(tools) || stop("Package tools version 3.0.0 is required!")
    
    #load Network
    
    if(verbose==TRUE){
        cat("Transforming the ids in the input network to gene symbols...\n")
    }
    
    
    if(.getClass(inputNetwork)=="character"){
        if(file_ext(inputNetwork)!="net"){
            stop("The extension of the input file should be 'net'!\n")
        }else{
            network <- read_graph_ncol(inputNetwork)
            if(edgeType=="weighted"){
                if(is.null(E(network)$weight)){
                    stop("The input network does not contain edge weights. Please add the edge weights or change parameter 'edgeType' to 'unweigthed'!")
                }
            }else{
                if(!is.null(E(network)$weight)){
                    stop("The input network contains edge weights. Please remove the edge weights or change parameter 'edgeType' to 'weigthed'!")
                }
            }
        }
    }else{
        if(.getClass(inputNetwork)=="data.frame" || .getClass(inputNetwork)=="matrix"){
            if(edgeType=="weighted"){
                if(ncol(inputNetwork)!=3){
                    stop("Data object should contain three columns: interactor1, interactor2 and edge weight!")
                }else{
                    weight <- inputNetwork[,3]
                    if(!is.numeric(weight)){
                        stop("The edge weight should be numeric!")
                    }else{
                        inputNetwork <- as.matrix(inputNetwork[,c(1,2)])
                        inputNetwork_S <- as.character(inputNetwork)
                        inputNetwork_S <- array(inputNetwork_S,dim=dim(inputNetwork))
                        network <- graph.edgelist(inputNetwork_S,directed=F)
                        E(network)$weight <- weight
                    }
                }
            }else{
                if(ncol(inputNetwork)!=2){
                    stop("data object should contain two columns!\n");
                }else{
                    inputNetwork <- as.matrix(inputNetwork)
                    inputNetwork_S <- as.character(inputNetwork)
                    inputNetwork_S <- array(inputNetwork_S,dim=dim(inputNetwork))
                    network <- graph.edgelist(inputNetwork_S,directed=F)
                }
            }
            rm(inputNetwork,inputNetwork_S)
            gc()
        }else{
            if(.getClass(inputNetwork)=="igraph"){
                if(edgeType=="unweighted"){
                    if(!is.null(E(inputNetwork)$weight)){
                        stop("The input network contains edge weights. Please remove the edge weights or change parameter 'edgeType' to 'weigthed'!")
                    }else{
                        network <- inputNetwork
                    }
                }else{
                    if(is.null(E(inputNetwork)$weight)){
                        stop("The input network does not contain edge weights. Please add the edge weights or change parameter 'edgeType' to 'unweigthed'!")
                    }else{
                        network <- inputNetwork
                    }
                }
                rm(inputNetwork)
                gc()
            }else{
                if(.getClass(inputNetwork)=="graphNEL"){
                    network <- igraph.from.graphNEL(inputNetwork)
                    if(edgeType=="unweighted"){
                        if(!is.null(E(network)$weight)){
                            stop("The input network contains edge weights. Please remove the edge weights or change parameter 'edgeType' to 'weigthed'!")
                        }
                    }else{
                        if(is.null(E(network)$weight)){
                            stop("The input network does not contain edge weights. Please add the edge weights or change parameter 'edgeType' to 'unweigthed'!")
                        }
                    }
                    rm(inputNetwork)
                    gc()
                }else{
                    stop("The input network should be from a file or a data object with data.frame, matrix, graphNEL or igraph class. Other types of input are invalid!\n")
                }
                
            }
        }
    }
    
    netNode <- get.vertex.attribute(network,"name")
    idmap <- .GeneToSymbol(netNode,organism,idType,verbose)
    
    if(is.null(idmap)){
        return(NULL)
    }else{
        if(.getClass(idmap)=="numeric"){
            return(idmap)
        }else{
            network <- .extractSubNetwork(network,idmap[,1],edgeType)
            rownames(idmap) <- idmap[,1]
            idmap <- idmap[get.vertex.attribute(network,"name"),]
            V(network)$name <- idmap[,2]
            network <- simplify(network)
            # if(verbose==TRUE){
            #    cat("After mapping to the gene symbol, the network contains ",vcount(network)," nodes and ",ecount(network)," edges!\n",sep="")
            #}
        
            network_edgelist <- get.edgelist(network)
            network_edgelist <- as.data.frame(network_edgelist)
            if(edgeType=="weighted"){
                wei <- get.edge.attribute(network,name="weight")
                network_edgelist$weight <- wei
            }
        
            re <- list(network=network_edgelist,idmap=idmap)
            return(re)
        }
    }
}

.extractSubNetwork <- function(network,subList,edgeType){
    if(edgeType=="unweighted"){
        x <- get.edgelist(network)
        x <- x[x[,1] %in% subList & x[,2] %in% subList,]
        network <- graph.edgelist(x,directed=F)
    }else{
        x <- get.edgelist(network)
        weight <- get.edge.attribute(network,"weight")
        ind <- which(x[,1] %in% subList & x[,2] %in% subList)
        x <- x[ind,]
        weight <- weight[ind]
        network <- graph.edgelist(x,directed=F)
        E(network)$weight <- weight
    }
    return(network)
}


.MatToSymbol <-
function(inputMat, organism="hsapiens", idType="auto", collapse_mode="maxSD", verbose=TRUE){
    
    
    #require(biomaRt) || stop("Package biomaRt version 2.18.0 is required!")
    #require(tools) || stop("Package tools version 3.0.0 is required!")
    #require(multicore) || stop("Package multicore version 0.1-7 is required!")
    #require(doSNOW) || stop("Package doSNOW version 1.0.6 is required!")
    #require(foreach) || stop("Package foreach version 1.4.0 is required!")
    
    #mart <- useMart("ensembl")
    
    #m <- try(mart <- useDataset(paste(organism,"_gene_ensembl",sep=""),mart),silent=TRUE)
    #if(class(m)=="try-error"){
    #    stop(paste("The organism ",organism," your input is not valid! Correct organism names can be obtained with the listDatasets function.\n",sep=""))
    #}

    
    re <- testFileFormat(inputMat=inputMat, collapse_mode=collapse_mode)
    inputMat <- re$inputMat
    inputId <- rownames(inputMat)
    
    idmap <- .GeneToSymbol(inputId,organism,idType,verbose)
    if(!is.null(idmap)){
        
        if(.getClass(idmap)=="numeric"){
            return(idmap)
        }else{
            inputMat <- inputMat[idmap[,1],]
            id <- as.vector(idmap[,2])
            inputMat <- mergeDuplicate(id,inputMat,collapse_mode)
            re <- list(data_symbol=inputMat,idmap=idmap)
            return(re)
        }
    }else{
        return(NULL)
    }
}


.sbtToSymbol <- function(inputFile, organism="hsapiens", idType="auto", verbose=TRUE){
    if(.getClass(inputFile)=="character"){
        if(file_ext(inputFile)!="sbt"){
            stop("The extension of the input file should be 'sbt'. The detail of the 'sbt' file format can be found in the NetGestalt (www.netgestalt.org)!\n")
        }else{
            inputMat <- read.csv(inputFile,header=FALSE,sep="\t",stringsAsFactors=FALSE)
        }
    }else{
        stop("The 'inputFile' should be the directory of a SBT file\n")
    }
    
    .calculateLength <- function(vector){
        vector <- vector[vector!=""]
        return(length(vector))
    }
    
    sbtLength <- apply(inputMat,1,.calculateLength)
    
    if(length(which(sbtLength<3))>0){
        stop("The SBT file should contain at least three columns. The following rows of the input file only contain one or two columns: ",which(sbtLength<3),"\n",sep="")
    }
    
    transformedData <- data.frame(name="",des="",genelist="",stringsAsFactors=F)
    ti <- 1
    for(i in c(1:nrow(inputMat))){
        geneL <- inputMat[i,3:ncol(inputMat)]
        geneL <- geneL[geneL!=""]
        idmap <- .GeneToSymbol(geneL,organism,idType,verbose)
        mapNum <- c()
        if(!is.null(idmap) && .getClass(idmap)!="numeric"){
            mappedL <- unique(idmap[,2])
            transformedData[ti,1] <- inputMat[i,1]
            transformedData[ti,2] <- inputMat[i,2]
            mappedL <- paste(mappedL,collapse="\t")
            transformedData[ti,3] <- mappedL
            ti <- ti+1
        }
    }
    
    if(transformedData[1,1]!=""){
        re <- list(transformedData=transformedData,oriLength=nrow(inputMat))
        return(re)
    }else{
        return(NULL)
    }
}


.sctToSymbol <- function(inputFile, organism="hsapiens", idType="auto", verbose=TRUE, collapse_mode="min"){
    if(.getClass(inputFile)=="character"){
        if(file_ext(inputFile)!="sct"){
            stop("The extension of the input file should be 'sct'. The detail of the 'sct' file format can be found in the NetGestalt (www.netgestalt.org)!\n")
        }else{
            inputMat <- read.csv(inputFile,header=TRUE,sep="\t",stringsAsFactors=FALSE,check.names=FALSE)
        }
    }else{
        stop("The 'inputFile' should be the directory of a SCT file\n")
    }
    
    if(ncol(inputMat)<2){
        stop("The SCT file should contain at least two columns (gene id and statistic score). \n")
    }
    
    id <- inputMat[,1]
    inputMat <- as.matrix(inputMat[,2:ncol(inputMat)])
    
    if(length(unique(id))<length(id)){
        cat("The SCT file contains duplidate Ids. The function will use 'median' to collapse duplicate Ids for each statistic.\n")
        inputMat <- mergeDuplicate(id,inputMat,collapse_mode)
    }else{
        rownames(inputMat) <- id
    }
    
    
    idmap <- .GeneToSymbol(id,organism,idType,verbose)
    
    if(!is.null(idmap)){
        
        if(.getClass(idmap)=="numeric"){
            return(idmap)
        }else{
            inputMat <- as.matrix(inputMat[idmap[,1],])
            id <- as.vector(idmap[,2])
            inputMat <- mergeDuplicate(id,inputMat,collapse_mode)
            re <- list(sct_symbol=inputMat,idmap=idmap)
            return(re)
        }
    }else{
        return(NULL)
    }
}

.getClass <- function(obj) {
   cls <- class(obj)
   return(cls[1])
}

read_graph_ncol <- function(file_path, directed = FALSE) {
    network_data <- read.table(file_path, header = FALSE)

    if (ncol(network_data) == 3) {
        colnames(network_data) <- c("from", "to", "weight")
    } else if (ncol(network_data) == 2) {
        colnames(network_data) <- c("from", "to")
    } else {
        stop("The file format is not supported. Expecting 2 or 3 columns.")
    }
    g <- graph_from_data_frame(network_data, directed = directed)

    return(g)
}

NetAnalyzer <-
function(inputNetwork, outputFileName, edgeType="unweighted"){
   
  #require(igraph) || stop("Package igraph version 0.6 is required!")
    
	if(missing(inputNetwork)){
		stop("Please input the network!\n")
	}
    
    
    #load Network
	if(.getClass(inputNetwork)=="character"){
        if(file_ext(inputNetwork)!="net"){
            stop("The extension of the input file should be 'net'!\n")
        }else{
            network <- read_graph_ncol(inputNetwork)
            if(edgeType=="weighted"){
                if(is.null(E(network)$weight)){
                    stop("The input network does not contain edge weights. Please add the edge weights or change parameter 'edgeType' to 'unweigthed'!")
                }
            }else{
                if(!is.null(E(network)$weight)){
                    stop("The input network contains edge weights. Please remove the edge weights or change parameter 'edgeType' to 'weigthed'!")
                }
            }
        }
	}else{
		if(.getClass(inputNetwork)=="data.frame" || .getClass(inputNetwork)=="matrix"){
            if(edgeType=="weighted"){
                if(ncol(inputNetwork)!=3){
                    stop("Data object should contain three columns: interactor1, interactor2 and edge weight!")
                }else{
                    weight <- inputNetwork[,3]
                    if(!is.numeric(weight)){
                        stop("The edge weight should be numeric!")
                    }else{
                        inputNetwork <- as.matrix(inputNetwork[,c(1,2)])
                        inputNetwork_S <- as.character(inputNetwork)
                        inputNetwork_S <- array(inputNetwork_S,dim=dim(inputNetwork))
                        network <- graph.edgelist(inputNetwork_S,directed=F)
                        E(network)$weight <- weight
                    }
                }
            }else{
                if(ncol(inputNetwork)!=2){
                    stop("data object should contain two columns!\n");
                }else{
                    inputNetwork <- as.matrix(inputNetwork)
                    inputNetwork_S <- as.character(inputNetwork)
                    inputNetwork_S <- array(inputNetwork_S,dim=dim(inputNetwork))
                    network <- graph.edgelist(inputNetwork_S,directed=F)
                }
            }
            rm(inputNetwork,inputNetwork_S)
            gc()
		}else{
			if(.getClass(inputNetwork)=="igraph"){
                if(edgeType=="unweighted"){
                    if(!is.null(E(inputNetwork)$weight)){
                        stop("The input network contains edge weights. Please remove the edge weights or change parameter 'edgeType' to 'weigthed'!")
                    }else{
                        network <- inputNetwork
                    }
                }else{
                    if(is.null(E(inputNetwork)$weight)){
                        stop("The input network does not contain edge weights. Please add the edge weights or change parameter 'edgeType' to 'unweigthed'!")
                    }else{
                        network <- inputNetwork
                    }
                }
                rm(inputNetwork)
                gc()
            }else{
                if(.getClass(inputNetwork)=="graphNEL"){
                    network <- igraph.from.graphNEL(inputNetwork)
                    if(edgeType=="unweighted"){
                        if(!is.null(E(network)$weight)){
                            stop("The input network contains edge weights. Please remove the edge weights or change parameter 'edgeType' to 'weigthed'!")
                        }
                    }else{
                        if(is.null(E(network)$weight)){
                            stop("The input network does not contain edge weights. Please add the edge weights or change parameter 'edgeType' to 'unweigthed'!")
                        }
                    }
					rm(inputNetwork)
					gc()
				}else{
                    stop("The input network should be from a file or a data object with data.frame, matrix, graphNEL or igraph class. Other types of input are invalid!\n")
				}

            }
        }
	}
	
	if(missing(outputFileName)){
		stop("Please input the output file name!\n")
	}else{
		if(substr(outputFileName,nchar(outputFileName),nchar(outputFileName))=="/"){
			stop("Please input the output file name!\n")
		}
	}
	
	nodeAttr <- data.frame(node=vertex_attr(network,name="name"),degree=0,clusterCoefficient=0,betweennessCentrality=0,closenessCentrality=0,stringsAsFactors=F)
	
	if(edgeType=="unweighted"){
	
		nodeAttr[,2] <- degree(network)
		nodeAttr[,3] <- transitivity(network,type="local")
		nodeAttr[,4] <- betweenness(network,directed=FALSE)
		nodeAttr[,5] <- closeness(network,mode="all")
	}else{
		nodeAttr[,2] <- strength(network)
		nodeAttr[,3] <- transitivity(network,type="weighted")
		nodeAttr[,4] <- betweenness(network,directed=FALSE)
		nodeAttr[,5] <- closeness(network,mode="all")
	}
	
	shortestP <- distances(network)
	shO <- paste(outputFileName,"_shortestPathDistance.txt",sep="")
	write.table(shortestP,file=shO,row.names=T,col.names=T,sep="\t",quote=F)
	
	shortestP_V <- shortestP[lower.tri(shortestP)]
	
	nodeO <- paste(outputFileName,".txt",sep="")
	write.table(nodeAttr,file=nodeO,row.names=F,col.names=F,sep="\t",quote=F)
	
	degreeP <- paste(outputFileName,"_degreeDistribution.pdf",sep="")
	if(edgeType=="unweighted"){
		.fit_power_law(network,edgeType,degreeP)
	}else{
		pdf(degreeP,height=6,width=6)
		hist(nodeAttr[,2],xlab="Degree",col="black",main="Degree Distribution")
		dev.off()
	}

	
	shortP <- paste(outputFileName,"_shortestPathDistanceFrequency.pdf",sep="")
	pdf(shortP,height=6,width=6)
	hist(shortestP_V,xlab="Shortest Path Distance",col="black",main="Shortest Path Distance Distribution")
	dev.off()
	
	x <- nodeAttr[nodeAttr[,2]>1,]
	ccP <- paste(outputFileName,"_clusteringCoefficient.pdf",sep="")
	pdf(ccP,height=6,width=6)
	a <- tapply(x[,3],x[,2],mean,na.rm=TRUE)
	plot(as.numeric(names(a)),a,xlab="Degree",ylab="Ave clustering coefficient",main="Clustering Coefficient Distribution",pch=19)
	dev.off()
	

	ccP <- paste(outputFileName,"_betweeness.pdf",sep="")
	pdf(ccP,height=6,width=6)
	a <- tapply(nodeAttr[,4],nodeAttr[,2],mean,na.rm=TRUE)
	plot(as.numeric(names(a)),a,xlab="Degree",ylab="Ave betweeness",main="Betweeness Distribution",pch=19)
	dev.off()
	
	ccP <- paste(outputFileName,"_closenessCentrality.pdf",sep="")
	pdf(ccP,height=6,width=6)
	a <- tapply(nodeAttr[,5],nodeAttr[,2],mean,na.rm=TRUE)
	plot(as.numeric(names(a)),a,xlab="Degree",ylab="Ave closeness centrality",main="Closeness Centrality Distribution",pch=19)
	dev.off()
	
}


.fit_power_law = function(graph,edgeType,outputFile) {
    # calculate degree

    d = degree(graph)
   	dd = degree.distribution(graph, cumulative = FALSE)

    degree = 1:max(d)
    probability = dd[-1]
    # delete blank values
    nonzero.position = which(probability != 0)
    probability = probability[nonzero.position]
    degree = degree[nonzero.position]
    reg = lm(log(probability) ~ log(degree))
    cozf = coef(reg)
    power.law.fit = function(x) exp(cozf[[1]] + cozf[[2]] * log(x))
    alpha = -cozf[[2]]
    R.square = summary(reg)$r.squared
    print(paste("Alpha =", round(alpha, 3)))
    print(paste("R square =", round(R.square, 3)))
    # plot
    pdf(outputFile,height=6,width=6)
    plot(probability ~ degree, log = "xy", xlab = "Degree (log)", ylab = "Probability (log)", 
        col = 1, main = "Degree Distribution")
    curve(power.law.fit, col = "red", add = T, n = length(d))
    dev.off()
}

.getClass <- function(obj) {
   cls <- class(obj)
   return(cls[1])
}

MatNet <-
function(inputMat, collapse_mode="maxSD", naPer=0.7, meanPer=0.8, varPer=0.8, corrType="spearman", matNetMethod="rank", valueThr=0.5, rankBest=0.003, networkType="signed", netFDRMethod="BH", netFDRThr=0.05, idNumThr=(-1), nThreads=3){
	
    #require(igraph) || stop("Package igraph version 0.6 is required!")
    #require(WGCNA) || stop("Package WGCNA version 1.34.0 is required!")
    #require(tools) || stop("Package tools version 3.0.0 is required!")
    
    #load expression data
    
    re <- testFileFormat(inputMat=inputMat,collapse_mode=collapse_mode)
    inputMat <- re$inputMat
    inputMat <- as.matrix(inputMat)
    
    if(naPer>1 || naPer<0 || .getClass(meanPer)!="numeric"){
        stop("The input 'naPer' is invalid! 'naPer' should be a positive number and less than 1!\n")
    }
    
    if(meanPer>1 || meanPer<0 || .getClass(meanPer)!="numeric"){
        stop("The input 'meanPer' is invalid! 'meanPer' should be a positive number and less than 1!\n")
    }
    
    if(varPer>1 || varPer<0 || .getClass(varPer)!="numeric"){
        stop("The input 'varPer' is invalid! 'varPer' should be a positive number and less than 1!\n")
    }
    
    
    if(length(which(corrType %in% c("pearson","spearman")))==0){
		stop("The input 'corrType' is invalid! Please select an option from 'pearson' and 'spearman'!\n")
	}
    
    if(length(which(matNetMethod %in% c("value","rank","directed")))==0){
		stop("The input 'matNetMethod' is invalid! Please select an option from 'value','rank' and 'directed'!\n")
	}
    
    if(valueThr>1 || valueThr<0 || .getClass(valueThr)!="numeric"){
        stop("The input 'valueThr' is invalid! 'valueThr' should be a positive number and less than 1!\n")
    }
    
    if(rankBest<0 || rankBest>1){
        stop("The input 'rankBest' is invalid! 'rankBest' should be from 0 to 1!\n")
    }
    
    if(length(which(networkType %in% c("signed","unsigned")))==0){
		stop("The input 'networkType' is invalid! Please select from 'signed' and 'unsigned'!\n")
	}
    
    if(length(which(netFDRMethod %in% c("holm","hochberg","hommel","bonferroni","BH","BY","none")))==0){
		stop("The input 'netFDRMethod' is invalid! Please select a method from 'holm','hochberg', 'hommel', 'bonferroni', 'BH', 'BY' and 'none'!\n")
	}
    
    if(netFDRThr>1 || .getClass(netFDRThr)!="numeric"){
        stop("The input 'netFDRThr' is invalid! 'netFDRThr' should be a number and less than 1!\n")
    }
    
    if(idNumThr<(-1) || .getClass(idNumThr)!="numeric"){
        stop("The input 'idNumThr' is invalid! 'idNumThr' should be -1 or a positive number!\n")
    }
    
    if(nThreads<1 || .getClass(nThreads)!="numeric"){
        stop("The input 'nThreads' is invalid! 'nThreads' should be a number and greater than 1!\n")
    }
    
    missing <- 0
    
	if(length(which(is.na(inputMat)))>0){
		cat("The input data contain ",nrow(inputMat)," ids and ",ncol(inputMat)," samples. The data contain missing values.\n",sep="")
		missing <- 1
	}else{
		cat("The input data contain ",nrow(inputMat)," ids and ",ncol(inputMat)," samples. No missing values in the data.\n",sep="")
	}
    
    #filter genes
    #cat("Remove low expressed genes and less variable genes...\n")
    
    if(missing==1){
    
        naG <- apply(inputMat,1,.calculateNANum)
        if(length(naG[naG>naPer])>0){
            cat(paste("Each of ",length(naG[naG>naPer])," ids has over ",naPer*100,"% missing values in all ",ncol(inputMat)," samples.The function will remove these ids.\n",sep=""))
            naG <- naG[naG<=naPer]
            filterData <- inputMat[names(naG),]
        }else{
            filterData <- inputMat
        }
    }else{
        filterData <- inputMat
    }
    
    meanG <- apply(filterData,1,mean,na.rm=T)
    sdG <- apply(filterData,1,sd,na.rm=T)
    
    if(length(which(sdG==0))>0){
        x <- sdG[sdG==0]
        cat(paste("The function removed ",length(x)," ids with standard deviation 0.\n",sep=""))
        sdG <- sdG[sdG!=0]
        meanG <- meanG[names(sdG)]
        filterData <- filterData[names(sdG),]
    }
    
    
    meanG <- sort(meanG,decreasing=T)
    meanG <- meanG[c(1:round(meanPer*nrow(filterData)))]
    sdG <- sdG[names(meanG)]
    sdG <- sort(sdG,decreasing=T)
    sdG <- sdG[c(1:round(varPer*length(meanG)))]
    
    if(idNumThr!=(-1)){
        if(length(sdG)>idNumThr){
            cat(paste("After filtering based on parameters 'naPer', 'meanPer' and 'varPer', the number of remaining ids is still larger than parameter 'idNumThr'. Thus, the function only selects the top ",idNumThr," ids with the largest variance\n",sep=""))
            sdG <- sdG[c(1:idNumThr)]
        }
    }
    
    cat("After removing ids based on parameters 'naPer', 'meanPer' and 'varPer', ",length(sdG)," ids are remained!\n",sep="")
    
    
    filterData <- filterData[names(sdG),]
    rm(meanG,sdG,inputMat)
    gc()
    
    enableWGCNAThreads()
	
    
	#calculate  correlation
	cat("Calculating ",corrType," correlation for each pair of ids...\n",sep="")
	threNum <- WGCNAnThreads()
	
	if(threNum>nThreads){
		threNum <- nThreads
	}
    
    if(missing==0){
        corrM <- WGCNA::cor(t(filterData),nThreads=threNum,method=corrType)
    }else{
        corrM <- WGCNA::cor(t(filterData),nThreads=threNum,use="pairwise.complete.obs",method=corrType)
    }
    
	disableWGCNAThreads()
    
    corrM[is.na(corrM)] <- 0
    corrM[corrM==1] <- 0.99999999999999999999
    corrM[corrM==(-1)] <- (-0.99999999999999999999)
    
    rankBest <- round(rankBest*nrow(corrM))
    if(rankBest==0){
        rankBest <- 1
    }
    
    if(matNetMethod=="value"){
        sigNetwork <- .valueBasedCoexp(corrM,valueThr,networkType)
        cat("Base on value-based method, an undirected network with ",length(union(sigNetwork[,1],sigNetwork[,2]))," nodes and ",nrow(sigNetwork)," edges was identified under threshold ",valueThr,".\n",sep="")
    }
    
    if(matNetMethod=="rank"){
        sigNetwork <- .rankBasedCoexp(filterData,corrM,rankBest,matNetMethod,networkType,netFDRMethod,netFDRThr)
        cat("Base on rank-based method, an undirected network with ",length(union(sigNetwork[,1],sigNetwork[,2]))," nodes and ",nrow(sigNetwork)," edges was identified when selecting most similar ",rankBest," nodes.\n",sep="")
    }
    
    if(matNetMethod=="directed"){
        sigNetwork <- .rankBasedCoexp(filterData,corrM,rankBest=1,matNetMethod,networkType,netFDRMethod,netFDRThr)
        cat("Base on directed-based method, a directed network with ",length(union(sigNetwork[,1],sigNetwork[,2]))," nodes and ",nrow(sigNetwork)," edges was identified when only selecting most similar node. \n",sep="")

    }
    
    return(sigNetwork)
}


.valueBasedCoexp <- function(corrArray,valueThr,networkType){
    
    diag(corrArray) <- 0
    
    if(networkType=="unsigned"){
        corrArray <- abs(corrArray)
    }
    
    corrArray[lower.tri(corrArray)] <- 0
    
    sigIndex <- which(corrArray>valueThr,arr.ind=TRUE)
    
    sigPair <- array(rownames(corrArray)[sigIndex],dim=dim(sigIndex))
    return(sigPair)
}

.rankBasedCoexp <- function(filterData,corrArray,rankBest,matNetMethod,networkType,netFDRMethod,netFDRThr){
    
    
    corrArray <- .calculateSigCorr(filterData,corrArray,netFDRMethod,netFDRThr)
    
    
    #calculatePosition <- function(sindex,rownum){
    #     col <- ceiling(sindex/rownum)
    #       correctI <- sindex-cumsum(1:col)[col]
    #       return(correctI)
    #   }
    
    
    if(networkType=="unsigned"){
        corrArray <- abs(corrArray)
    }
    
    diag(corrArray) <- 0
    
    bestNeighbor <- apply(corrArray,1,.findBestNeighbor,rankBest)
    
    corrArray[corrArray!=0] <- 0
    
    
    for(i in c(1:nrow(corrArray))){
        if(!is.null(bestNeighbor[[i]][[1]])){
            x <- bestNeighbor[[i]][[1]]
            corrArray[i,x] <- 1
        }
    }
    
    if(matNetMethod=="rank"){
        corrArray <- corrArray+t(corrArray)
        corrArray[lower.tri(corrArray)] <- 0
        sigIndex <- which(corrArray==2,arr.ind=TRUE)
    }
    
    if(matNetMethod=="directed"){
        sigIndex <- which(corrArray==1,arr.ind=TRUE)
    }
    
    sigPair <- array(rownames(corrArray)[sigIndex],dim=dim(sigIndex))

    return(sigPair)
}

.calculateSigCorr <- function(filterData,corrArray,netFDRMethod,netFDRThr){
    n <- t(!is.na(t(filterData))) %*% (!is.na(t(filterData)))
    suppressWarnings(t <- (corrArray * sqrt(n - 2))/sqrt(1 - corrArray^2))
    suppressWarnings(corrP <- 2 * (1 - pt(abs(t), (n - 2))))
    rm(n,t)
    gc()
    corrP[is.na(corrP)] <- 0
    corrP[corrP>1] <- 1
    diag(corrP) <- (-1)
    corrSig <- apply(corrP,1,.fdrFilter,netFDRMethod,netFDRThr)
    corrSig <- t(corrSig)
    rm(corrP)
    gc()
    corrArray <- corrArray*corrSig
    return(corrArray)

}

.fdrFilter <- function(vector,netFDRMethod,netFDRThr){
    a <- vector[vector>=0]
    adjp <- p.adjust(a,method=netFDRMethod)
    vector[names(adjp)] <- adjp
    vector[vector==(-1)] <- 1
    sigP <- ifelse(vector<=netFDRThr,1,0)
    return(sigP)
}



.findBestNeighbor <- function(corrList,rankBest){
    
    corrList <- corrList[corrList!=0]
    
    if(length(corrList)==0){
        return(NULL)
    }else{
    
        if(length(corrList)<rankBest){
            return(list(names(corrList)))
        }else{
            corrList <- sort(corrList,decreasing=T)
            return(list(names(corrList)[1:rankBest]))
        }
    }
}

.calculateNANum <- function(vector){
    return(sum(is.na(vector))/length(vector))
}

.getClass <- function(obj) {
   cls <- class(obj)
   return(cls[1])
}

NetSAM <- function(inputNetwork, outputFileName, outputFormat="nsm", edgeType="unweighted", map_to_genesymbol=FALSE, organism="hsapiens", idType="auto", minModule=0.003, stepIte=FALSE, maxStep=4, moduleSigMethod="cutoff", modularityThr=0.2, ZRanNum=10, PerRanNum=100, ranSig=0.05, edgeThr=(-1), nodeThr=(-1), nThreads=3){
  organisms <- c("hsapiens","mmusculus","rnorvegicus","drerio","celegans","scerevisiae","cfamiliaris","dmelanogaster","athaliana")
  names(organisms) <- c("Hs","Mm","Rn","Dr","Ce","Sc","Cf","Dm","At")

  if(length(which(organisms==organism))==0){
    stop("Currently, the package supports the following nine organisms: hsapiens, mmusculus, rnorvegicus, drerio, celegans, scerevisiae, cfamiliaris, dmelanogaster and athaliana!")
  }

  if(missing(inputNetwork)){
    stop("Please input the network!\n")
  }

  #load Network
  if(.getClass(inputNetwork)=="character"){
    if(file_ext(inputNetwork)!="net"){
      stop("The extension of the input file should be 'net'!\n")
    }else{
      network <- read.graph(inputNetwork,format="ncol")
      if(edgeType=="weighted"){
        if(is.null(E(network)$weight)){
          stop("The input network does not contain edge weights. Please add the edge weights or change parameter 'edgeType' to 'unweigthed'!")
        }
      }else{
        if(!is.null(E(network)$weight)){
          stop("The input network contains edge weights. Please remove the edge weights or change parameter 'edgeType' to 'weigthed'!")
        }
      }
    }
  }else{
    if(.getClass(inputNetwork)=="data.frame" || .getClass(inputNetwork)=="matrix"){
      if(edgeType=="weighted"){
        if(ncol(inputNetwork)!=3){
          stop("Data object should contain three columns: interactor1, interactor2 and edge weight!")
        }else{
          weight <- inputNetwork[,3]
          if(!is.numeric(weight)){
            stop("The edge weight should be numeric!")
          }else{
            inputNetwork <- as.matrix(inputNetwork[,c(1,2)])
            inputNetwork_S <- as.character(inputNetwork)
            inputNetwork_S <- array(inputNetwork_S,dim=dim(inputNetwork))
            network <- graph.edgelist(inputNetwork_S,directed=F)
            E(network)$weight <- weight
          }
        }
      }else{
        if(ncol(inputNetwork)!=2){
          stop("data object should contain two columns!\n");
        }else{
          inputNetwork <- as.matrix(inputNetwork)
          inputNetwork_S <- as.character(inputNetwork)
          inputNetwork_S <- array(inputNetwork_S,dim=dim(inputNetwork))
          network <- graph.edgelist(inputNetwork_S,directed=F)
        }
      }
      rm(inputNetwork,inputNetwork_S)
      gc()
    }else{
      if(.getClass(inputNetwork)=="igraph"){
        if(edgeType=="unweighted"){
          if(!is.null(E(inputNetwork)$weight)){
            stop("The input network contains edge weights. Please remove the edge weights or change parameter 'edgeType' to 'weigthed'!")
          }else{
            network <- inputNetwork
          }
        }else{
          if(is.null(E(inputNetwork)$weight)){
            stop("The input network does not contain edge weights. Please add the edge weights or change parameter 'edgeType' to 'unweigthed'!")
          }else{
            network <- inputNetwork
          }
        }
        rm(inputNetwork)
        gc()
      }else{
        if(.getClass(inputNetwork)=="graphNEL"){
          network <- igraph.from.graphNEL(inputNetwork)
          if(edgeType=="unweighted"){
            if(!is.null(E(network)$weight)){
              stop("The input network contains edge weights. Please remove the edge weights or change parameter 'edgeType' to 'weigthed'!")
            }
          }else{
            if(is.null(E(network)$weight)){
              stop("The input network does not contain edge weights. Please add the edge weights or change parameter 'edgeType' to 'unweigthed'!")
            }
          }
          rm(inputNetwork)
          gc()
        }else{
          stop("The input network should be from a file or a data object with data.frame, matrix, graphNEL or igraph class. Other types of input are invalid!\n")
        }

      }
    }
  }

  if(outputFormat != "none" && missing(outputFileName)){
    stop("Please input the output file name!\n")
  }else{
    if(substr(outputFileName,nchar(outputFileName),nchar(outputFileName))=="/"){
      stop("Please input the output file name!\n")
    }
  }

  if(!(outputFormat %in% c("nsm","gmt","multiple","none"))){
    stop("The input 'outputFormat' is invalid! Please select an output format from 'nsm', 'gmt', 'multiple' and 'none'!\n")
  }

  if(!is.logical(map_to_genesymbol)){
    stop("The input 'map_to_genesymbol' is invalid! 'map_to_genesymbol' should only be TRUE or FALSE!\n")
  }

  if(!(organism %in% organisms)){
    stop("Currently, the package supports the following nine organisms: hsapiens, mmusculus, rnorvegicus, drerio, celegans, scerevisiae, cfamiliaris, dmelanogaster and athaliana!")
  }

  if(minModule<0 || minModule>0.2){
    stop("The input 'minModule' is invalid! 'minModule' should be between 0 and  0.2!\n")
  }

  if(maxStep<2 || .getClass(maxStep)!="numeric"){
    stop("The input 'maxStep' is invalid! 'maxStep' should be a number and larger than 2!\n")
  }

  if(!(moduleSigMethod %in% c("cutoff","zscore","permutation"))){
    stop("The input 'moduleSigMethod' is invalid! Please select an option from 'cutoff','zscore' and 'permutation'!\n")
  }

  if(modularityThr>1 || modularityThr<0 || .getClass(modularityThr)!="numeric"){
    stop("The input 'modularityThr' is invalid! 'modularityThr' should be a positive number and less than 1!\n")
  }

  if(ZRanNum<10 || .getClass(ZRanNum)!="numeric"){
    stop("The input 'ZRanNum' is invalid! 'ZRanNum' should be a number and larger than 10!\n")
  }

  if(PerRanNum<10 || .getClass(PerRanNum)!="numeric"){
    stop("The input 'PerRanNum' is invalid! 'PerRanNum' should be a number and larger than 10!\n")
  }

  if(ranSig>1 || ranSig <0 || .getClass(ranSig)!="numeric"){
    stop("The input 'ranSig' is invalid! 'ranSig' should be a positive number and less than 1!\n")
  }

  if(edgeThr<(-1) || .getClass(edgeThr)!="numeric"){
    stop("The input 'edgeThr' is invalid! 'edgeThr' should be -1 or a positive number!\n")
  }

  if(nodeThr<(-1) || .getClass(nodeThr)!="numeric"){
    stop("The input 'nodeThr' is invalid! 'nodeThr' should be -1 or a positive number!\n")
  }

  if(nThreads<1 || .getClass(nThreads)!="numeric"){
    stop("The input 'nThreads' is invalid! 'nThreads' should be a number and greater than 1!\n")
  }

  if(!is.simple(network)){
    warning("The input network contain loop or multiple edges. For unweighted network, NetSAM will remove loop or multiple edges. For weighted network, NetSAM will sum the weights from loop or multiple edges!!!")
    network <- simplify(network)
  }

  if(nodeThr!=(-1)){
    if(vcount(network)>nodeThr){
      stop("The number of nodes in the network is over the threshold ",nodeThr,". Please adjust the parameters to decrease the network size!\n")
    }
  }

  if(edgeThr!=(-1)){
    if(ecount(network)>edgeThr){
      stop("The number of edges in the network is over the threshold ",edgeThr,". Please adjust the parameters to decrease the network size!\n")
    }
  }


  ###################Get the whole gene symbols for the given organism###################
  if(organism=="scerevisiae"){
    #require("org.Sc.sgd.db") || stop("package org.Sc.sgd.db is required!!\n")
    genesymbol <- keys(eval(parse(text="org.Sc.sgd.db::org.Sc.sgdCOMMON2ORF")))
  }else{
    if(organism=="athaliana"){
      #require("org.At.tair.db") || stop("package org.At.tair.db is required!!\n")
      genesymbol <- unlist(as.list(eval(parse(text="org.At.tair.db::org.At.tairSYMBOL"))))
      names(genesymbol) <- NULL
      genesymbol <- unique(genesymbol)
      genesymbol <- genesymbol[!is.na(genesymbol)]
    }else{
      or <- names(organisms)[which(organisms==organism)]
      #require(paste("org.",or,".eg.db",sep=""),character.only = TRUE) || stop(paste("package org.", or, ".eg.db is required!!\n", sep=""))
      genesymbol <- keys(eval(parse(text=paste("org.",or,".eg.db::","org.",or,".egSYMBOL2EG",sep=""))))
    }
  }
  ########################################################################################

  geneid <- V(network)$name

  is.genesymbol <- FALSE
  if(length(intersect(geneid,genesymbol))>0.6*length(geneid)){
    is.genesymbol <- TRUE
  }else{
    is.genesymbol <- FALSE
  }

  mapping.status <- 0

  if(map_to_genesymbol==TRUE){
    ne <- mapToSymbol(inputData=network,organism=organism,inputType="network",idType=idType, edgeType=edgeType, verbose=TRUE)
    if(!is.null(ne)){
      network_edgelist <- ne$network
      netMat <- as.matrix(network_edgelist[,c(1,2)])
      network <- graph.edgelist(netMat,directed=FALSE)
      if(edgeType=="weighted"){
        E(network)$weight <- network_edgelist[,3]
      }
      mapping.status <- 0
    }else{
      stop("Please check the parameter 'idType' or set the parameter 'map_to_genesymbol' as FALSE!\n")
    }
  }else{
    if(is.genesymbol==TRUE){
      mapping.status <- 0
    }else{
      if(idType==""){     #NONE OF THE ABOVE
        mapping.status <- 1
      }else{
        ne <- mapToSymbol(inputData=network,organism=organism,inputType="network",idType=idType,edgeType=edgeType,verbose=FALSE)
        if(!is.null(ne)){
          idmap <- ne$idmap
          mapping.status <- 2
        }else{
          mapping.status <- 1
        }
      }
    }
  }

  minModule <- round(vcount(network)*minModule)
  if(minModule<5){
    minModule <- 5
  }

  enableWGCNAThreads()
  threNum <- WGCNAnThreads()
  if(threNum>nThreads){
    threNum <- nThreads
  }

  network_module <- .identifyModule(network,minModule,stepIte,maxStep,moduleSigMethod,modularityThr,ZRanNum,PerRanNum,ranSig,threNum,edgeType)
  geneorder <- network_module$geneorder
  disableWGCNAThreads()

  if(outputFormat=="nsm" || outputFormat=="none" || outputFormat=="multiple"){

    network_edges <- get.edgelist(network)
    if(edgeType=="weighted"){
      if(ecount(network)>500000){
        warning("The input weighted network contain over 500,000 edges. Because nsm file contains edge information, remaining all edges of the network will cause a very large size of nsm file, which will be difficult to upload to NetGestalt. NetSAM only remains top 500,000 edges based on the edge weights from largest to smallest!!\n")
        w <- E(network)$weight
        w <- order(w,decreasing=T)
        network_edges <- network_edges[w,]
        network_edges <- network_edges[1:500000,]
      }
    }

    hmiFile <- .createHMIFile(network_module$allHir,geneorder)

    rownames(geneorder) <- geneorder[,4]
    netgestalt <- list(rulfile=geneorder,hmifile=hmiFile,network=network_edges)

    if(outputFormat=="multiple"){
      outputFile <- paste(outputFileName,"_rulerfile.rul",sep="")
      write.table(geneorder,file=outputFile,row.names=F,col.names=T,sep="\t",quote=F)

      outputFile <- paste(outputFileName,"_hmifile.hmi",sep="")
      write.table(hmiFile,file=outputFile,row.names=F,col.names=T,sep="\t",quote=F)

      outputFile <- paste(outputFileName,"_network.net",sep="")
      write.table(network_edges,file=outputFile,row.names=F,col.names=F,sep="\t",quote=F)

    }

    if(outputFormat=="nsm"){
      outputFile <- paste(outputFileName,".nsm",sep="")
      note <- "##  Ruler file  ##"
      write.table(note,file=outputFile,row.names=F,col.names=F,quote=F)
      suppressWarnings(write.table(geneorder,file=outputFile,row.names=F,col.names=T,append=T,quote=F,sep="\t"))
      note <- "##  HMI file ##"
      write.table(note,file=outputFile,row.names=F,col.names=F,quote=F,append=T)
      suppressWarnings(write.table(hmiFile,file=outputFile,row.names=F,col.names=T,quote=F,append=T,sep="\t"))
      note <- "##  Network file  ##"
      write.table(note,file=outputFile,row.names=F,col.names=F,quote=F,append=T)
      write.table(network_edges,file=outputFile,row.names=F,col.names=F,quote=F,append=T,sep="\t")

      netgestalt$mapping.status <- mapping.status

      note <- "##  Mapping Status  ##"
      write.table(note,file=outputFile,row.names=F,col.names=F,quote=F,append=T)
      suppressWarnings(write.table(paste("mapping.status=",mapping.status,sep=""),file=outputFile,row.names=F,col.names=F,quote=F,append=T,sep="\t"))


      if(mapping.status==2){
        note <- "##  Gene Annotation  ##"
        write.table(note,file=outputFile,row.names=F,col.names=F,quote=F,append=T)
        suppressWarnings(write.table(idmap,file=outputFile,row.names=F,col.names=T,quote=F,append=T,sep="\t"))
        netgestalt$geneAnn <- idmap
      }

    }

    cat("NetSAM identified ",(nrow(hmiFile)-1)," modules in ",(length(unique(hmiFile[,2]))-1)," levels!\n",sep="")
    cat("Processing completed!\n\n")
    return(netgestalt)


  }else{
    hmiFile <- .createHMIFile(network_module$allHir,geneorder)
    gmtFile <- .createGMTFile(hmiFile,geneorder)
    outputFile1 <- paste(outputFileName,".gmt",sep="")
    write.table(gmtFile,file=outputFile1,row.names=F,col.names=F,sep="\t",quote=F)
    result <- gmtFile
    cat("NetSAM identified ",(nrow(hmiFile)-1)," modules in ",(length(unique(hmiFile[,2]))-1)," levels!\n",sep="")
    cat("Processing completed!\n\n")
    return(result)
  }

}


.identifyModule <- function(network, minModule, stepIte, maxStep, moduleSigMethod, modularityThr, ZRanNum, PerRanNum, ranSig, threNum, edgeType){

  cat("\nIdentifying the hierarchical modules of the network...\n")
  overlap_genesymbol_networkP <- V(network)$name
  subnetworkInfo <- list()
  subnetworkInfo_index <- 1
  network_cluster <- clusters(network)
  network_cluster_size <- network_cluster$csize

  if(length(network_cluster_size[network_cluster_size>=minModule])==0){
    stop("The size of all subnetworks are less than ",minModule,". Please adjust the parameter 'minModule'!\n\n")
  }

  network_cluster_size <- data.frame(id=c(1:length(network_cluster_size)),cluster_size=network_cluster_size,stringsAsFactors=F)
  network_cluster_size <- network_cluster_size[order(-network_cluster_size[,2]),]
  network_cluster_membership <- network_cluster$membership

  network_ordered_node <- vector()
  subnetwork_id <- 1
  for(i in c(1:nrow(network_cluster_size))){
    sub_network_size <- network_cluster_size[i,2]
    if(sub_network_size>=minModule){
      cat("Starting to analysis connected component ",subnetwork_id,"!\n",sep="")
      subnetwork_id <- subnetwork_id+1
      subnetwork_node <- overlap_genesymbol_networkP[which(network_cluster_membership==network_cluster_size[i,1])]
      subnetwork <- .extractSubNetwork(network,subnetwork_node,edgeType)
      allHir <- .identifyHierOr(subnetwork, minModule, stepIte, maxStep, moduleSigMethod, modularityThr, ZRanNum, PerRanNum, ranSig, threNum, edgeType)
      subnetworkInfo[[subnetworkInfo_index]] <- allHir
      subnetworkInfo_index <- subnetworkInfo_index+1
      network_ordered_node <- c(network_ordered_node,subnetwork_node)
      cat("\n")
    }
  }
  cat("\nReordering the genes in the one dimentional layout...\n")
  geneorder <- data.frame(ruler_id=c(1:length(overlap_genesymbol_networkP)),node_type="Gene",node_db="Entrez Gene",node_db_id=overlap_genesymbol_networkP,node_name=overlap_genesymbol_networkP,stringsAsFactors=F)
  rownames(geneorder) <- overlap_genesymbol_networkP
  unann_node <- setdiff(overlap_genesymbol_networkP,network_ordered_node)
  if(length(unann_node) !=0){
    network_ordered_node <- c(network_ordered_node,unann_node)
  }
  geneorder <- geneorder[network_ordered_node,]


  geneorder <- .orderDiffLevel(subnetworkInfo,geneorder)

  result <- list(network=network,allHir=subnetworkInfo,geneorder=geneorder)
  return(result)
}


.calculateRandomWalkerAdjectMatrix <- function(network_igraph,step,edgeType){

  #calculate the random walk distance for the network
  protein_in_ppi <- V(network_igraph)$name
  if(edgeType=="unweighted"){
    E(network_igraph)$weight <- rep(1,ecount(network_igraph))
  }

  nweight <- graph.strength(network_igraph,mode="all")
  V(network_igraph)$weight <- as.numeric(nweight)


  eweight <- E(network_igraph)$weight

  degree_node <- igraph::degree(network_igraph)
  network_igraph <- add.edges(network_igraph,rbind(protein_in_ppi,protein_in_ppi)) #walktrap algorithm adds all self interactions for each node
  E(network_igraph)$weight <- c(eweight,V(network_igraph)$weight/degree_node)
  V(network_igraph)$weight <- V(network_igraph)$weight+ V(network_igraph)$weight/degree_node

  nweight <- V(network_igraph)$weight

  adjMatrix <- get.adjacency(network_igraph,attr="weight")
  adjMatrix <- as.matrix(adjMatrix)

  W_weighted <- adjMatrix/nweight

  rm(adjMatrix,network_igraph,eweight,degree_node)
  gc()

  #cat("Create transition Matrix...\n")

  tranM <- W_weighted

  if(step>1){
    for(i in c(1:(step-1))){
      tranM <- tranM%*%W_weighted
    }
  }

  rm(W_weighted)
  gc()

  #tranM <- as.matrix(tranM)

  tranM <- t(tranM)/sqrt(nweight)
  tranM <- t(tranM)

  #cat("Calculate EU distance...\n")

  smat <- apply(tranM,1,crossprod)
  mat1 <- matrix(smat,nrow=length(protein_in_ppi),ncol=length(protein_in_ppi))
  mat3 <- tcrossprod(tranM)
  mat4 <- mat1+t(mat1)-2*mat3
  rm(smat,mat1,mat3,tranM)
  gc()
  mat4[mat4<0] <- 0
  diag(mat4) <- 0
  mat4 <- sqrt(mat4)

  return(mat4)
}


.transformFromWalktrapToHclust <- function(walktrap){

  #transform walktrap to hclust

  merge <- walktrap$merges
  name <- walktrap$names
  N <- length(name)

  merge[which(merge[,1]<=N),1] <- (-merge[which(merge[,1]<=N),1])
  merge[which(merge[,2]<=N),2] <- (-merge[which(merge[,2]<=N),2])

  merge[which(merge[,1]>N),1] <- (merge[which(merge[,1]>N),1]-N)
  merge[which(merge[,2]>N),2] <- (merge[which(merge[,2]>N),2]-N)

  height <- c(1:(N-1))

  dend <- as.dendrogram(walktrap)
  order <- order.dendrogram(dend)

  labels <- name

  ht <- list(merge=merge,height=height,order=order,labels=labels,method="walktrap",call=match.call(),dist.method="randomwalk")

  class(ht) <- "hclust"

  return(ht)
}

.walktrapcommunity <- function(network_igraph,steps,edgeType){
  if(edgeType=="weighted"){
    network_walktrap <- walktrap.community(network_igraph,weights=E(network_igraph)$weight,steps=steps)
  }else{
    network_walktrap <- walktrap.community(network_igraph,steps=steps)
  }
  return(network_walktrap)
}

.evaluateWalktrapStep <- function(network_igraph,stepIte,maxStep,level,threNum,edgeType,subM){

  #evaluate the optimal Step for the network

  if(stepIte==FALSE || maxStep==2 || level==1){
    network_walktrap <- .walktrapcommunity(network_igraph,steps=maxStep,edgeType)
    network_adjMatrix <- .calculateRandomWalkerAdjectMatrix(network_igraph,maxStep,edgeType)
    rm(network_igraph)
    gc()
    network_adjMatrix <- as.dist(network_adjMatrix)
    network_hclust <- .transformFromWalktrapToHclust(network_walktrap)
    network_order <- seriate(network_adjMatrix,method="OLO",control=list(hclust=network_hclust))
    network_order <- get_order(network_order)
    network_info <- list(gene=network_walktrap$names,membership=network_walktrap$membership,modularity=max(network_walktrap$modularity),step=maxStep,order=network_order,level=level)
    return(network_info)
  }else{

    if(maxStep < threNum){
      threNum <- maxStep
      perN <- 1
    }else{
      perN <- floor((maxStep-1)/threNum)
    }


    cl <- makeCluster(threNum)
    registerDoParallel(cl)


    i <- 1
    optimalM <- foreach(i=1:threNum, .packages="igraph") %dopar% {
      finalStep <- data.frame(step=0,modularity=1,stringsAsFactors=F)
      fi <- 1
      if(i==1){
        step_start <- 2
        step_end <- i*perN+1
      }else{
        step_start <- i*perN-(perN-2)
        if(i==threNum){
          step_end <- maxStep
        }else{
          step_end <- i*perN+1
        }
      }
      for(j in c(step_start:step_end)){
        if(edgeType=="weighted"){
          w <- walktrap.community(network_igraph,weights=E(network_igraph)$weight,steps=j)
        }else{
          w <- walktrap.community(network_igraph,steps=j)
        }
        m <- max(w$modularity)
        finalStep[fi,1] <- j
        finalStep[fi,2] <- m
        fi <- fi + 1
      }

      return(finalStep)
    }
    stopCluster(cl)

    finalStep <- data.frame(step=0,modularity=1,stringsAsFactors=F)
    for(i in c(1:length(optimalM))){
      finalStep <- rbind(finalStep,optimalM[[i]])
    }
    finalStep <- finalStep[finalStep[,1]!=0,]
    finalStep <- finalStep[order(-finalStep[,2],finalStep[,1]),]

    optimalStep <- finalStep[1,1]
    cat("The optimal Step of network ",subM," is ",optimalStep," !\n",sep="")

    optimalwalktrap <- .walktrapcommunity(network_igraph,steps=optimalStep,edgeType)
    network_adjMatrix <- .calculateRandomWalkerAdjectMatrix(network_igraph,optimalStep,edgeType)
    rm(network_igraph)
    gc()
    network_adjMatrix <- as.dist(network_adjMatrix)
    network_hclust <- .transformFromWalktrapToHclust(optimalwalktrap)
    network_order <- seriate(network_adjMatrix,method="OLO",control=list(hclust=network_hclust))
    network_order <- get_order(network_order)
    maxWalktrap <- list(gene=optimalwalktrap$names,membership=optimalwalktrap$membership,modularity=max(optimalwalktrap$modularity),step=optimalStep,order=network_order,level=level)
    return(maxWalktrap)
  }
}


.identifySig_Unweighted <- function(network_igraph,network_modularity,step,moduleSigMethod,modularityThr, ZRanNum, PerRanNum, ranSig, threNum){

  #identify whether the network can be separated again

  degree <- igraph::degree(network_igraph)
  sig <- 0
  i <- 1

  if(moduleSigMethod=="cutoff"){
    if(network_modularity>modularityThr){
      sig <- 1
    }
  }

  if(moduleSigMethod=="zscore"){

    if(ZRanNum<threNum){
      threNum <- ZRanNum
      perN <- 1
    }else{
      perN <- floor(ZRanNum/threNum)
    }


    cl <- makeCluster(threNum)
    registerDoParallel(cl)

    ranmodu <- foreach(i=1:threNum, .combine="c", .packages="igraph") %dopar%{

      randomM <- c()

      rN <- perN
      if(i==threNum){
        rN <- ZRanNum-(i-1)*perN
      }

      for(j in c(1:rN)){
        suppressWarnings(rannet <- degree.sequence.game(degree,method="vl"))
        ran_walktrap <- walktrap.community(rannet,steps=step)
        ranModularity <- max(ran_walktrap$modularity)
        randomM <- c(randomM,ranModularity)
      }
      return(randomM)
    }
    stopCluster(cl)

    ranmodu_mean <- mean(ranmodu)
    ranmodu_sd <- sd(ranmodu)
    if(ranmodu_sd == 0){
      if(network_modularity>ranmodu_mean){
        sig <- 1
      }
    }else{
      Z_network_modularity <- (network_modularity-ranmodu_mean)/ranmodu_sd
      p <- pnorm(Z_network_modularity,mean=0,sd=1,lower.tail=F)
      if(p<ranSig){
        sig <- 1
      }
    }
  }

  if(moduleSigMethod=="permutation"){

    if(PerRanNum<threNum){
      threNum <- PerRanNum
      perN <- 1
    }else{
      perN <- floor(PerRanNum/threNum)
    }


    cl <- makeCluster(threNum)
    registerDoParallel(cl)

    ranmodu <- foreach(i=1:threNum, .combine="c", .packages="igraph") %dopar%{

      randomM <- c()

      rN <- perN
      if(i==threNum){
        rN <- PerRanNum-(i-1)*perN
      }

      for(j in c(1:rN)){

        suppressWarnings(rannet <- degree.sequence.game(degree,method="vl"))
        ran_walktrap <- walktrap.community(rannet,steps=step)
        ranModularity <- max(ran_walktrap$modularity)
        randomM <- c(randomM,ranModularity)
      }
      return(randomM)
    }
    stopCluster(cl)

    p <- length(ranmodu[ranmodu>=network_modularity])/PerRanNum
    if(p<ranSig){
      sig <- 1
    }
  }

  return(sig)
}


.identifySig_Weighted <- function(network_igraph, network_modularity, step, moduleSigMethod, modularityThr, ZRanNum, PerRanNum, ranSig, threNum){

  #identify whether the network can be separated again


  sig <- 0
  i <- 1
  if(moduleSigMethod=="cutoff"){
    if(network_modularity>modularityThr){
      sig <- 1
    }
  }

  if(moduleSigMethod=="zscore"){

    #network_igraph <- network_info$network
    weight <- E(network_igraph)$weight
    #ranmodu <- vector()
    #step <- network_info$step

    if(ZRanNum<threNum){
      threNum <- ZRanNum
      perN <- 1
    }else{
      perN <- floor(ZRanNum/threNum)
    }

    cl <- makeCluster(threNum)
    registerDoParallel(cl)

    ranmodu <- foreach(i=1:threNum, .combine="c", .packages="igraph") %dopar%{

      randomM <- c()

      rN <- perN
      if(i==threNum){
        rN <- ZRanNum-(i-1)*perN
      }

      for(j in c(1:rN)){

        ranWeight <- sample(weight,length(weight))
        ranModularity <- max(walktrap.community(network_igraph,weights=ranWeight,steps=step)$modularity)
        randomM <- c(randomM,ranModularity)
      }
      return(randomM)
    }
    stopCluster(cl)
    rm(network_igraph,weight)
    gc()
    #cat("randomMo:",ranmodu,"\n")
    ranmodu_mean <- mean(ranmodu)
    ranmodu_sd <- sd(ranmodu)
    if(ranmodu_sd == 0){
      if(network_modularity>ranmodu_mean){
        sig <- 1
      }
    }else{
      Z_network_modularity <- (network_modularity-ranmodu_mean)/ranmodu_sd
      p <- pnorm(Z_network_modularity,mean=0,sd=1,lower.tail=F)
      if(p<ranSig){
        sig <- 1
      }
    }
  }

  if(moduleSigMethod=="permutation"){

    #network_igraph <- network_info$network
    weight <- E(network_igraph)$weight
    #step <- network_info$step

    if(PerRanNum<threNum){
      threNum <- PerRanNum
      perN <- 1
    }else{
      perN <- floor(PerRanNum/threNum)
    }

    cl <- makeCluster(threNum)
    registerDoParallel(cl)

    ranmodu <- foreach(i=1:threNum, .combine="c", .packages="igraph") %dopar%{

      randomM <- c()

      rN <- perN
      if(i==threNum){
        rN <- PerRanNum-(i-1)*perN
      }

      for(j in c(1:rN)){

        ranWeight <- sample(weight,length(weight))
        ranModularity <- max(walktrap.community(network_igraph,weights=ranWeight,steps=step)$modularity)
        randomM <- c(randomM,ranModularity)
      }
      return(randomM)
    }
    stopCluster(cl)
    rm(network_igraph,weight)
    gc()

    p <- length(ranmodu[ranmodu>=network_modularity])/PerRanNum
    if(p<ranSig){
      sig <- 1
    }
  }

  return(sig)
}


.identifySig <- function(network_igraph, network_modularity, step, moduleSigMethod, modularityThr, ZRanNum, PerRanNum, ranSig, threNum, edgeType){
  if(edgeType=="weighted"){
    sig <- .identifySig_Weighted(network_igraph, network_modularity, step, moduleSigMethod, modularityThr, ZRanNum, PerRanNum, ranSig, threNum)
  }else{
    sig <- .identifySig_Unweighted(network_igraph, network_modularity, step, moduleSigMethod, modularityThr, ZRanNum, PerRanNum, ranSig, threNum)
  }

  return(sig)
}


.identifyHierOr <- function(network_maxComponent, minModule, stepIte, maxStep, moduleSigMethod, modularityThr, ZRanNum, PerRanNum, ranSig, threNum, edgeType){

  #identify hierarchical organization of network

  allHir <- list()
  ai <- 1
  sigHir <- vector()
  si <- 1

  start <- 1

  cat("Evaluating networks in Level 1 ...\n")

  levelid <- 2

  network_info <- .evaluateWalktrapStep(network_maxComponent, stepIte, maxStep, level=1, threNum, edgeType, subM=1)
  cat("Network modularity: ",network_info$modularity,"\n\n",sep="")

  network_sig <- .identifySig(network_maxComponent, network_info$modularity, network_info$step, moduleSigMethod, modularityThr, ZRanNum, PerRanNum, ranSig, threNum, edgeType)

  allHir[[ai]] <- network_info
  rm(network_info)
  gc()


  if(network_sig==1){
    sigHir <- c(sigHir,ai)
    si <- si+1
  }

  ai <- ai+1

  while(length(sigHir)>0 && start!=si){
    currentPos <- sigHir[start]
    currentNetwork <- allHir[[currentPos]]
    start <- start+1

    currentNetwork_level <- currentNetwork$level
    currentNetwork_node <- currentNetwork$gene

    currentNetwork_membership <- currentNetwork$membership
    currentNetwork_membership <- data.frame(node=currentNetwork_node,membership=currentNetwork_membership,stringsAsFactors=F)
    currentNetwork_membership_count <- tapply(currentNetwork_membership[,1],currentNetwork_membership[,2],length)
    currentNetwork_membership_count <- currentNetwork_membership_count[currentNetwork_membership_count>=minModule]

    if(length(currentNetwork_membership_count)==0){
      next
    }

    currentNetwork_membership_group <- as.integer(names(currentNetwork_membership_count))
    rm(currentNetwork_membership_count,currentNetwork_node)
    gc()

    subLevel <- currentNetwork_level+1
    if(subLevel==levelid){
      cat("Evaluating networks in Level ",levelid," ...\n",sep="")
      levelid <- levelid+1
      subM <- 1
    }
    for(i in c(1:length(currentNetwork_membership_group))){
      subnetwork_node <- currentNetwork_membership[currentNetwork_membership[,2]==currentNetwork_membership_group[i],1]
      subnetwork_igraph <- .extractSubNetwork(network_maxComponent,subnetwork_node,edgeType)
      subnetwork_info <- .evaluateWalktrapStep(subnetwork_igraph, stepIte, maxStep, subLevel, threNum, edgeType, subM)
      cat("Modularity of network ",subM,": ",subnetwork_info$modularity,"\n\n",sep="")
      subnetwork_sig <- .identifySig(subnetwork_igraph, subnetwork_info$modularity, subnetwork_info$step, moduleSigMethod, modularityThr, ZRanNum, PerRanNum, ranSig, threNum, edgeType)

      allHir[[ai]] <- subnetwork_info
      rm(subnetwork_node,subnetwork_igraph,subnetwork_info)
      gc()

      if(subnetwork_sig==1){
        sigHir <- c(sigHir,ai)
        si <- si+1
      }

      ai <- ai+1
      subM <- subM + 1
    }
  }

  return(allHir)
}


.orderDiffLevel <- function(subnetworkInfo,geneorder){

  #reorder all genes in the network according to the optimal position in each level

  for(l in c(1:length(subnetworkInfo))){
    allHir <- subnetworkInfo[[l]]

    for(i in c(1:length(allHir))){
      ori <- allHir[[i]]$order
      node <- allHir[[i]]$gene
      node <- node[ori]
      node <- data.frame(id=c(1:length(node)),name=node,stringsAsFactors=F)
      node <- node[order(node[,2]),]

      geneorder_subpos <- which(geneorder[,5] %in% node[,2])
      geneorder_sub <- geneorder[geneorder_subpos,]
      geneorder_sub <- geneorder_sub[order(geneorder_sub[,5]),]
      geneorder_sub <- cbind(geneorder_sub,node[,1])
      geneorder_sub <- geneorder_sub[order(geneorder_sub[,6]),]
      geneorder_sub <- geneorder_sub[,c(1:5)]
      geneorder[geneorder_subpos,] <- geneorder_sub

    }

  }
  geneorder[,1] <- c(1:nrow(geneorder))
  return(geneorder)
}

.createHMIFile <- function(subnetworkInfo,geneorder){
  #create HMI file
  hmiFile <- data.frame(best="N",level=0,order=1,name="ALL",start=1,end=nrow(geneorder),stringsAsFactors=F)
  hi <- 2
  for(l in c(1:length(subnetworkInfo))){
    allHir <- subnetworkInfo[[l]]
    for(i in c(1:length(allHir))){
      node <- allHir[[i]]$gene
      position <- which(geneorder[,5] %in% node)
      start <- min(position)
      end <- max(position)
      level <- allHir[[i]]$level
      if(level==2){
        best <- "Y"
      }else{
        best <- "N"
      }
      hmiFile[hi,1] <- best
      hmiFile[hi,2] <- level
      hmiFile[hi,3] <- 0
      hmiFile[hi,4] <- ""
      hmiFile[hi,5] <- start
      hmiFile[hi,6] <- end
      hi <- hi+1
    }
  }

  hmiFile <- hmiFile[order(hmiFile[,2],hmiFile[,5]),]
  allLevel <- sort(unique(hmiFile[,2]))
  for(i in c(1:length(allLevel))){
    position <- which(hmiFile[,2]==allLevel[i])
    start <- min(position)
    end <- max(position)
    hmiFile[start:end,3] <- c(1:(end-start+1))
  }
  hmiFile[,4] <- paste("Level",hmiFile[,2],"Module",hmiFile[,3],sep="_")
  return(hmiFile)
}


.createGMTFile <- function(hmiFile,geneorder){
  allgene <- geneorder[,4]
  allgene <- paste(allgene,collapse="\t")
  humancatfile <- data.frame(name="01",childnum=1,gene=allgene,start=1,end=nrow(geneorder),level=0,stringsAsFactors=F)

  for(i in c(2:nrow(hmiFile))){
    st <- hmiFile[i,5]
    en <- hmiFile[i,6]
    l <- hmiFile[i,2]
    for(j in c(1:nrow(humancatfile))){
      pl <- humancatfile[j,6]
      if(pl==(l-1)){
        ps <- humancatfile[j,4]
        pe <- humancatfile[j,5]
        if(st>=ps && en<=pe){
          pcu <- humancatfile[j,1]
          pcu_c <- humancatfile[j,2]
          if(pcu_c < 10){
            pcu_c <- paste("0",pcu_c,sep="")
          }else{
            pcu_c <- as.character(pcu_c)
          }

          c_cu <- paste(pcu,pcu_c,sep="-")
          humancatfile[j,2] <- humancatfile[j,2] + 1
          humancatfile[i,1] <- c_cu
          humancatfile[i,2] <- 1
          cg <- geneorder[c(st:en),4]
          cg <- paste(cg,collapse="\t")
          humancatfile[i,3] <- cg
          humancatfile[i,4] <- st
          humancatfile[i,5] <- en
          humancatfile[i,6] <- l
          break
        }
      }
    }
  }
  humancatfile[,7] <- humancatfile[,5]-humancatfile[,4]+1
  gmtFile <- humancatfile[,c(1,7,3)]
  return(gmtFile)
}


.extractSubNetwork <- function(network,subList,edgeType){
  if(edgeType=="unweighted"){
    x <- get.edgelist(network)
    x <- x[x[,1] %in% subList & x[,2] %in% subList,]
    network <- graph.edgelist(x,directed=F)
  }else{
    x <- get.edgelist(network)
    weight <- get.edge.attribute(network,"weight")
    ind <- which(x[,1] %in% subList & x[,2] %in% subList)
    x <- x[ind,]
    weight <- weight[ind]
    network <- graph.edgelist(x,directed=F)
    E(network)$weight <- weight
  }
  return(network)
}

## ----setup, include=FALSE-----------------------------------------------------
knitr::opts_chunk$set(echo = TRUE)
knitr::opts_chunk$set(eval = FALSE)
knitr::opts_chunk$set(tidy.opts=list(width.cutoff=65),tidy=TRUE)

## -----------------------------------------------------------------------------
#  install.packages("igraph")
#  install.packages("seriation")
#  install.packages("WGCNA")
#  install.packages("snow")
#  install.packages("doSNOW")
#  install.packages("foreach")
#  source("http://bioconductor.org/biocLite.R")
#  biocLite("biomaRt")
#  biocLite("GO.db")
#  install.packages("R2HTML")
#  install.packages("survival")

## ----eval=FALSE---------------------------------------------------------------
#  library("NetSAM")
#  inputNetworkDir <- system.file("extdata","exampleNetwork.net",package="NetSAM")
#  outputFileName <- paste(getwd(),"/NetSAM",sep="")
#  result <- NetSAM(inputNetwork=inputNetworkDir, outputFileName=outputFileName, outputFormat="nsm",
#  edgeType="unweighted", map_to_genesymbol=FALSE, organism="hsapiens", idType="auto", minModule=0.003,
#  stepIte=FALSE, maxStep=4, moduleSigMethod="cutoff", modularityThr=0.2, ZRanNum=10,
#  PerRanNum=100, ranSig=0.05, edgeThr=(-1), nodeThr=(-1), nThreads=3)

## -----------------------------------------------------------------------------
#  library("NetSAM")
#  inputNetwork <- system.file("extdata","exampleNetwork.net",package="NetSAM")
#  outputFileName <- paste(getwd(),"/NetSAM",sep="")
#  NetAnalyzer(inputNetwork,outputFileName,"unweighted")

## -----------------------------------------------------------------------------
#  library("NetSAM")
#  inputMatDir <- system.file("extdata","exampleExpressionData_nonsymbol.cct",package="NetSAM")
#  inputMat <- read.table(inputMatDir,header=TRUE,sep="\t",stringsAsFactors=FALSE,check.names=FALSE)
#  mergedData <- mergeDuplicate(id=inputMat[,1],data=inputMat[,2:ncol(inputMat)],collapse_mode="maxSD")

## -----------------------------------------------------------------------------
#  library("NetSAM")
#  print("transform ids from a gene list to gene symbols...")
#  geneListDir <- system.file("extdata","exampleGeneList.txt",package="NetSAM")
#  geneList <- read.table(geneListDir,header=FALSE,sep="\t",stringsAsFactors=FALSE)
#  geneList <- as.vector(as.matrix(geneList))
#  geneList_symbol <- mapToSymbol(inputData=geneList, organism="hsapiens", inputType="genelist",idType="affy_hg_u133_plus_2")
#  
#  print("transform ids in the input network to gene symbols...")
#  inputNetwork <- system.file("extdata","exampleNetwork_nonsymbol.net",package="NetSAM")
#  network_symbol <- mapToSymbol(inputData=inputNetwork,organism="hsapiens",inputType="network",idType="entrezgene",edgeType="unweighted")
#  
#  print("transform ids in the input matrix to gene symbols...")
#  inputMatDir <- system.file("extdata","exampleExpressionData_nonsymbol.cct",package="NetSAM")
#  matrix_symbol <- mapToSymbol(inputData=inputMatDir,organism="hsapiens",inputType="matrix",idType="affy_hg_u133_plus_2",collapse_mode="maxSD")
#  
#  print("transform ids in the sbt file to gene symbols...")
#  inputSBTDir <- system.file("extdata","exampleSBT.sbt",package="NetSAM")
#  sbt_symbol <- mapToSymbol(inputData= inputSBTDir,organism="hsapiens",inputType="sbt",idType="affy_hg_u133_plus_2")
#  
#  print("transform ids in the sct file to gene symbols...")
#  inputSCTDir <- system.file("extdata","exampleSCT.sct",package="NetSAM")
#  sct_symbol <- mapToSymbol(inputData= inputSCTDir,organism="hsapiens",inputType="sct",idType="affy_hg_u133_plus_2",collapse_mode="min")

## -----------------------------------------------------------------------------
#  library("NetSAM")
#  inputMatDir <- system.file("extdata","exampleExpressionData.cct",package="NetSAM")
#  matNetwork <- MatNet(inputMat=inputMatDir, collapse_mode="maxSD", naPer=0.7, meanPer=0.8, varPer=0.8,
#  corrType="spearman", matNetMethod="rank", valueThr=0.6, rankBest=0.003, networkType="signed",
#  netFDRMethod="BH", netFDRThr=0.05, idNumThr=(-1), nThreads=3)

## -----------------------------------------------------------------------------
#  library("NetSAM")
#  inputMatDir <- system.file("extdata","exampleExpressionData.cct",package="NetSAM")
#  data <- read.table(inputMatDir, header=TRUE, row.names=1, stringsAsFactors=FALSE)
#  net <- consensusNet(data=data, organism="hsapiens",bootstrapNum=10, naPer=0.5, meanPer=0.8,varPer=0.8,method="rank_unsig",value=3/1000,pth=1e-6, nMatNet=2, nThreads=4)

## -----------------------------------------------------------------------------
#  library("NetSAM")
#  inputMatDir <- system.file("extdata","exampleExpressionData.cct",package="NetSAM")
#  sampleAnnDir <- system.file("extdata","sampleAnnotation.tsi",package="NetSAM")
#  formatedData <- testFileFormat(inputMat=inputMatDir,sampleAnn=sampleAnnDir,collapse_mode="maxSD")

## -----------------------------------------------------------------------------
#  library("NetSAM")
#  inputMatDir <- system.file("extdata","exampleExpressionData.cct",package="NetSAM")
#  sampleAnnDir <- system.file("extdata","sampleAnnotation.tsi",package="NetSAM")
#  data(NetSAMOutput_Example)
#  outputHtmlFile <- paste(getwd(),"/featureAsso_HTML",sep="")
#  featureAsso <- featureAssociation(inputMat=inputMatDir, sampleAnn=sampleAnnDir, NetSAMOutput=netsam_output, outputHtmlFile=outputHtmlFile, CONMethod="spearman", CATMethod="kruskal", BINMethod="ranktest", fdrmethod="BH",pth=0.05,collapse_mode="maxSD")

## -----------------------------------------------------------------------------
#  library("NetSAM")
#  data(NetSAMOutput_Example)
#  outputHtmlFile <- paste(getwd(),"/GOAsso_HTML",sep="")
#  GOAsso <- GOAssociation(NetSAMOutput=netsam_output, outputHtmlFile=outputHtmlFile, organism="hsapiens", fdrmethod="BH", fdrth=0.05, topNum=5)

## -----------------------------------------------------------------------------
#  library("NetSAM")
#  inputMatDir <- system.file("extdata","exampleExpressionData.cct",package="NetSAM")
#  sampleAnnDir <- system.file("extdata","sampleAnnotation.tsi",package="NetSAM")
#  outputFileName <- paste(getwd(),"/MatSAM",sep="")
#  matModule <- MatSAM(inputMat=inputMatDir, sampleAnn=sampleAnnDir,
#                      outputFileName = outputFileName, outputFormat="msm",
#                      organism="hsapiens", map_to_symbol=FALSE, idType="auto", collapse_mode="maxSD", naPer=0.7, meanPer=0.8, varPer=0.8,
#  corrType="spearman", matNetMethod="rank",
#  valueThr=0.6, rankBest=0.003, networkType="signed", netFDRMethod="BH",
#  netFDRThr=0.05, minModule=0.003, stepIte=FALSE,
#  maxStep=4, moduleSigMethod="cutoff", modularityThr=0.2, ZRanNum=10, PerRanNum=100, ranSig=0.05, idNumThr=(-1), nThreads=3)

.getClass <- function(obj) {
   cls <- class(obj)
   return(cls[1])
}

mapToSymbol <- function(inputData,organism="hsapiens",inputType="genelist",idType="auto",edgeType="unweighted", collapse_mode="maxSD", is_outputFile=FALSE, outputFileName="", verbose=TRUE){
    
    organisms <- c("hsapiens","mmusculus","rnorvegicus","drerio","celegans","scerevisiae","cfamiliaris","dmelanogaster","athaliana")
    
    if(length(which(organisms==organism))==0){
        stop("Currently, the package supports the following nine organisms: hsapiens, mmusculus, rnorvegicus, drerio, celegans, scerevisiae, cfamiliaris, dmelanogaster and athaliana!")
    }

    
    if(length(which(inputType %in% c("genelist","network","sbt","sct","matrix")))==0){
        stop("The input 'inputType' is invalide! Please select an option from 'genelist', 'netwrok', 'sbt', 'sct', and 'matrix'!\n")
    }
    
    if(length(which(collapse_mode %in% c("mean","median","maxSD","maxIQR","max","min")))==0){
        stop("The input 'collapse_mode' is invalide! Please select an option from 'mean', 'median', 'maxSD',  'maxIQR', 'max' and 'min' (use mean, median, max standard derivation, max interquartile range, maximum and minimum of duplicate genes for each sample)!\n")
    }
    
    if(inputType=="genelist"){
        
        if(is_outputFile==TRUE && outputFileName==""){
            outputFileName <- "geneList_symbol.txt"
        }
        
        mapresult <- .GeneToSymbol(geneList=inputData,organism=organism,idType=idType,verbose=verbose)
        
        if(is.null(mapresult)){
            if(verbose==TRUE){
                stop("The ids can not be transformed to gene symbols! Please check whether the inut idType is correct!\n",sep="")
            }
            
        }else{
            if(.getClass(mapresult)=="numeric"){
                if(verbose==TRUE){
                    stop(paste("Only ",round(mapresult*100),"% ids can be transformed to gene symbols. Please check whether the inut idType is correct!\n",sep=""))
                }
                mapresult <- NULL
            }else{
                if(is_outputFile==TRUE){
                    write.table(mapresult,file=outputFileName,row.names=F,col.names=F,sep="\t",quote=F)
                }
            }
        }
    }
    
    if(inputType=="network"){
        
        if(is_outputFile==TRUE && outputFileName==""){
            outputFileName <- "network_symbol.net"
        }

        mapresult <- .NetToSymbol(inputNetwork=inputData, organism=organism, idType=idType, edgeType=edgeType, verbose=verbose)
        
        if(is.null(mapresult)){
            if(verbose==TRUE){
                stop("The ids in the input network can not be transformed to gene symbols! Please check whether the inut idType is correct!\n",sep="")
            }

        }else{
            if(.getClass(mapresult)=="numeric"){
                if(verbose==TRUE){
                    stop(paste("Only ",round(mapresult*100),"% ids in the input network can be transformed to gene symbols. Please check whether the inut idType is correct!\n",sep=""))
                }
                mapresult <- NULL
            }else{
                if(is_outputFile==TRUE){
                    net <- mapresult$network
                    write.table(net,file=outputFileName,row.names=F,col.names=F,sep="\t",quote=F)
                }
            }
        }
    }
    
    if(inputType=="matrix"){
        
        if(is_outputFile==TRUE && outputFileName==""){
            outputFileName <- "matrix_symbol.cct"
        }
        
        mapresult <- .MatToSymbol(inputMat=inputData, organism=organism, idType=idType, collapse_mode=collapse_mode, verbose=verbose)
        
        if(is.null(mapresult)){
            if(verbose==TRUE){
                stop("The ids in the input matrix can not be transformed to gene symbols! Please check whether the inut idType is correct!\n")
            }
        }else{
            if(.getClass(mapresult)=="numeric"){
                if(verbose==TRUE){
                    stop(paste("Only ",round(mapresult*100),"% ids in the input matrix can be transformed to gene symbols. Please check whether the inut idType is correct!\n",sep=""))
                }
                mapresult <- NULL
            }else{
                if(is_outputFile==TRUE){
                    matrix <- mapresult$data_symbol
                    matrix <- cbind(rownames(matrix),matrix)
                    colnames(matrix)[1] <- "GeneSymbol"
                    write.table(matrix,file=outputFileName,row.names=F,col.names=T,sep="\t",quote=F)
                }
            }
        }
    }
    
    if(inputType=="sbt"){
        if(is_outputFile==TRUE && outputFileName==""){
            outputFileName <- "sbt_symbol.sbt"
        }

        mapresult <- .sbtToSymbol(inputFile=inputData, organism=organism, idType=idType, verbose=verbose)
        
        if(is.null(mapresult)){
            if(verbose==TRUE){
                stop("The ids in the SBT file can not be transformed to gene symbols! Please check whether the inut idType is correct!\n")
            }
        }else{
            l <- mapresult$oriLength
            mapresult <- mapresult$transformedData
            
            if(l!=nrow(mapresult)){
                if(verbose==TRUE){
                    warning(paste("The ids in ",nrow(mapresult)," tracks among all ",l," tracks in the input SBT file can be transformed to gene symbols!\n",sep=""))
                }
            }
            
            if(is_outputFile==TRUE){
                    write.table(mapresult,file=outputFileName,row.names=F,col.names=F,sep="\t",quote=F)
            }
        }
    }
    
    if(inputType=="sct"){
        
        if(is_outputFile==TRUE && outputFileName==""){
            outputFileName <- "sct_symbol.sct"
        }

        
        mapresult <- .sctToSymbol(inputFile=inputData, organism=organism, idType=idType, verbose=verbose, collapse_mode=collapse_mode)
        
        if(is.null(mapresult)){
            if(verbose==TRUE){
                stop("The ids in the SCT file can not be transformed to gene symbols! Please check whether the inut idType is correct!\n")
            }
        }else{
            if(.getClass(mapresult)=="numeric"){
                if(verbose==TRUE){
                    stop(paste("Only ",round(mapresult*100),"% ids in the SCT file can be transformed to gene symbols. Please check whether the inut idType is correct!\n",sep=""))
                }
                mapresult <- NULL
            }else{
            		sctM <- mapresult$sct_symbol
            		sctM <- cbind(rownames(sctM),sctM)
            		colnames(sctM)[1] <- "GeneSymbol"
                if(is_outputFile==TRUE){
                    write.table(sctM,file=outputFileName,row.names=F,col.names=T,sep="\t",quote=F)
                }
            }
        }
    }
    
    return(mapresult)
}

.GeneToSymbol <-
function(geneList, organism="hsapiens", idType="auto",verbose=TRUE){
	
    
    
    #require(biomaRt) || stop("Package biomaRt version 2.18.0 is required!")
    
    if(!is.null(dim(geneList))){
        stop("The input gene list should be a vector!!\n")
    }
   
   if(organism=="athaliana"){
       mart <- useMart("plants_mart",host="plants.ensembl.org")
       m <- try(mart <- useDataset(paste(organism,"_eg_gene",sep=""),mart),silent=TRUE)
   }else{
       mart <- useMart("ENSEMBL_MART_ENSEMBL",host="www.ensembl.org")
       m <- try(mart <- useDataset(paste(organism,"_gene_ensembl",sep=""),mart),silent=TRUE)
   }
   
    
    if(.getClass(m)=="try-error"){
        stop(paste("The function can not connect to Biomart. Please try again!\n",sep=""))
    }
    
    
    allMartAttr <- listAttributes(mart)
    allFilter <- listFilters(mart)
    
    finalAttr <- intersect(allMartAttr[,1],allFilter[,1])
    
    genesymbol <- ""
    
    if(organism=="hsapiens"){
        noAttr <- c("strand","transcript_status","atlas_diseasestate","transcript_count","phenotype_description","source","go_id","transcript_source","goslim_goa_accession","ens_hs_gene","chromosome_name","status","mim_morbid_accession","atlas_celltype","germ_line_variation_source")
        genesymbol <- "hgnc_symbol"
    }
    
    if(organism=="mmusculus"){
        noAttr <- c("chromosome_name","go_id","goslim_goa_accession","strand","ikmcs_no_products_available_yet","status","germ_line_variation_source","hgnc_id","hgnc_symbol","hgnc_transcript_name","prints","phenotype_description","source")
        genesymbol <- "mgi_symbol"
    }
    
    if(organism=="rnorvegicus"){
        noAttr <- c("chromosome_name","go_id","goslim_goa_accession","strand","status","germ_line_variation_source","mgi_id","mgi_symbol","mgi_transcript_name","prints","source","transcript_source","transcript_count","transcript_biotype","transcript_status")
        genesymbol <- "rgd_symbol"
    }
    
    if(organism=="drerio"){
        noAttr <- c("chromosome_name","go_id","goslim_goa_accession","strand","status","status","germ_line_variation_source","hgnc_id","hgnc_symbol","hgnc_transcript_name","prints","phenotype_description","source","transcript_source","transcript_count","transcript_biotype","transcript_status")
        genesymbol <- "zfin_symbol"
    }
    
    if(organism=="celegans"){
         noAttr <- c("chromosome_name","go_id","prints","source","status","strand","transcript_source","transcript_count","transcript_biotype","transcript_status")
         genesymbol <- "wormbase_locus"
    }
    
    if(organism=="scerevisiae"){
        noAttr <- c("chromosome_name","germ_line_variation_source","go_id","goslim_goa_accession","prints","source","status","strand","transcript_source","transcript_count","transcript_biotype","transcript_status")
        genesymbol <- "external_gene_name"
    }
    
    if(organism=="cfamiliaris"){
        noAttr <- c("chromosome_name","germ_line_variation_source","go_id","goslim_goa_accession","hgnc_id","hgnc_symbol","hgnc_transcript_name","phenotype_description","prints","source","status","strand","transcript_source","transcript_count","transcript_biotype","transcript_status")
        genesymbol <- "external_gene_name"
    }
    
    if(organism=="dmelanogaster"){
        noAttr <- c("chromosome_name","germ_line_variation_source","go_id","goslim_goa_accession","prints","source","status","strand","transcript_source","transcript_count","transcript_biotype","transcript_status")
        genesymbol <- "external_gene_name"
    }
    
    if(organism=="athaliana"){
        noAttr <- c("chromosome_name","prints_pf","strand")
        genesymbol <- "tair_symbol"

    }
    
    finalAttr <- setdiff(finalAttr,noAttr)
    
    finalAttr <- sort(finalAttr)
    
    if(idType!="auto" && length(which(finalAttr==idType))==0){
        cat("The input 'idType' is not supported by Biomart. Please select one id type from the following list:\n")
        cat(finalAttr,sep="\n")
        stop("The users can also set 'idType' as 'auto' and the function will automatically search idtype based on the input data. However, this function may take 20-60 minutes based on users' internet speed\n")
    }
    
    if(idType=="auto"){
        idtype <- .autoSearchIdType(geneList,finalAttr,mart,genesymbol,verbose)
        if(!is.null(idtype)){
            idmap <- getBM(attributes=c(idtype,genesymbol),filters=idtype,values=geneList,mart=mart)
            idmap <- idmap[idmap[,2]!="",]
            
            t <- tapply(idmap[,2],idmap[,1],paste,collapse="|")
            
            idmap <- data.frame(id=names(t),genesymbol=t,stringsAsFactors=F)
            
            return(idmap)
        }else{
            return(NULL)
        }
    }else{
        idmap <- getBM(attributes=c(idType,genesymbol),filters=idType,values=geneList,mart=mart)
        
        if(nrow(idmap)==0){
            return(NULL)
        }else{
            idmap <- idmap[idmap[,2]!="",]
        
            t <- tapply(idmap[,2],idmap[,1],paste,collapse="|")
        
            idmap <- data.frame(id=names(t),genesymbol=t,stringsAsFactors=F)
            
            if(nrow(idmap)/length(geneList)<0.1){
                return(nrow(idmap)/length(geneList))
            }else{
                return(idmap)
            }
        }
    }
}

.autoSearchIdType <- function(geneList,finalAttr,mart,genesymbol,verbose=TRUE){
    if(length(geneList)>40){
        randomNum <- 40
    }else{
        randomNum <- length(geneList)
    }
    
    if(verbose==TRUE){
        cat("\nSearching the array type...\n")
    }
    
    randomId <- sample(geneList,randomNum)
    
    
    finalIdtype <- c()
    tempIdtype <- data.frame(id="",rate=0,stringsAsFactors=F)
    ti <- 1
    
    rang <- ifelse(length(finalAttr)>10,10,length(finalAttr))
    
    startA <- 1
    endA <- rang
    
    startB <- length(finalAttr)-rang+1
    endB <- length(finalAttr)
    
    
    l <- 0
    
    
    u <- 0
    fi <- 0
    while(u<length(finalAttr)){
        if(l==0){
            s <- startA
            e <- endA
        }else{
            s <- startB
            e <- endB
        }
        for(i in c(s:e)){
            idtype <- finalAttr[i]
            idmap <- getBM(attributes=c(idtype,genesymbol),filters=idtype,values=randomId,mart=mart)
            if(length(unique(idmap[,1]))>(0.8*length(randomId))){
                finalIdtype <- idtype
                fi <- 1
                break
            }else{
                if(length(unique(idmap[,1]))>(0.6*length(randomId))){
                    tempIdtype[ti,1] <- idtype
                    tempIdtype[ti,2] <- (length(unique(idmap[,1]))/length(randomId))
                    ti <- ti + 1
                }
            }
        }
        if(fi==1){
            break
        }
        
        if(l==0){
            l <- 1
            u <- u+endA-startA+1
            startA <- startA + rang
            endA <- startA + rang - 1
            if(endA>=startB){
                endA <- startB-1
            }
        }else{
            l <- 0
            u <- u+endB-startB+1
            endB <- startB-1
            startB <- endB - rang + 1
            if(startB<endA){
                startB <- endA+1
            }
        }
        
    }
    
    is.map <- TRUE
    if(length(finalIdtype)>0){
        idtype <- finalIdtype
        is.map <- TRUE
        
    }else{
        if(tempIdtype[1,1]!=""){
            tempIdtype <- tempIdtype[order(-tempIdtype[,2]),]
            idtype <- tempIdtype[1,1]
            is.map <- TRUE
        }else{
            is.map <- FALSE
        }
    }
    
    if(is.map==TRUE){
        
        if(verbose==TRUE){
            cat("The input Ids can map to ",idtype, "!\n")
        }
        
        return(idtype)
        
    }else{
        if(verbose==TRUE){
            cat("The function can not find the matched id type from biomart!\n")
        }
        return(NULL)
    }
}


.NetToSymbol <-
function(inputNetwork, organism="hsapiens", idType="auto", edgeType="unweighted", verbose=TRUE){
    
    
    #require(tools) || stop("Package tools version 3.0.0 is required!")
    
    #load Network
    
    if(verbose==TRUE){
        cat("Transforming the ids in the input network to gene symbols...\n")
    }
    
    
    if(.getClass(inputNetwork)=="character"){
        if(file_ext(inputNetwork)!="net"){
            stop("The extension of the input file should be 'net'!\n")
        }else{
            network <- read.graph(inputNetwork,format="ncol")
            if(edgeType=="weighted"){
                if(is.null(E(network)$weight)){
                    stop("The input network does not contain edge weights. Please add the edge weights or change parameter 'edgeType' to 'unweigthed'!")
                }
            }else{
                if(!is.null(E(network)$weight)){
                    stop("The input network contains edge weights. Please remove the edge weights or change parameter 'edgeType' to 'weigthed'!")
                }
            }
        }
    }else{
        if(.getClass(inputNetwork)=="data.frame" || .getClass(inputNetwork)=="matrix"){
            if(edgeType=="weighted"){
                if(ncol(inputNetwork)!=3){
                    stop("Data object should contain three columns: interactor1, interactor2 and edge weight!")
                }else{
                    weight <- inputNetwork[,3]
                    if(!is.numeric(weight)){
                        stop("The edge weight should be numeric!")
                    }else{
                        inputNetwork <- as.matrix(inputNetwork[,c(1,2)])
                        inputNetwork_S <- as.character(inputNetwork)
                        inputNetwork_S <- array(inputNetwork_S,dim=dim(inputNetwork))
                        network <- graph.edgelist(inputNetwork_S,directed=F)
                        E(network)$weight <- weight
                    }
                }
            }else{
                if(ncol(inputNetwork)!=2){
                    stop("data object should contain two columns!\n");
                }else{
                    inputNetwork <- as.matrix(inputNetwork)
                    inputNetwork_S <- as.character(inputNetwork)
                    inputNetwork_S <- array(inputNetwork_S,dim=dim(inputNetwork))
                    network <- graph.edgelist(inputNetwork_S,directed=F)
                }
            }
            rm(inputNetwork,inputNetwork_S)
            gc()
        }else{
            if(.getClass(inputNetwork)=="igraph"){
                if(edgeType=="unweighted"){
                    if(!is.null(E(inputNetwork)$weight)){
                        stop("The input network contains edge weights. Please remove the edge weights or change parameter 'edgeType' to 'weigthed'!")
                    }else{
                        network <- inputNetwork
                    }
                }else{
                    if(is.null(E(inputNetwork)$weight)){
                        stop("The input network does not contain edge weights. Please add the edge weights or change parameter 'edgeType' to 'unweigthed'!")
                    }else{
                        network <- inputNetwork
                    }
                }
                rm(inputNetwork)
                gc()
            }else{
                if(.getClass(inputNetwork)=="graphNEL"){
                    network <- igraph.from.graphNEL(inputNetwork)
                    if(edgeType=="unweighted"){
                        if(!is.null(E(network)$weight)){
                            stop("The input network contains edge weights. Please remove the edge weights or change parameter 'edgeType' to 'weigthed'!")
                        }
                    }else{
                        if(is.null(E(network)$weight)){
                            stop("The input network does not contain edge weights. Please add the edge weights or change parameter 'edgeType' to 'unweigthed'!")
                        }
                    }
                    rm(inputNetwork)
                    gc()
                }else{
                    stop("The input network should be from a file or a data object with data.frame, matrix, graphNEL or igraph class. Other types of input are invalid!\n")
                }
                
            }
        }
    }
    
    netNode <- get.vertex.attribute(network,"name")
    idmap <- .GeneToSymbol(netNode,organism,idType,verbose)
    
    if(is.null(idmap)){
        return(NULL)
    }else{
        if(.getClass(idmap)=="numeric"){
            return(idmap)
        }else{
            network <- .extractSubNetwork(network,idmap[,1],edgeType)
            rownames(idmap) <- idmap[,1]
            idmap <- idmap[get.vertex.attribute(network,"name"),]
            V(network)$name <- idmap[,2]
            network <- simplify(network)
            # if(verbose==TRUE){
            #    cat("After mapping to the gene symbol, the network contains ",vcount(network)," nodes and ",ecount(network)," edges!\n",sep="")
            #}
        
            network_edgelist <- get.edgelist(network)
            network_edgelist <- as.data.frame(network_edgelist)
            if(edgeType=="weighted"){
                wei <- get.edge.attribute(network,name="weight")
                network_edgelist$weight <- wei
            }
        
            re <- list(network=network_edgelist,idmap=idmap)
            return(re)
        }
    }
}

.extractSubNetwork <- function(network,subList,edgeType){
    if(edgeType=="unweighted"){
        x <- get.edgelist(network)
        x <- x[x[,1] %in% subList & x[,2] %in% subList,]
        network <- graph.edgelist(x,directed=F)
    }else{
        x <- get.edgelist(network)
        weight <- get.edge.attribute(network,"weight")
        ind <- which(x[,1] %in% subList & x[,2] %in% subList)
        x <- x[ind,]
        weight <- weight[ind]
        network <- graph.edgelist(x,directed=F)
        E(network)$weight <- weight
    }
    return(network)
}


.MatToSymbol <-
function(inputMat, organism="hsapiens", idType="auto", collapse_mode="maxSD", verbose=TRUE){
    
    
    #require(biomaRt) || stop("Package biomaRt version 2.18.0 is required!")
    #require(tools) || stop("Package tools version 3.0.0 is required!")
    #require(multicore) || stop("Package multicore version 0.1-7 is required!")
    #require(doSNOW) || stop("Package doSNOW version 1.0.6 is required!")
    #require(foreach) || stop("Package foreach version 1.4.0 is required!")
    
    #mart <- useMart("ensembl")
    
    #m <- try(mart <- useDataset(paste(organism,"_gene_ensembl",sep=""),mart),silent=TRUE)
    #if(class(m)=="try-error"){
    #    stop(paste("The organism ",organism," your input is not valid! Correct organism names can be obtained with the listDatasets function.\n",sep=""))
    #}

    
    re <- testFileFormat(inputMat=inputMat, collapse_mode=collapse_mode)
    inputMat <- re$inputMat
    inputId <- rownames(inputMat)
    
    idmap <- .GeneToSymbol(inputId,organism,idType,verbose)
    if(!is.null(idmap)){
        
        if(.getClass(idmap)=="numeric"){
            return(idmap)
        }else{
            inputMat <- inputMat[idmap[,1],]
            id <- as.vector(idmap[,2])
            inputMat <- mergeDuplicate(id,inputMat,collapse_mode)
            re <- list(data_symbol=inputMat,idmap=idmap)
            return(re)
        }
    }else{
        return(NULL)
    }
}


.sbtToSymbol <- function(inputFile, organism="hsapiens", idType="auto", verbose=TRUE){
    if(.getClass(inputFile)=="character"){
        if(file_ext(inputFile)!="sbt"){
            stop("The extension of the input file should be 'sbt'. The detail of the 'sbt' file format can be found in the NetGestalt (www.netgestalt.org)!\n")
        }else{
            inputMat <- read.csv(inputFile,header=FALSE,sep="\t",stringsAsFactors=FALSE)
        }
    }else{
        stop("The 'inputFile' should be the directory of a SBT file\n")
    }
    
    .calculateLength <- function(vector){
        vector <- vector[vector!=""]
        return(length(vector))
    }
    
    sbtLength <- apply(inputMat,1,.calculateLength)
    
    if(length(which(sbtLength<3))>0){
        stop("The SBT file should contain at least three columns. The following rows of the input file only contain one or two columns: ",which(sbtLength<3),"\n",sep="")
    }
    
    transformedData <- data.frame(name="",des="",genelist="",stringsAsFactors=F)
    ti <- 1
    for(i in c(1:nrow(inputMat))){
        geneL <- inputMat[i,3:ncol(inputMat)]
        geneL <- geneL[geneL!=""]
        idmap <- .GeneToSymbol(geneL,organism,idType,verbose)
        mapNum <- c()
        if(!is.null(idmap) && .getClass(idmap)!="numeric"){
            mappedL <- unique(idmap[,2])
            transformedData[ti,1] <- inputMat[i,1]
            transformedData[ti,2] <- inputMat[i,2]
            mappedL <- paste(mappedL,collapse="\t")
            transformedData[ti,3] <- mappedL
            ti <- ti+1
        }
    }
    
    if(transformedData[1,1]!=""){
        re <- list(transformedData=transformedData,oriLength=nrow(inputMat))
        return(re)
    }else{
        return(NULL)
    }
}


.sctToSymbol <- function(inputFile, organism="hsapiens", idType="auto", verbose=TRUE, collapse_mode="min"){
    if(.getClass(inputFile)=="character"){
        if(file_ext(inputFile)!="sct"){
            stop("The extension of the input file should be 'sct'. The detail of the 'sct' file format can be found in the NetGestalt (www.netgestalt.org)!\n")
        }else{
            inputMat <- read.csv(inputFile,header=TRUE,sep="\t",stringsAsFactors=FALSE,check.names=FALSE)
        }
    }else{
        stop("The 'inputFile' should be the directory of a SCT file\n")
    }
    
    if(ncol(inputMat)<2){
        stop("The SCT file should contain at least two columns (gene id and statistic score). \n")
    }
    
    id <- inputMat[,1]
    inputMat <- as.matrix(inputMat[,2:ncol(inputMat)])
    
    if(length(unique(id))<length(id)){
        cat("The SCT file contains duplidate Ids. The function will use 'median' to collapse duplicate Ids for each statistic.\n")
        inputMat <- mergeDuplicate(id,inputMat,collapse_mode)
    }else{
        rownames(inputMat) <- id
    }
    
    
    idmap <- .GeneToSymbol(id,organism,idType,verbose)
    
    if(!is.null(idmap)){
        
        if(.getClass(idmap)=="numeric"){
            return(idmap)
        }else{
            inputMat <- as.matrix(inputMat[idmap[,1],])
            id <- as.vector(idmap[,2])
            inputMat <- mergeDuplicate(id,inputMat,collapse_mode)
            re <- list(sct_symbol=inputMat,idmap=idmap)
            return(re)
        }
    }else{
        return(NULL)
    }
}

test_NetSAM <- function(){
	inputNetworkDir <- system.file("extdata","exampleNetwork.net",package="NetSAM")
	outputFileName <- paste(getwd(),"/NetSAM",sep="")
	result <- NetSAM(inputNetwork=inputNetworkDir, outputFileName=outputFileName)
	checkTrue(!is.na(result[1]))
	checkTrue(!is.na(result[2]))
	checkTrue(!is.na(result[3]))
}

.getClass <- function(obj) {
   cls <- class(obj)
   return(cls[1])
}

NetAnalyzer <-
function(inputNetwork, outputFileName, edgeType="unweighted"){
   
  #require(igraph) || stop("Package igraph version 0.6 is required!")
    
	if(missing(inputNetwork)){
		stop("Please input the network!\n")
	}
    
    
    #load Network
	if(.getClass(inputNetwork)=="character"){
        if(file_ext(inputNetwork)!="net"){
            stop("The extension of the input file should be 'net'!\n")
        }else{
            network <- read.graph(inputNetwork,format="ncol")
            if(edgeType=="weighted"){
                if(is.null(E(network)$weight)){
                    stop("The input network does not contain edge weights. Please add the edge weights or change parameter 'edgeType' to 'unweigthed'!")
                }
            }else{
                if(!is.null(E(network)$weight)){
                    stop("The input network contains edge weights. Please remove the edge weights or change parameter 'edgeType' to 'weigthed'!")
                }
            }
        }
	}else{
		if(.getClass(inputNetwork)=="data.frame" || .getClass(inputNetwork)=="matrix"){
            if(edgeType=="weighted"){
                if(ncol(inputNetwork)!=3){
                    stop("Data object should contain three columns: interactor1, interactor2 and edge weight!")
                }else{
                    weight <- inputNetwork[,3]
                    if(!is.numeric(weight)){
                        stop("The edge weight should be numeric!")
                    }else{
                        inputNetwork <- as.matrix(inputNetwork[,c(1,2)])
                        inputNetwork_S <- as.character(inputNetwork)
                        inputNetwork_S <- array(inputNetwork_S,dim=dim(inputNetwork))
                        network <- graph.edgelist(inputNetwork_S,directed=F)
                        E(network)$weight <- weight
                    }
                }
            }else{
                if(ncol(inputNetwork)!=2){
                    stop("data object should contain two columns!\n");
                }else{
                    inputNetwork <- as.matrix(inputNetwork)
                    inputNetwork_S <- as.character(inputNetwork)
                    inputNetwork_S <- array(inputNetwork_S,dim=dim(inputNetwork))
                    network <- graph.edgelist(inputNetwork_S,directed=F)
                }
            }
            rm(inputNetwork,inputNetwork_S)
            gc()
		}else{
			if(.getClass(inputNetwork)=="igraph"){
                if(edgeType=="unweighted"){
                    if(!is.null(E(inputNetwork)$weight)){
                        stop("The input network contains edge weights. Please remove the edge weights or change parameter 'edgeType' to 'weigthed'!")
                    }else{
                        network <- inputNetwork
                    }
                }else{
                    if(is.null(E(inputNetwork)$weight)){
                        stop("The input network does not contain edge weights. Please add the edge weights or change parameter 'edgeType' to 'unweigthed'!")
                    }else{
                        network <- inputNetwork
                    }
                }
                rm(inputNetwork)
                gc()
            }else{
                if(.getClass(inputNetwork)=="graphNEL"){
                    network <- igraph.from.graphNEL(inputNetwork)
                    if(edgeType=="unweighted"){
                        if(!is.null(E(network)$weight)){
                            stop("The input network contains edge weights. Please remove the edge weights or change parameter 'edgeType' to 'weigthed'!")
                        }
                    }else{
                        if(is.null(E(network)$weight)){
                            stop("The input network does not contain edge weights. Please add the edge weights or change parameter 'edgeType' to 'unweigthed'!")
                        }
                    }
					rm(inputNetwork)
					gc()
				}else{
                    stop("The input network should be from a file or a data object with data.frame, matrix, graphNEL or igraph class. Other types of input are invalid!\n")
				}

            }
        }
	}
	
	if(missing(outputFileName)){
		stop("Please input the output file name!\n")
	}else{
		if(substr(outputFileName,nchar(outputFileName),nchar(outputFileName))=="/"){
			stop("Please input the output file name!\n")
		}
	}
	
	nodeAttr <- data.frame(node=vertex_attr(network,name="name"),degree=0,clusterCoefficient=0,betweennessCentrality=0,closenessCentrality=0,stringsAsFactors=F)
	
	if(edgeType=="unweighted"){
	
		nodeAttr[,2] <- degree(network)
		nodeAttr[,3] <- transitivity(network,type="local")
		nodeAttr[,4] <- betweenness(network,directed=FALSE)
		nodeAttr[,5] <- closeness(network,mode="all")
	}else{
		nodeAttr[,2] <- strength(network)
		nodeAttr[,3] <- transitivity(network,type="weighted")
		nodeAttr[,4] <- betweenness(network,directed=FALSE)
		nodeAttr[,5] <- closeness(network,mode="all")
	}
	
	shortestP <- distances(network)
	shO <- paste(outputFileName,"_shortestPathDistance.txt",sep="")
	write.table(shortestP,file=shO,row.names=T,col.names=T,sep="\t",quote=F)
	
	shortestP_V <- shortestP[lower.tri(shortestP)]
	
	nodeO <- paste(outputFileName,".txt",sep="")
	write.table(nodeAttr,file=nodeO,row.names=F,col.names=F,sep="\t",quote=F)
	
	degreeP <- paste(outputFileName,"_degreeDistribution.pdf",sep="")
	if(edgeType=="unweighted"){
		.fit_power_law(network,edgeType,degreeP)
	}else{
		pdf(degreeP,height=6,width=6)
		hist(nodeAttr[,2],xlab="Degree",col="black",main="Degree Distribution")
		dev.off()
	}

	
	shortP <- paste(outputFileName,"_shortestPathDistanceFrequency.pdf",sep="")
	pdf(shortP,height=6,width=6)
	hist(shortestP_V,xlab="Shortest Path Distance",col="black",main="Shortest Path Distance Distribution")
	dev.off()
	
	x <- nodeAttr[nodeAttr[,2]>1,]
	ccP <- paste(outputFileName,"_clusteringCoefficient.pdf",sep="")
	pdf(ccP,height=6,width=6)
	a <- tapply(x[,3],x[,2],mean,na.rm=TRUE)
	plot(as.numeric(names(a)),a,xlab="Degree",ylab="Ave clustering coefficient",main="Clustering Coefficient Distribution",pch=19)
	dev.off()
	

	ccP <- paste(outputFileName,"_betweeness.pdf",sep="")
	pdf(ccP,height=6,width=6)
	a <- tapply(nodeAttr[,4],nodeAttr[,2],mean,na.rm=TRUE)
	plot(as.numeric(names(a)),a,xlab="Degree",ylab="Ave betweeness",main="Betweeness Distribution",pch=19)
	dev.off()
	
	ccP <- paste(outputFileName,"_closenessCentrality.pdf",sep="")
	pdf(ccP,height=6,width=6)
	a <- tapply(nodeAttr[,5],nodeAttr[,2],mean,na.rm=TRUE)
	plot(as.numeric(names(a)),a,xlab="Degree",ylab="Ave closeness centrality",main="Closeness Centrality Distribution",pch=19)
	dev.off()
	
}


.fit_power_law = function(graph,edgeType,outputFile) {
    # calculate degree

    d = degree(graph)
   	dd = degree.distribution(graph, cumulative = FALSE)

    degree = 1:max(d)
    probability = dd[-1]
    # delete blank values
    nonzero.position = which(probability != 0)
    probability = probability[nonzero.position]
    degree = degree[nonzero.position]
    reg = lm(log(probability) ~ log(degree))
    cozf = coef(reg)
    power.law.fit = function(x) exp(cozf[[1]] + cozf[[2]] * log(x))
    alpha = -cozf[[2]]
    R.square = summary(reg)$r.squared
    print(paste("Alpha =", round(alpha, 3)))
    print(paste("R square =", round(R.square, 3)))
    # plot
    pdf(outputFile,height=6,width=6)
    plot(probability ~ degree, log = "xy", xlab = "Degree (log)", ylab = "Probability (log)", 
        col = 1, main = "Degree Distribution")
    curve(power.law.fit, col = "red", add = T, n = length(d))
    dev.off()
}

---
title: "NetSAM User Guide"
output:
  pdf_document:
    number_sections: yes
  html_document: default
date: "5/15/2021"
vignette: >
  %\VignetteIndexEntry{NetSAM User Guide}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE)
knitr::opts_chunk$set(eval = FALSE)
knitr::opts_chunk$set(tidy.opts=list(width.cutoff=65),tidy=TRUE)
```

# Introduction

The last decade of systems biology research has demonstrated that networks
rather than individual genes govern the onset and progression of complex diseases.
Meanwhile, real world complex networks usually exhibit hierarchical organization,
in which nodes can be combined into groups that can be further combined into
larger groups, and so on over multiple scales. Thus, identifying the hierarchical
organization of a network becomes indispensable in complex disease studies. A
traditional and useful method for revealing hierarchical architecture of network
is hierarchical clustering, which groups data over a variety of scales by
creating a hierarchical tree. However, hierarchical clustering has three
major limitations.

* There are many different leaf node orderings consistent with the
structure of a hierarchical tree, and hierarchical clustering does not
optimize the ordering.
* Hierarchical clustering does not assess the statistical significance of
the modular organization of a network.
* It does not specify relevant hierarchical levels and modules at different scales.

To address these limitations, we developed the NetSAM (Network Seriation and Modularization)
package which identifies the hierarchical modules from a network
(network modularization) and find a suitable linear order for all leaves of
the identified hierarchical organization (network seriation). NetSAM takes
an edge-list representation of a weighted or unweighted network as an
input and generates as files that can be used as an input for the one-dimensional
network visualization tool NetGestalt ([`http://www.netgestalt.org`](http://www.netgestalt.org))
or other network analysis. NetSAM uses random walk distance-based
hierarchical clustering to identify the hierarchical modules of the network
and then uses the optimal leaf ordering (OLO) method to optimize
the one-dimensional ordering of the genes in each module by
minimizing the sum of the pair-wise random walk distance of adjacent genes in
the ordering. The detailed description of the NetSAM method can be found
in our published Nature Methods paper "NetGestalt: integrating multidimensional
omics data over biological networks" ([`http://www.nature.com/nmeth/journal/v10/n7/full/nmeth.2517.html`](http://www.nature.com/nmeth/journal/v10/n7/full/nmeth.2517.html).

The NetSAM package can also generate correlation network (e.g. co-expression
network) based on the input matrix data, perform seriation and
modularization analysis for correlation network and calculate the
associations between the sample features and modules or identify the associated GO terms for the modules.

# Environment

NetSAM requires R version 3.0.0 or later, which can be downloaded from the website
[`http://www.r-project.org`](http://www.r-project.org/). Because the seriation
step requires pair-wise distance between all nodes, NetSAM is memory consuming.
We recommend to use the 64 bit version of R to run the NetSAM. For networks
with less than 10,000 nodes, we recommend to use a computer with at least 8GB
memory. Using our computer with 2.7 GHz Intel Core i5 processor and 8GB 1333
MHz DDR3 memory, NetSAM took 402 seconds to analyze the HPRD network
([`http://www.hprd.org`](http://www.hprd.org)) with 9198 nodes. For networks
with more than 10,000 nodes, a computer with at least 16GB memory is recommended.
NetSAM package requires the following packages: `igraph` (>=0.6-1),
`seriation` (>=1.0-6), `WGCNA` (>=1.34.0), `doParallel` (>=1.0.10),
`foreach` (>=1.4.0), `tools` (>=3.0.0), `biomaRt` (>=2.18.0),
`GO.db` (>=2.10.0), `R2HTML` (>=2.2.0) and `survival` (>=2.37-7), which can be installed as follows.

```{r}
install.packages("igraph")
install.packages("seriation")
install.packages("WGCNA")
install.packages("snow")
install.packages("doSNOW")
install.packages("foreach")
source("http://bioconductor.org/biocLite.R")
biocLite("biomaRt")
biocLite("GO.db")
install.packages("R2HTML")
install.packages("survival")
```

# Network Seriation and Modularization

After building up the basic environment mentioned above, the users can install the NetSAM package and use it to analyze networks.

```{r eval=FALSE}
library("NetSAM")
inputNetworkDir <- system.file("extdata","exampleNetwork.net",package="NetSAM")
outputFileName <- paste(getwd(),"/NetSAM",sep="")
result <- NetSAM(inputNetwork=inputNetworkDir, outputFileName=outputFileName, outputFormat="nsm",
edgeType="unweighted", map_to_genesymbol=FALSE, organism="hsapiens", idType="auto", minModule=0.003,
stepIte=FALSE, maxStep=4, moduleSigMethod="cutoff", modularityThr=0.2, ZRanNum=10,
PerRanNum=100, ranSig=0.05, edgeThr=(-1), nodeThr=(-1), nThreads=3)
```

## Input

* `inputNetwork` is the network under analysis. `inputNetwork` can be the directory of the input network file including the file name with "net"
 extension. If `edgeType` is "`unweighted`", each row represents an edge with two node names separated by a tab or space. If `edgeType` is
 "`weighted`", each row represents an edge with two node names and edge weight separated by a tab or space.  `inputNetwork` can also be a data object in R (data object must be igraph, graphNEL, matrix or data.frame class).
 
* `outputFileName` is the name of the output file.

* `outputFormat` is the format of the output file. "`nsm`" format can be used as an input to NetGestalt
([`http://www.netgestalt.org`](http://www.netgestalt.org)), "`gmt`" format can be used to do other network analysis 
(e.g. as an input in GSEA (Gene Set Enrichment Analysis) to do module enrichment analysis) and "`none`" means the function will not output a file.

* Because pathway enrichment analysis in NetGestalt is based on gene symbol, setting `map_to_genesymbol` as `TRUE` can transform other ids in the 
network into gene symbols and thus allow users to do functional analysis based on the identified modules. If the input network is not a biology 
network or users do not plan to do enrichment analysis in the NetGestalt, users can set `map_to_genesymbol` as `FALSE`. The default is `FALSE`.

* `organism` is the organism of the input network. Currently, the package supports the following nine organisms: `hsapiens`, `mmusculus`,
`rnorvegicus`, `drerio`, `celegans`, `scerevisiae`, `cfamiliaris`, `dmelanogaster` and `athaliana`. The default is "`hsapiens`".

* `idType` is the id type of the input network. MatSAM will use BiomaRt package to transform the input ids to gene symbols based on `idType`. User 
can also set `idType` as "`auto`" that means MatSAM will automatically search the id type of the input data. However, this may take 10 minutes depending on the users' network connection speed. The default is "`auto`".

* `minModule` is the minimum percentage of nodes in a module. The minimum size of a module is calculated by multiplying `minModule` by the number of 
nodes in the whole network. If the size of a module identified by the function is less than the minimum size, the module will not be further
partitioned into sub-modules. The default is $0.003$ which means the minimum module size is `30` if there are $10,000$ nodes in the whole network. If
 the minimum module size is less than $5$, the minimum module size will be set as $5$. The `minModule` should be less than $0.2$.

* Because NetSAM uses random walk distance-based hierarchical clustering to reveal the hierarchical organization of an input network, 
it requires a specified length of the random walks. If `stepIte` is `TRUE`, the function will test a range of lengths ranging from $2$ to `maxStep` 
to get the optimal length. Otherwise, the function will directly use `maxStep` as the length of the random walks. The default `maxStep` is $4$.
Because optimizing the length of the random walks will take a long time, if the network is too big (e.g. the number of edges is over $200,000$), we suggest to set `stepIte` to `FALSE`.

* To test whether a network under consideration has a non-random internal modular organization, the function provides three options for parameter 
`moduleSigMethod`: "`cutoff`", "`zscore`" and "`permutation`". "`cutoff`" means if the modularity score of the network is above a specified cutoff 
value, the network will be considered to have internal organization and will be further partitioned. For "`zscore`" and "`permutation`", 
the function will first generate a set of random modularity scores. Based on a unweighted network, the function uses the edge switching method to 
generate a given number of random networks with the same number of nodes and an identical degree sequence and calculates 
the modularity scores for these random networks. Based on a weighted network, the function shuffles the weights of all edges and calculate the 
modularity scores for network with random weights. Then, "`zscore`" method will transform the real modularity score to a z 
score based on the random modularity scores and then transform the z score to a p value assuming a standard normal distribution. The "`permutation`" 
method will compare the real modularity score with the random ones to calculate a p value. Finally, under a specified significance level, the function determines whether the network can be further partitioned. The default is "`cutoff`".

* `modularityThr` is the threshold of modularity score for the "`cutoff`" method. The default value is $0.2$.

* `ZRanNum` is the number of random networks that will be generated for the "`zscore`" calculation. The default value is $10$.

* `PerRanNum` is the number of random networks that will be generated for the "`permutation`" p value calculation. The default value is $100$.

* `ranSig` is the significance level for determining whether a network has non-random internal modular organization for the "`zscore`" or
"`permutation`" methods.

* If the network is too big, it will take a long time to identify the modules. Thus, 
the function provides the option to set the threshold of number of edges and nodes as `edgeThr` and `nodeThr`. 
If the size of network is over the threshold, the function will stop and the users should change the parameters
and re-run the function. We suggest to set the threshold for node as $12,000$ and the threshold for edge as $300,000$.
The default value is $-1$ which means there is no limitation for the network.

* `nThreads` is the number of cores used for parallel processing.  The default value is $3$.

## Output

If output format is "`nsm`", the function will output not only an "`nsm`" file but also a list object containing module information, 
gene order information and network information. If output format is "`gmt`", the function will output the "`gmt`" file and a matrix
object containing the module and annotation information.


# Network Analyzer

The `NetAnalyzer` function calculates the degree, clustering coefficient, betweeness and closeness centrality 
for each node and the shortest path distance for each pair of nodes. The function can also plot the distributions for these measurements.

```{r}
library("NetSAM")
inputNetwork <- system.file("extdata","exampleNetwork.net",package="NetSAM") 
outputFileName <- paste(getwd(),"/NetSAM",sep="")
NetAnalyzer(inputNetwork,outputFileName,"unweighted")
```

## Input

* `inputNetwork` is the path to the network file under analysis or a data object. If it is a path to the network file, the file must have 
`.net`extension. If `edgeType` is `unweighted`, each row represents an edge with two node names separated by a tab or space. 
If edgeType is `weighted`, each row represents an edge with two node names and edge weight separated by a tab or space.
If `inputNetwork` is a data object, if must be of one of the following classes: `igraph`, `graphNEL`, `matrix` or `data.frame`.

* `edgeType` can be either "`unweighted`" or "`weighted`"

* `outputFileName` is the name of the output file.

## Output

The `NetAnalyzer` function will output two "`txt`" files and five "`pdf`" files. Two "`txt`" files contain degree,
clustering coefficient, betweeness and closeness centrality for each node and the shortest path 
distance for each pair of nodes. Five "`pdf`" files are the distributions of these measurements.


# `mergeDuplicate`

The `mergeDuplicat`e function will merge the duplicate Ids in the matrix and return the matrix with unique Ids.
This function can also used to merge the duplicate mapped Ids when transforming the Ids of data matrix to other Ids.

```{r}
library("NetSAM")
inputMatDir <- system.file("extdata","exampleExpressionData_nonsymbol.cct",package="NetSAM")
inputMat <- read.table(inputMatDir,header=TRUE,sep="\t",stringsAsFactors=FALSE,check.names=FALSE)
mergedData <- mergeDuplicate(id=inputMat[,1],data=inputMat[,2:ncol(inputMat)],collapse_mode="maxSD")
```

## Input

* `id` are the duplicated Ids. It should be a vector object.

* `data` is the corresponding data matrix that has the same number of 
rows with id and should be a matrix or data.frame object.

* `collapse_mode` is the method to collapse duplicate ids. "`mean`", "`median`", "`maxSD`", 
"`maxIQR`", "`max`" and "`min`"represents the mean, median, max standard deviation, max interquartile range,
maximum and minimum of values for ids in each sample respectively. The default value is "`maxSD`".

## Output

The function returns a data matrix with unique Ids.


# Mapping other ids to gene symbols

To perform enrichment analysis in NetGestalt, the gene ids in each module should be gene symbols. 
The `mapToSymbol` function can transform other ids from a gene list, network, matrix, sbt file or sct file
to gene symbols.

```{r}
library("NetSAM")
print("transform ids from a gene list to gene symbols...")
geneListDir <- system.file("extdata","exampleGeneList.txt",package="NetSAM")
geneList <- read.table(geneListDir,header=FALSE,sep="\t",stringsAsFactors=FALSE)
geneList <- as.vector(as.matrix(geneList))
geneList_symbol <- mapToSymbol(inputData=geneList, organism="hsapiens", inputType="genelist",idType="affy_hg_u133_plus_2")

print("transform ids in the input network to gene symbols...")
inputNetwork <- system.file("extdata","exampleNetwork_nonsymbol.net",package="NetSAM")
network_symbol <- mapToSymbol(inputData=inputNetwork,organism="hsapiens",inputType="network",idType="entrezgene",edgeType="unweighted")

print("transform ids in the input matrix to gene symbols...")
inputMatDir <- system.file("extdata","exampleExpressionData_nonsymbol.cct",package="NetSAM")
matrix_symbol <- mapToSymbol(inputData=inputMatDir,organism="hsapiens",inputType="matrix",idType="affy_hg_u133_plus_2",collapse_mode="maxSD")

print("transform ids in the sbt file to gene symbols...")
inputSBTDir <- system.file("extdata","exampleSBT.sbt",package="NetSAM")
sbt_symbol <- mapToSymbol(inputData= inputSBTDir,organism="hsapiens",inputType="sbt",idType="affy_hg_u133_plus_2")

print("transform ids in the sct file to gene symbols...")
inputSCTDir <- system.file("extdata","exampleSCT.sct",package="NetSAM")
sct_symbol <- mapToSymbol(inputData= inputSCTDir,organism="hsapiens",inputType="sct",idType="affy_hg_u133_plus_2",collapse_mode="min")
```

## Input

* `inputData`: `mapToSymbol` function supports five different types of data: "`genelist`", "`network`", 
"`matrix`", "`sbt`" and "`sct`". For "`genelist`" type, `inputData` should be a vector containing gene ids.
For "`network`" type, `inputData` can be the path to the input network file and the file must have a "`.net`" extension. 
If `edgeType` is "`unweighted`"", each row represents an edge with two node names separated by a tab or space.
If edgeType is "`weighted`", each row represents an edge with two node names and edge weight separated by a tab or space.
`inputNetwork` can also be a data object (data object must be `igraph`, `graphNEL`, `matrix` or `data.frame` class). 
For "`matrix`" type, `inputData` should be a path to a file with extension "`cct`" or "`cbt`" or a matrix
or data.frame object.
The data should have column names. If the data do not have any row name, the first column of the data should be the ids. For "`sbt`" type,
`inputData` should be a path to a file with extension "`.sbt`". For "`sct`" type, inputData should be a directory containing a file name with extension "`.sct`". The detail information of "`cct`" , "`cbt`", "`sbt`", "`sct`" format can be found in the NetGestalt user manual ([`http://www.netgestalt.org`](http://www.netgestalt.org)).

* `inputType`: the type of the input data. see detailed information in `inputData` parameter.

* `idType`: see `idType` in `NetSAM` function

* `collapse_mode` is the method used to collapse duplicate ids. See details in `mergeDuplicate` section. For SCT file, we suggest to use "`max`"
or "`min`" to collapse duplicate ids in the statistic data.

* `is_outputFile`: If `is_outputFile` is `TRUE`, the function will output the transformed data to a file. The default value is `FALSE`.

* `outputFileName`: the output file name.

* `verbose`: whether the function reports extra information. The default value is `TRUE`.

## Output

The function will output a object with transformed data. If the ids in the input data can not be transformed to gene symbols,
the function will output `NULL`. If `outputFileName` is `TRUE`, the functionsaves the transformed data to a file.

# Construction of correlation network

The `MatNet` function can be used to construct a correlation network based on the input matrix.

```{r}
library("NetSAM")
inputMatDir <- system.file("extdata","exampleExpressionData.cct",package="NetSAM")
matNetwork <- MatNet(inputMat=inputMatDir, collapse_mode="maxSD", naPer=0.7, meanPer=0.8, varPer=0.8,
corrType="spearman", matNetMethod="rank", valueThr=0.6, rankBest=0.003, networkType="signed",
netFDRMethod="BH", netFDRThr=0.05, idNumThr=(-1), nThreads=3)
```

## Input

* `inputMat` is the path to a file with extension "`.cct`" or a matrix or data.frame object. The data should have column names. If the data do not 
have any row name, the first column of the data should be the ids.

* If the input matrix data contains the duplicate ids, the function will collapse duplicate ids based on the `collapse` mode. "`mean`", "`median`",
"`maxSD`" and "`maxIQR`" represents the mean, median, max standard deviation or max interquartile range of id values in each sample respectively. The default value is "`maxSD`".

* To remove ids with missing values in most of samples, the function calculates the percentage
of missing values in all samples for each id and removes ids with over `naPer`${\times}100\%$ missing values in all samples.
The default value is $0.7$.

* To remove ids with low values, the function calculates the mean of values for each id in all samples and keeps top `meanPer`${\times}100\%$ ids 
based on the mean values. The default value is $0.8$.

* Based on the remained ids filtered by `meanPer`, the function can also remove less variable ids by calculating the
standard deviation of values for each id in all samples and keeping top `varPer`${\times}100\%$ ids based on the standard deviation. The default 
value is $0.8$.

* `corrType`: a character string indicating which correlation coefficient is to be computed for each pair of ids.
The function supports "`spearman`" (default) or "`pearson`" method.

* `MatNet` function supports three methods to construct correlation network: "`value`","`rank`" and "`directed`". 
    * "`value`": the correlation network only keeps id pairs with correlations over cutoff threshold `valueThr`; 
    * "`rank`": for each id A, the function first selects ids that significantly correlate with id A and then extracts a set of candidate neighbors
    (the number of ids is `rankBest`) from the significant set that are most similar to id A. Then, for each id B in the candidate neighbors of id A
    , the function also extracts the same number of ids that are significantly correlated and most similar to id B.
    If id A is also the candidate neighbors of id B, there will be an edge between id A and id B.
    Combining all edges can construct a correlation network; 
    * "`directed`": the function will only keep the most significant id for each id as the edge.  A directed correlation network is
       constructed by combining all edges.

* `valueThr`: the correlation cutoff threshold for "`value`" method

* `rankBest` is the percentage of ids that are most similar to one id for "`rank`" method. The default value is $0.003$ which means
   the "`rank`" method will select top $30$ most similar ids for each id if the number of ids in the matrix is $10,000$.
   
* `networkType`: if set as "`unsigned`", the correlation of all id pairs will be changed to absolute values. The default value is "`signe`".

* `netFDRMethod`: the p value adjustment methods for "`rank`" and "`directed`" methods. The default value is "`BH`".

* `netFDRThr` is FDR threshold for identifying significant pairs for "`rank`" and "`directed`" methods.

* `idNumThr`: If the matrix contains too many ids, it will take a long time and use a lot of memory to identify the modules.    
 Thus, the function provides the option to set the threshold of number of ids for further analysis. After 
 filtering by `meanPer` and `varPer`, if the number of ids is still larger than `idNumThr`, the function will select top `idNumThr`
  ids with the largest variance. The default value is $-1$, which means there is no limitation for the matrix.
  

## Output

The function will output a matrix with two columns.


# Construction of consensus network

To increase robustness against errors in data, a bootstrapping procedure is used to construct a consensus network.

```{r}
library("NetSAM")
inputMatDir <- system.file("extdata","exampleExpressionData.cct",package="NetSAM")
data <- read.table(inputMatDir, header=TRUE, row.names=1, stringsAsFactors=FALSE)
net <- consensusNet(data=data, organism="hsapiens",bootstrapNum=10, naPer=0.5, meanPer=0.8,varPer=0.8,method="rank_unsig",value=3/1000,pth=1e-6, nMatNet=2, nThreads=4)
```

## Input

* `data` should contain a file name with extension `cct` or `cbt` or a matrix or `data.frame` object in R. The first column and first row of
    the `cct` or `cbt` file should be the row and column names, respectively and other parts are the numeric values. The detail information of
    `cct` or `cbt` format can be found in the manual of NetGestalt ([`http://www.netgestalt.org`](http://www.netgestalt.org)). 
    A matrix or data.frame object should have row and column names and only contain numeric or integer values. 

*  `organism` is the organism of the input network. Currently, the package supports the following nine organisms: `hsapiens`, `mmusculus`,
`rnorvegicus`, `drerio`, `celegans`, `scerevisiae`, `cfamiliaris`, `dmelanogaster` and `athaliana`. The default is "`hsapiens`".

* `bootstrapNum`: Number of bootstrap data sets generated. Default is 100. 

* `naPer`: To remove ids with missing values in most of samples, the function calculates the percentage of missing values in 
  all samples for each id and removes ids with over `naPer` missing values in all samples. The default value is 0.5. 

* `meanPer`:  To remove ids with low values, the function calculates the mean of values for each id in all samples and remains top `meanPer`
  ids based on the mean.  The default value is 0.8.

* `varPer`: Based on the remaining ids filtered by `meanPer`, the function can also remove less variable ids by calculating the standard deviation of values for each id in all
 samples and remaining top `varPer` ids based on the standard deviation. The default value is 0.8.
   
* `method`: Method used for constructing correlation network with `MatNet`. Currently supports "rank", "value" and "rank_unsig". Default is "rank_unsig".

* `value`: The corresponding value set for `method`. Default is 0.003.

* `pth`:  p-value threshold for including an edge. Default is 1.0e-6.

* `nMatNet`: The number of concurrent running MatNet processes, default is 2. 

* `nThreads`: consensusNet function supports parallel computing based on multiple cores. The default is 4.
  

## Output

The function will output a matrix with two columns.



# Test input data format

The `testFileFormat` function will test the format of the input data matrix and annotation data and return the standardized data
matrix and sample annotation data.

```{r}
library("NetSAM")
inputMatDir <- system.file("extdata","exampleExpressionData.cct",package="NetSAM")
sampleAnnDir <- system.file("extdata","sampleAnnotation.tsi",package="NetSAM")
formatedData <- testFileFormat(inputMat=inputMatDir,sampleAnn=sampleAnnDir,collapse_mode="maxSD")
```

## Input

* `inputMat`: a file name or a `matrix` or `data.frame` object. 

* `sampleAnn`: a file name or a `data.frame` object.  If the users set `inputMat` as "", the function 
   only tests format of sample annotation data. If the users set `sampleAnn` as "", the  function only tests format of data matrix.
   
* If the input data contains the duplicate ids, the function will collapse duplicate ids based on the `collapse_mode`. 
  "`mean`", "`median`", "`maxSD`" and "`maxIQR`" represents the mean, median, max standard deviation or max interquartile
   range of values for ids in each sample. The default is "`maxSD`".
   
## Output

If there is no format error, the function will return the standardized data matrix and sample annotation data. Otherwise, 
it will output the detailed sources of errors.


# Identification of the associations between sample features and modules

The `featureAssociation` function can be used to calculate the associations between sample features 
in the input sample annotation data and the modules identified by `NetSAM` or `MatSAM` functions.

```{r}
library("NetSAM")
inputMatDir <- system.file("extdata","exampleExpressionData.cct",package="NetSAM")
sampleAnnDir <- system.file("extdata","sampleAnnotation.tsi",package="NetSAM")
data(NetSAMOutput_Example)
outputHtmlFile <- paste(getwd(),"/featureAsso_HTML",sep="")
featureAsso <- featureAssociation(inputMat=inputMatDir, sampleAnn=sampleAnnDir, NetSAMOutput=netsam_output, outputHtmlFile=outputHtmlFile, CONMethod="spearman", CATMethod="kruskal", BINMethod="ranktest", fdrmethod="BH",pth=0.05,collapse_mode="maxSD")
```

## Input

* `inputMat` should be a path to a "`cct`" file or a `matrix` or `data.frame` object. The data should contain column names. 
If the data do not have any row name, the first column of the data should be the ids.

* `sampleAnn` should a path to a "`tsi`" file extension or a `data.frame` object. The detail information of "`tsi`" format can be 
found in the NetGestalt manual . The first row of the sample annotation data is the feature names.
The second row is feature types. The function supports four types: `BIN` (binary feature, such as male and female), 
`CAT` (category feature, such as stage i, stage ii and stage iii), `CON` (continuous feature, such as age) and `SUR` (survival data,
 such as overall survival). The third row is the feature categories. If there is no category information for the features, 
 the sample information will start from the third row. The first column is the sample names.
 
* `NetSAMOutput` is the list object from the NetSAM or MatSAM functions.

* `outputHtmlFile` is the output directory of the HTML file.

* `CONMethod` is the method used to calculate the associations between modules and continuous features. 
     The function provides two methods: "`spearman`" and "`pearson`" and the default value is "`spearman`".
     
* `CATMethod` is the method used to calculate the associations between modules and category features.
   The function provides two methods: "`anova`" and "`kruskal`" and the default value is "`kruskal`".
   
* `BINMethod` is the method used to calculate the associations between modules and binary features. 
    The function provides two methods: "`ttest`" and "`ranktest`" and the default value is "`ranktest`".
    
* `fdrmethod` is the FDR used method for identifying the significantly associated GO terms. The default value is "`BH`".

* `pth` is the threshold of the p values to be identified as significant associations.

* If the input matrix data contains the duplicate ids, the function will collapse duplicate ids based on 
  `collapse_mode`. "`mean`", "`median`", "`maxSD`" and "`maxIQR`" represents the mean, median, max standard deviation or max interquartile
   range of values for ids in each sample. The default is "`maxSD`".
   
## Output

The function will output a `data.frame` object and a HTML file to show the significant associations.

# Identification of the associated GO terms for the modules

The `GOAssociation` function can be used to identify the associated GO terms for the modules identified by `NetSAM` or `MatSAM` functions.

```{r}
library("NetSAM")
data(NetSAMOutput_Example)
outputHtmlFile <- paste(getwd(),"/GOAsso_HTML",sep="")
GOAsso <- GOAssociation(NetSAMOutput=netsam_output, outputHtmlFile=outputHtmlFile, organism="hsapiens", fdrmethod="BH", fdrth=0.05, topNum=5)
```

## Input

* `NetSAMOutput`: the list object from the `NetSAM` or `MatSAM` functions. 

* `outputHtmlFile`: the output directory for the HTML file.

* `organism`: the organism type of the input data matrix that has been used to identify the modules. 
   Currently, the package supports the following nine organisms: `hsapiens`, `mmusculus`, `rnorvegicus`, 
    `drerio`, `celegans`, `scerevisiae`, `cfamiliaris`, `dmelanogaster` and `athaliana`. The default is value is "`hsapiens`".
    
* `outputType`: the type of output associated GO terms . The function supports two types:
    * `significant`:  all GO terms that are significantly associated under a certain FDR threshold
    * `top`:   the function first sorts all GO terms based on their hypergeometric test p values and 
                then selects top GO terms as the associated terms. 
The default value is `significant`.

* `fdrmethod`: the FDR method for identifying the significantly associated GO terms. The default is "`BH`".

* `fdrth`: the FDR threshold.

* `topNum`: the number of selected top GO terms.

## Output

The function will output a `data.frame` object and a HTML file to show the associated GO terms for each module.

# Identification of correlation modules

The `MatSAM` function can identify the hierarchical correlation modules.

```{r}
library("NetSAM")
inputMatDir <- system.file("extdata","exampleExpressionData.cct",package="NetSAM")
sampleAnnDir <- system.file("extdata","sampleAnnotation.tsi",package="NetSAM")
outputFileName <- paste(getwd(),"/MatSAM",sep="")
matModule <- MatSAM(inputMat=inputMatDir, sampleAnn=sampleAnnDir,
                    outputFileName = outputFileName, outputFormat="msm", 
                    organism="hsapiens", map_to_symbol=FALSE, idType="auto", collapse_mode="maxSD", naPer=0.7, meanPer=0.8, varPer=0.8, 
corrType="spearman", matNetMethod="rank",
valueThr=0.6, rankBest=0.003, networkType="signed", netFDRMethod="BH", 
netFDRThr=0.05, minModule=0.003, stepIte=FALSE,
maxStep=4, moduleSigMethod="cutoff", modularityThr=0.2, ZRanNum=10, PerRanNum=100, ranSig=0.05, idNumThr=(-1), nThreads=3)
```

## Input

* `inputMat` should be a path to a "`cct`" file or a `matrix` or `data.frame` object. The data should contain column names. 
If the data do not have any row name, the first column of the data should be the ids.

* `sampleAnn` should a path to a "`tsi`" file extension or a `data.frame` object. The detail information of "`tsi`" format can be 
found in the NetGestalt manual . The first row of the sample annotation data is the feature names.
The second row is feature types. The function supports four types: `BIN` (binary feature, such as male and female), 
`CAT` (category feature, such as stage i, stage ii and stage iii), `CON` (continuous feature, such as age) and `SUR` (survival data,
 such as overall survival). The third row is the feature categories. If there is no category information for the features, 
 the sample information will start from the third row. The first column is the sample names.
 
* `outputFormat` is the format of the output file. "`msm`" format can be used as an input to NetGestalt; 
   "`gmt`" format can be used to perform other network analysis (e.g. as an input to GSEA (Gene Set Enrichment Analysis) to 
   perform module enrichment analysis); "`multiple`" means that the function will output five files: a ruler file containing 
    gene order information, a hmi file containing module information,a net file containing correlation network information,
    a cct file containing the filtered data matrix, and a tsi file containing the sample annotation with standardized format;
    and "`none`" means that the function will not output any file.
    
* If `map_to_symbol` is `TRUE`, the function will first change the input id to gene symbol and collapse multiple 
      ids with the same gene symbol based on the collapse mode method before identifying correlation network. The default value is `FALSE`.
      
* `matNetMethod` specifies the method used to construct correlation network, which has two options: "`value`" and "`rank`".
     Details can be found in the argument description of the `MatNet` function.

The description of other arguments can be found in the argument description of the proceeding functions.


## Output

The function will output a list object containing module information, gene order information, correlation network and filtered matrix based on the ids in the network. The function will also output two HTML files that contain the significant associations between sample 
features and modules identified by `featureAssociation` function and associated GO terms for the modules 
identified by `GOAssociation` function.


 **Note**:  When calling `featureAssociation` function, `MatSAM` uses the default parameters. When calling the GOAssociation function, MatSAM sets 
"`ouputType`" to "`top`" and "`topNum`" to $1$. User can use the list object returned by `MatSAM` as the input to these two functions to perform 
further analysis with different parameters.
 

\name{GOAssociation}
\alias{GOAssociation}

\title{
	Identify the associated GO terms for each module
}

\description{
	 The GOAssociation function will identify the associated GO terms for each module from the NetSAM or MatSAM function.
}

\usage{
	GOAssociation(NetSAMOutput, outputHtmlFile, organism, outputType, fdrmethod, fdrth, topNum)
}

\arguments{
 \item{NetSAMOutput}{
	The list object outputted from the NetSAM or MatSAM function.
  }
 \item{outputHtmlFile}{
	The output directory of the HTML file.
  }
 \item{organism}{
	The organism of the input data matrix that has been used to identify the modules. Currently, the package supports the following nine organisms: hsapiens, mmusculus, rnorvegicus, drerio, celegans, scerevisiae, cfamiliaris, dmelanogaster and athaliana. The default is "hsapiens". 
  }
 \item{outputType}{
	The function supports two types of output results. 1. "significant" represents all associated GO terms should be significant under a certain FDR threshold; 2. "top" represents the function first sorts all GO terms based on their hypergenometric test p values and then selects top GO terms as the associated terms. The default is "significant".
  }
 \item{fdrmethod}{
	The FDR method for identifying the significantly associated GO terms. The default is "BH".
  }
 \item{fdrth}{
	The FDR threshold.
  }
 \item{topNum}{
	The number of the selected top GO terms.
  }

}

\value{
	The function will output a data.frame object and a HTML file to show the associated GO terms for each module.
}

\author{
	Jing Wang
}

\examples{
	data(NetSAMOutput_Example)
	outputHtmlFile <- paste(getwd(),"/GOAsso_HTML",sep="")
	GOAsso <- GOAssociation(NetSAMOutput=netsam_output, outputHtmlFile=outputHtmlFile, organism="hsapiens", fdrmethod="BH", fdrth=0.05, topNum=5)
}

\seealso{
	\code{\link{MatSAM}}
	\code{\link{NetSAM}}
}

\keyword{ methods }

\name{MatSAM}
\alias{MatSAM}

\title{
	Correlation network construction, seriation and modularization from a matrix
}

\description{
	 The MatSAM function first uses MatNet function to identify the correlation network and then uses NetSAM function to identify the module and optimize the one-dimensional ordering of the nodes in each module. 
}

\usage{
MatSAM(inputMat, sampleAnn=NULL, outputFileName, outputFormat="msm", organism="hsapiens", map_to_symbol=FALSE, idType="auto", collapse_mode="maxSD", naPer=0.7, meanPer=0.8, varPer=0.8, corrType="spearman", matNetMethod="rank", valueThr=0.5, rankBest=0.003, networkType="signed", netFDRMethod="BH", netFDRThr=0.05, minModule=0.003, stepIte=FALSE, maxStep=4, moduleSigMethod="cutoff", modularityThr=0.2, ZRanNum=10, PerRanNum=100, ranSig=0.05,  idNumThr=(-1), nThreads=3)
}

\arguments{
  \item{inputMat}{
	\code{inputMat} should contain a file name with extension "cct" or "cbt" or a matrix or data.frame object in R. The first column and first row of the "cct" or "cbt" file should be the row and column names, respectively and other parts are the numeric values. The detail information of "cct" or "cbt" format can be found in the manual of NetGestalt (www.netgestalt.org). A matrix or data.frame object should have row and column names and only contain numeric or integer values.
  }
  \item{sampleAnn}{
	\code{sampleAnn} should contain a file name with  "tsi" extension (the detail information of "tsi" format can be found in the manual of NetGestalt (www.netgestalt.org)) or a data.frame object in R. If the data does not have sample annotation, this argument can be ignored. The first row of the data is the name  of sample features. The second row is the type of each feature. The third row is the category of each feature. If there is no category information for the features, the sample information will start from the third row . The first column is the sample name. 
  }
  \item{outputFileName}{
	Output file name. The file name extension is "msm" which can be uploaded to the NetGestalt directly.
  }
  \item{outputFormat}{
	The format of the output file. "msm" format can be used as an input in NetGestalt; "gmt" format can be used to do other network analysis (e.g. as an input in GSEA (Gene Set Enrichment Analysis) to do module enrichment analysis); "multiple" represents the MatSAM function will output five files: ruler file containing gene order information, hmi file containing module information, net file containing correlation network information, cct file containing the filtered data matrix, and tsi file containing the sample annotation with standardized format; and "none" represents the function will not output any file.
  }
  \item{organism}{
	The organism of the input data. Currently, the package supports the following nine organisms: hsapiens, mmusculus, rnorvegicus, drerio, celegans, scerevisiae, cfamiliaris, dmelanogaster and athaliana. The default is "hsapiens". 
  }
  \item{map_to_symbol}{
	If \code{map_to_symbol} is TRUE, the function will first change the input ids to gene symbols and collapse multiple ids with the same gene symbol based on the \code{collapse_mode} method before identifying correlation network. The default is FALSE.
  }
    \item{idType}{
  	The id type of the ids in the input matrix. MatSAM will use BiomaRt package to transform the input ids to gene symbols based on \code{idType}. The users can also set \code{idType} as "auto" that means MatSAM will automatically search the id type of the input data. However, this may take 10 minutes based on the users' internet speed. The default is "auto".
  }
 \item{collapse_mode}{
	The method to collapse duplicate ids. "mean", "median", "maxSD", "maxIQR", "max" and "min" represent the mean, median, max standard deviation, max interquartile range, maximum and minimum of values for ids in each sample. The default is "maxSD".
  }
  \item{naPer}{
	To remove ids with missing values in most of samples, the function calculates the percentage of missing values in all samples for each id and removes ids with over \code{naPer} missing values in all samples. The default \code{naPer} is 0.7.
 }
  \item{meanPer}{
	To remove ids with low values, the function calculates the mean of values for a id in all samples and remains top \code{meanPer} ids based on the mean. The default \code{meanPer} is 0.8.
  }
  \item{varPer}{
	Based on the remained ids filtered by \code{meanPer}, the function can also remove less variable ids by calculating the standard deviation of values for a id in all samples and remaining top \code{varPer} ids based on the standard deviation. The default \code{varPer} is 0.8.
  }
  \item{corrType}{
	A character string indicating which correlation coefficient is to be computed for each pair of ids. The function supports "spearman" (default) or "pearson" method.
  }
  \item{matNetMethod}{
	MatNet function supports three methods to construct correlation network: "value", "rank" and "directed". 1. "value" method: the correlation network only remains id pairs with correlations over cutoff threshold \code{valueThr}; 2. "rank" method: for each id A, the function first selects ids that significantly correlate with id A and then extracts a set of ids (the number of ids is calculated based on \code{rankBest}) that are most similar to id A from the significant set. Then, for each id B in the set, the function also extracts the same number of ids that are significant correlated and most similar to id B. If id A is in the set of id B, the edge between id A and id B will be remained. Combining all remained edges can construct a correlation network; 3. "directed" method: the function will only remain the best significant id for each id as the edge.Combining all edges can construct a directed correlation network.
  }
  \item{valueThr}{
	Correlation cutoff threshold for "value" method. The default is 0.5.
  }
  \item{rankBest}{
	The percentage of ids that are most similar to one id for "rank" method. The default is 0.003 which means the "rank" method will select top 30 most similar ids for each id if the number of ids in the matrix is 10,000.
  }
  \item{networkType}{
	If \code{networkType} is "unsigned", the correlation of all pairs of ids will be changed to absolute values. The default is "signed".
  }
  \item{netFDRMethod}{
	p value adjustment methods for "rank" and "directed" methods. The default is "BH".
  }
  \item{netFDRThr}{
	fdr threshold for identifying significant pairs for "rank" and "directed" methods. The default is 0.05
  }
\item{minModule}{
	The minimum percentage of nodes in a module. The minimum size of a module is calculated by multiplying \code{minModule} by the number of nodes in the whole network. If the size of a module identified by the function is less than the minimum size, the module will not be further partitioned into sub-modules. The default is 0.003 which means the minimum module size is 30 if there are 10,000 nodes in the whole network. If the minimum module size is less than 5, the minimum module size will be set as 5. The \code{minModule} should be less than 0.2.
  }
  \item{stepIte}{
	Because NetSAM uses random walk distance-based hierarchical clustering to reveal the hierarchical organization of an input network, it requires a specified length of the random walks. If \code{stepIte} is TRUE, the function will test a range of lengths ranging from 2 to \code{maxStep} to get the optimal length. Otherwise, the function will directly use \code{maxStep} as the length of the random walks. The default \code{maxStep} is 4. Because optimizing the length of the random walks will take a long time, if the network is too big (e.g. the number of edges is over 200,000), we suggest to set \code{stepIte} as FALSE.
  }
  \item{maxStep}{
	The length or max length of the random walks.
  }
  \item{moduleSigMethod}{
	To test whether a network under consideration has a non-random internal modular organization, the function provides three options: "cutoff", "zscore" and "permutation". "cutoff" means if the modularity score of the network is above a specified cutoff value, the network will be considered to have internal organization and will be further partitioned. For "zscore" and "permutation", the function will first generate a set of random modularity scores. Based on a unweighted network, the function uses the edge switching method to generate a given number of random networks with the same number of nodes and an identical degree sequence and calculates the modularity scores for these random networks. Based on a weighted network, the function shuffles the weights of all edges and calculate the modularity scores for network with random weights. Then, "zscore" method will transform the real modularity score to a z score based on the random modularity scores and then transform the z score to a p value assuming a standard normal distribution. The "permutation" method will compare the real modularity score with the random ones to calculate a p value. Finally, under a specified significance level, the function determines whether the network can be further partitioned. The default is "cutoff".
  }
  \item{modularityThr}{
	Threshold of modularity score for the  "cutoff" method. The default is 0.2
  }
  \item{ZRanNum}{
	The number of random networks that will be generated for the "zscore" calculation. The default is 10.
  }
  \item{PerRanNum}{
	The number of random networks that will be generated for the "permutation" p value calculation. The default is 100.
  }
  \item{ranSig}{
	The significance level for determining whether a network has non-random internal modular organization for the "zscore" or "permutation" methods. The default is 0.05.
  }
  \item{idNumThr}{
  	If the matrix contains too many ids, it will take a long time and use a lot of memory to identify the modules. Thus, the function provides the option to set the threshold of number of ids for further analysis. After filtering by meanPer and varPer, if the number of ids is still larger than \code{idNumThr}, the function will select top \code{idNumThr} ids with the largest variance. The default is -1, which means there is no limitation for the matrix.
  }
  \item{nThreads}{
	MatSAM function supports parallel computing based on multiple cores. The default is 3.
  }
}

\value{
	Including a "msm" file, the function will output a list object containing module information, gene order information, correlation network and filtered matrix based on the ids in the network. The function will also output two HTML files that contain the significant associations between sample features and modules and associated GO terms for the modules.
}

\note{
After identifying the modules, the MatSAM function will identify the associations between sample features and modules using the featureAssociation function or the associated GO terms for the modules using the GOAssociation function. For the featureAssociation function, MatSAM only uses the default parameters. For the GOAssociation function, MatSAM sets "outputType" as "top" and "topNum" as 1. The users can use the list object returned by MatSAM as the input of the function featureAssociation and GOAssociation to perform some further analysis based on the different parameters.
}


\author{
	Jing Wang
}

\examples{
	inputMatDir <- system.file("extdata","exampleExpressionData.cct",package="NetSAM")
	cat(inputMatDir)
	sampleAnnDir <- system.file("extdata","sampleAnnotation.tsi",package="NetSAM")
	cat(sampleAnnDir)
	outputFileName <- paste(getwd(),"/MatSAM",sep="")
	matModule <- MatSAM(inputMat=inputMatDir, sampleAnn=sampleAnnDir, outputFileName=outputFileName, outputFormat="msm", organism="hsapiens", map_to_symbol=FALSE, idType="auto", collapse_mode="maxSD", naPer=0.7, meanPer=0.8, varPer=0.8, corrType="spearman", matNetMethod="rank", valueThr=0.6, rankBest=0.003, networkType="signed", netFDRMethod="BH", netFDRThr=0.05, minModule=0.003, stepIte=FALSE, maxStep=4, moduleSigMethod="cutoff", modularityThr=0.2, ZRanNum=10, PerRanNum=100, ranSig=0.05, idNumThr=(-1), nThreads=3)
}

\seealso{
	\code{\link{MatNet}}
	\code{\link{NetSAM}}
}

\keyword{ methods }

\name{mapToSymbol}
\alias{mapToSymbol}

\title{
	Map other ids to gene symbols
}

\description{
	 The mapToSymbol function can transform other ids from a gene list, network, matrix, sbt file or sct file to gene symbols.
}

\usage{
mapToSymbol(inputData, organism="hsapiens", inputType="genelist", idType="auto", edgeType="unweighted", collapse_mode="maxSD", is_outputFile=FALSE, outputFileName="", verbose=TRUE)
}

\arguments{
  \item{inputData}{
	mapToSymbol function supports five different types of data:  "genelist", "network", "matrix", "sbt" and "sct".
	For "genelist" type,  \code{inputData} should be a vector containing gene ids. 
	For "network" type, \code{inputData} can be the directory of the input network file including the file name with "net" extension. If \code{edgeType} is "unweighted", each row represents an edge with two node names separated by a tab or space. If \code{edgeType} is "weighted", each row represents an edge with two node names and edge weight separated by a tab or space.  \code{inputNetwork} can also be a data object in R (data object must be igraph, graphNEL, matrix or data.frame class). 
	For "matrix" type, \code{inputData} should be a directory containing a file name with extension "cct" or "cbt"  or a matrix or data.frame object in R. The first column and first row of the "cct" or "cbt" file should be the row and column names, respectively and other parts are the numeric values. The detail information of "cct" or "cbt" format can be found in the manual of NetGestalt (www.netgestalt.org). A matrix or data.frame object should have row and column names and only contain numeric or integer values.
	For "sbt" type, \code{inputData} should be a directory containing a file name with extension "sbt" . The first column of a "sbt" file is the track names, the second one is the descriptions and others are the ids contained in the track. A "sbt" file can contain multiple tracks. The detail information of "sbt" format can be found in the manual of NetGestalt (www.netgestalt.org). 
	For "sct" type, \code{inputData} should be a directory containing a file name with extension "sct" . The first column of a "sct" file is id names, the first row is the column names and others are the numeric or integer values. The detail information of "sct" format can be found in the manual of NetGestalt (www.netgestalt.org). 
  }
  \item{organism}{
	The organism of the input data. Currently, the package supports the following nine organisms: hsapiens, mmusculus, rnorvegicus, drerio, celegans, scerevisiae, cfamiliaris, dmelanogaster and athaliana. The default is "hsapiens". 
  }
  \item{inputType}{
  	The type of the input data. see detail information in \code{inputData}.
  }
   \item{idType}{
  	The id type of the ids in the input data. MatSAM will use BiomaRt package to transform the input ids to gene symbols based on \code{idType}. The users can also set \code{idType} as "auto" that means MatSAM will automatically search the id type of the input data. However, this may take 10 minutes based on the users' internet speed. The default is "auto".
  }
  \item{edgeType}{
	The type of the input network: "weighted" or "unweighted". 
  }
 \item{collapse_mode}{
	The method to collapse duplicate ids. "mean", "median", "maxSD", "maxIQR", "max" and "min" represent the mean, median, max standard deviation, max interquartile range, maximum and minimum of values for ids in each sample. The default is "maxSD". For SCT file, we suggest to use "max" or "min" to collapse duplicate ids in the statistic data.
  }
  \item{is_outputFile}{
  	If \code{is_outputFile} is TRUE, the function will output the transformed data to a file. The default is FALSE.
  }
    \item{outputFileName}{
  	The output file name.
  }
  \item{verbose}{
	Report the extra information on progress. The default is TRUE.
  }
}

\author{
	Jing Wang
}

\examples{
	
	###transform ids from a gene list to gene symbols###
	geneListDir <- system.file("extdata","exampleGeneList.txt",package="NetSAM")
	geneList <- read.table(geneListDir,header=FALSE,sep="\t",stringsAsFactors=FALSE)
	geneList <- as.vector(as.matrix(geneList))
	geneList_symbol <- mapToSymbol(inputData=geneList, organism="hsapiens", inputType="genelist",idType="affy_hg_u133_plus_2")
	
	###transform ids in the input network to gene symbols###
	inputNetwork <- system.file("extdata","exampleNetwork_nonsymbol.net",package="NetSAM")
	network_symbol <- mapToSymbol(inputData=inputNetwork,organism="hsapiens",inputType="network",idType="entrezgene_id",edgeType="unweighted")
	
	###transform ids in the input matrix to gene symbols###
	inputMatDir <- system.file("extdata","exampleExpressionData_nonsymbol.cct",package="NetSAM")
	matrix_symbol <- mapToSymbol(inputData=inputMatDir,organism="hsapiens",inputType="matrix",idType="affy_hg_u133_plus_2",collapse_mode="maxSD")
	
	###transform ids in the sbt file to gene symbols###
	inputSBTDir <- system.file("extdata","exampleSBT.sbt",package="NetSAM")
	sbt_symbol <- mapToSymbol(inputData= inputSBTDir,organism="hsapiens",inputType="sbt",idType="affy_hg_u133_plus_2")
	
	###transform ids in the sct file to gene symbols###
	inputSCTDir <- system.file("extdata","exampleSCT.sct",package="NetSAM")
	sct_symbol <- mapToSymbol(inputData= inputSCTDir,organism="hsapiens",inputType="sct",idType="affy_hg_u133_plus_2",collapse_mode="min")

}

\keyword{ methods }

\name{testFileFormat}
\alias{testFileFormat}

\title{
	Test whether the data matrix and the annotation have a correct format
}

\description{
	 The testFileFormat function will test the format of the input data matrix and annotation data and return the standardized data matrix and sample annotation data.
}

\usage{
	testFileFormat(inputMat=NULL,sampleAnn=NULL,collapse_mode="maxSD")
}

\arguments{

   \item{inputMat}{
	\code{inputMat} should contain a file name with extension "cct" or "cbt" or a matrix or data.frame object in R. The first column and first row of the "cct" or "cbt" file should be the row and column names, respectively and other parts are the numeric values. The detail information of "cct" or "cbt" format can be found in the manual of NetGestalt (www.netgestalt.org). A matrix or data.frame object should have row and column names and only contain numeric or integer values.
  }
  \item{sampleAnn}{
	\code{sampleAnn} is a file name or a data.frame object in R.
  }
 \item{collapse_mode}{
	The method to collapse duplicate ids. "mean", "median", "maxSD", "maxIQR", "max" and "min" represent the mean, median, max standard deviation, max interquartile range, maximum and minimum of values for ids in each sample. The default is "maxSD".
  }
}

\value{
	 If there is no format error, the function will return the standardized data matrix and sample annotation data.  Otherwise, the function will output the detailed position of the errors.
}

\note{
	If the users set inputMat as "", the testFileFormat function only test format of sample annotation data. If the users set sampleAnn as "", the testFileFormat function only test format of data matrix. 
}

\author{
	Jing Wang
}

\examples{
	inputMatDir <- system.file("extdata","exampleExpressionData.cct",package="NetSAM")
	sampleAnnDir <- system.file("extdata","sampleAnnotation.tsi",package="NetSAM")
	
	formatedData <- testFileFormat(inputMat=inputMatDir,sampleAnn=sampleAnnDir,collapse_mode="maxSD")
}

\keyword{ methods }

\name{NetSAM}
\alias{NetSAM}

\title{
	Network Seriation and Modularization
}

\description{
	The NetSAM function uses random walk distance-based hierarchical clustering to identify the hierarchical modules of a weighted or unweighted network and then uses the optimal leaf ordering (OLO) method to optimize the one-dimensional ordering of the genes in each module by minimizing the sum of the pair-wise random walk distance of adjacent genes in the ordering. 
}

\usage{
NetSAM(inputNetwork, outputFileName, outputFormat="nsm", edgeType="unweighted", map_to_genesymbol=FALSE, organism="hsapiens", idType="auto",minModule=0.003, stepIte=FALSE, maxStep=4, moduleSigMethod="cutoff", modularityThr=0.2, ZRanNum=10, PerRanNum=100, ranSig=0.05, edgeThr=(-1), nodeThr=(-1), nThreads=3)
}

\arguments{
  \item{inputNetwork}{
	The network under analysis. \code{inputNetwork} can be the directory of the input network file including the file name with "net" extension. If \code{edgeType} is "unweighted", each row represents an edge with two node names separated by a tab or space. If \code{edgeType} is "weighted", each row represents an edge with two node names and edge weight separated by a tab or space.  \code{inputNetwork} can also be a data object in R (data object must be igraph, graphNEL, matrix or data.frame class). 
  }
  \item{edgeType}{
	The type of the input network: "weighted" or "unweighted". 
  }
  \item{outputFileName}{
	The name of the output file.
  }
  \item{outputFormat}{
	The format of the output file. "nsm" format can be used as an input in NetGestalt; "gmt" format can be used to do other network analysis (e.g. as an input in GSEA (Gene Set Enrichment Analysis) to do module enrichment analysis); "multiple" represents the NetSAM function will output three files: ruler file containing gene order information, hmi file containing module information and net file containing network information; and "none" represents the function will not output any file.
  }
  \item{map_to_genesymbol}{
        Because pathway enrichment analysis in NetGestalt is based on gene symbol, setting \code{map_to_genesymbol} as TRUE can transform other ids in the network into gene symbols and thus allow users to do functional analysis based on the identified modules. If the input network is not a biology network or users do not plan to do enrichment analysis in the NetGestalt, users can set \code{map_to_genesymbol} as FALSE. The default is FALSE.
  }
  \item{organism}{
	The organism of the input network. Currently, the package supports the following nine organisms: hsapiens, mmusculus, rnorvegicus, drerio, celegans, scerevisiae, cfamiliaris, dmelanogaster and athaliana. The default is "hsapiens". 
  }
   \item{idType}{
  	The id type of the ids in the input network. MatSAM will use BiomaRt package to transform the input ids to gene symbols based on \code{idType}. The users can also set \code{idType} as "auto" that means MatSAM will automatically search the id type of the input data. However, this may take 10 minutes based on the users' internet speed. The default is "auto".
  }
  \item{minModule}{
	The minimum percentage of nodes in a module. The minimum size of a module is calculated by multiplying \code{minModule} by the number of nodes in the whole network. If the size of a module identified by the function is less than the minimum size, the module will not be further partitioned into sub-modules. The default is 0.003 which means the minimum module size is 30 if there are 10,000 nodes in the whole network. If the minimum module size is less than 5, the minimum module size will be set as 5. The \code{minModule} should be less than 0.2.
  }
  \item{stepIte}{
	Because NetSAM uses random walk distance-based hierarchical clustering to reveal the hierarchical organization of an input network, it requires a specified length of the random walks. If \code{stepIte} is TRUE, the function will test a range of lengths ranging from 2 to \code{maxStep} to get the optimal length. Otherwise, the function will directly use \code{maxStep} as the length of the random walks. The default \code{maxStep} is 4. Because optimizing the length of the random walks will take a long time, if the network is too big (e.g. the number of edges is over 200,000), we suggest to set \code{stepIte} as FALSE.
  }
  \item{maxStep}{
	The length or max length of the random walks.
  }
  \item{moduleSigMethod}{
	To test whether a network under consideration has a non-random internal modular organization, the function provides three options: "cutoff", "zscore" and "permutation". "cutoff" means if the modularity score of the network is above a specified cutoff value, the network will be considered to have internal organization and will be further partitioned. For "zscore" and "permutation", the function will first generate a set of random modularity scores. Based on a unweighted network, the function uses the edge switching method to generate a given number of random networks with the same number of nodes and an identical degree sequence and calculates the modularity scores for these random networks. Based on a weighted network, the function shuffles the weights of all edges and calculate the modularity scores for network with random weights. Then, "zscore" method will transform the real modularity score to a z score based on the random modularity scores and then transform the z score to a p value assuming a standard normal distribution. The "permutation" method will compare the real modularity score with the random ones to calculate a p value. Finally, under a specified significance level, the function determines whether the network can be further partitioned. The default is "cutoff".
  }
  \item{modularityThr}{
	Threshold of modularity score for the  "cutoff" method. The default is 0.2
  }
  \item{ZRanNum}{
	The number of random networks that will be generated for the "zscore" calculation. The default is 10.
  }
  \item{PerRanNum}{
	The number of random networks that will be generated for the "permutation" p value calculation. The default is 100.
  }
  \item{ranSig}{
	The significance level for determining whether a network has non-random internal modular organization for the "zscore" or "permutation" methods.
  }
  \item{edgeThr}{
	If the network is too big, it will take a long time to identify the modules. Thus, the function provides the option to set the threshold of number of edges and nodes as \code{edgeThr} and \code{nodeThr}. If the size of network is over the threshold, the function will stop and the users should change the parameters and re-run the function. We suggest to set the threshold for node as 12,000 and the threshold for edge as 300,000. The default is -1, which means there is no limitation for the input network.
  }
  \item{nodeThr}{
  	see \code{edgeThr}.
  }
  \item{nThreads}{
	NetSAM function supports parallel computing based on multiple cores. The default is 3.
  }
}

\value{
	If output format is "nsm", the function will output not only a "nsm" file but also a list object containing module information, gene order information and network information. If output format is "gmt", the function will output the "gmt" file and a matrix object containing the module and annotation information.
}

\note{
	Because the seriation step requires pair-wise distance between all nodes, NetSAM is memory consuming. We recommend to use the 64 bit version of R to run the NetSAM. For networks with less than 10,000 nodes, we recommend to use a computer with 8GB memory. For networks with more than 10,000 nodes, a computer with at least 16GB memory is recommended.
}

\author{
	Jing Wang
}

\examples{
	inputNetworkDir <- system.file("extdata","exampleNetwork.net",package="NetSAM")
	outputFileName <- paste(getwd(),"/NetSAM",sep="")
	result <- NetSAM(inputNetwork=inputNetworkDir, outputFileName=outputFileName, outputFormat="nsm", edgeType="unweighted", map_to_genesymbol=FALSE, organism="hsapiens", idType="auto",minModule=0.003, stepIte=FALSE, maxStep=4, moduleSigMethod="cutoff", modularityThr=0.2, ZRanNum=10, PerRanNum=100, ranSig=0.05, edgeThr=(-1), nodeThr=(-1), nThreads=3)
}

\keyword{ methods }

\name{NetAnalyzer}
\alias{NetAnalyzer}

\title{
	Network analyzer
}

\description{
	The NetAnalyzer function can calculate the degree, clustering coefficient, betweeness and closeness centrality for each node and the shortest path distance for each pair of nodes. The NetAnalyzer function can also plot the distributions for these measurements.
}

\usage{
NetAnalyzer(inputNetwork, outputFileName,edgeType="unweighted")
}

\arguments{
  \item{inputNetwork}{
	The network under analysis. \code{inputNetwork} can be the directory of the input network file including the file name with "net" extension. If \code{edgeType} is "unweighted", each row represents an edge with two node names separated by a tab or space. If \code{edgeType} is "weighted", each row represents an edge with two node names and edge weight separated by a tab or space.  \code{inputNetwork} can also be a data object in R (data object must be igraph, graphNEL, matrix or data.frame class). 
  }
  \item{edgeType}{
	The type of the input network: "weighted" or "unweighted". 
  }
  \item{outputFileName}{
	The name of the output file.
  }
}

\value{
	The function will output two "txt" files and five "pdf" files. Two "txt" files contain degree, clustering coefficient, betweeness and closeness centrality for each node and the shortest path distance for each pair of nodes. Five "pdf" files are the distributions of these measurements.
}

\author{
	Jing Wang
}

\examples{
	inputNetworkDir <- system.file("extdata","exampleNetwork.net",package="NetSAM")
	outputFileName <- paste(getwd(),"/NetSAM",sep="")
	NetAnalyzer(inputNetworkDir,outputFileName,"unweighted")
}

\keyword{ methods }

\name{netsam_output}
\alias{netsam_output}
\docType{data}
\title{
   An example of the list object returned by NetSAM function
}
\description{
   The list object contains at least three parts: gene order information, module information and network information. This object can be used as an input of the function featureAssociation or GOAssociation.
}
\usage{data(NetSAMOutput_Example)}
\format{list}

\keyword{datasets}

\name{NetSAM-package}
\alias{NetSAM-package}

\docType{package}
\title{
	Network Seriation and Modularization
}
\description{
	The NetSAM (Network Seriation and Modularization) package takes an edge-list representation of a weighted or unweighted network as an input, performs network seriation and modularization analysis, and generates as files that can be used as an input for the one-dimensional network visualization tool NetGestalt (http://www.netgestalt.org) or other network analysis. Meanwhile, the NetSAM package can also generate correlation network (e.g. co-expression network) based on the input matrix data and then perform seriation and modularization analysis for correlation network.
}
\details{
	\tabular{ll}{
		Package: \tab NetSAM\cr
		Type: \tab Package\cr
		Version: \tab 1.31.1\cr
		Date: \tab 2021-05-15\cr
		License: \tab LGPL\cr
		LazyLoad: \tab yes\cr
	}
}

\author{
	Jing Wang
	Maintainer: Zhiao Shi <zhiao.shi@gmail.com>
}

\references{
	NetGestalt: integrating multidimensional omics data over biological networks. Nature Methods 10, 597-598 (2013).
}

\seealso{
	\code{\link{NetSAM}}
	\code{\link{MatSAM}}
}

\keyword{ package }

\name{mergeDuplicate}
\alias{mergeDuplicate}

\title{
	Merge the duplicate Ids in the matrix data
}

\description{
	 The mergeDuplicate function will merge the duplicate Ids in the matrix data and return the matrix with unique Ids. This function can also used to merge the duplicate mapped Ids when transforming the Ids of data matrix to other Ids.

}

\usage{
	mergeDuplicate(id, data, collapse_mode="maxSD")
}

\arguments{
  \item{id}{
	Duplicate Ids that should be a vector object in R.
  }
  \item{data}{
  	the corresponding data matrix that has the same number of rows with \code{id} and should be a matrix or data.frame object in R.
  }
 \item{collapse_mode}{
	The method to collapse duplicate ids. "mean", "median", "maxSD", "maxIQR", "max" and "min" represent the mean, median, max standard deviation, max interquartile range, maximum and minimum of values for ids in each sample. The default is "maxSD".
  }

}

\value{
	The function will return the data matrix with unique Ids.
}

\author{
	Jing Wang
}

\examples{
	inputMatDir <- system.file("extdata","exampleExpressionData_nonsymbol.cct",package="NetSAM")
	inputMat <- read.table(inputMatDir,header=TRUE,sep="\t",stringsAsFactors=FALSE,check.names=FALSE)
	mergedData <- mergeDuplicate(id=inputMat[,1],data=inputMat[,2:ncol(inputMat)],collapse_mode="maxSD")
}

\keyword{ methods }

\name{featureAssociation}
\alias{featureAssociation}

\title{
	Calculate the associations between modules and sample features
}

\description{
	 The featureAssociation function will calculate the associations between the sample features in the input annotation data and the modules identified by NetSAM or MatSAM function.
}

\usage{
	featureAssociation(inputMat, sampleAnn, NetSAMOutput, outputHtmlFile, CONMethod="spearman", CATMethod="kruskal", BINMethod="ranktest", fdrmethod="BH",pth=0.05,collapse_mode="maxSD")
}

\arguments{
  \item{inputMat}{
	\code{inputMat} should contain a file name with extension "cct" or "cbt" or a matrix or data.frame object in R. The first column and first row of the "cct" or "cbt" file should be the row and column names, respectively and other parts are the numeric values. The detail information of "cct" or "cbt" format can be found in the manual of NetGestalt (www.netgestalt.org). A matrix or data.frame object should have row and column names and only contain numeric or integer values.
  }
  \item{sampleAnn}{
	\code{sampleAnn} should be a directory containing a file name with  "tsi" extension or a data.frame object in R. The detail information of "tsi" format can be found in the manual of NetGestalt (www.netgestalt.org). The first row of the sample annotation data is the feature names. The second row is the feature types. The function supports four types: BIN (binary feature, such as male and female), CAT (category feature, such as stage i, stage ii and stage iii), CON (continuous feature, such as age) and SUR (survival data, such as overall survival). The third row is the feature categories. If there is no category information for the features, the sample information will start from the third row . The first column is the sample names.
  }
 \item{NetSAMOutput}{
	The list object outputted from NetSAM or MatSAM.
  }
 \item{outputHtmlFile}{
	The output directory of the HTML file.
  }
 \item{CONMethod}{
	The method to calculate the associations between modules and continuous features. The function provides two methods: "spearman" and "pearson" and the default is "spearman".
  }
 \item{CATMethod}{
	The method to calculate the associations between modules and category features. The function provides two methods: "anova" and "kruskal" and the default is "kruskal".
  }
 \item{BINMethod}{
	The method to calculate the associations between modules and binary features. The function provides two methods: "test" and "rankest" and the default is "rankest".
  }
\item{fdrmethod}{
	The FDR method for identifying the significantly associated GO terms. The default is "BH".
}
 \item{pth}{
	The threshold of the p values to identify the significant associations.
  }
 \item{collapse_mode}{
	The method to collapse duplicate ids. "mean", "median", "maxSD", "maxIQR", "max" and "min" represent the mean, median, max standard deviation, max interquartile range, maximum and minimum of values for ids in each sample. The default is "maxSD".
  }

}

\value{
	The function will output a data.frame object and a HTML file to show the significant associations.
}

\author{
	Jing Wang
}

\examples{
	inputMatDir <- system.file("extdata","exampleExpressionData.cct",package="NetSAM")
	sampleAnnDir <- system.file("extdata","sampleAnnotation.tsi",package="NetSAM")
	data(NetSAMOutput_Example)
	outputHtmlFile <- paste(getwd(),"/featureAsso_HTML",sep="")
	featureAsso <- featureAssociation(inputMat= inputMatDir, sampleAnn=sampleAnnDir, NetSAMOutput=netsam_output, outputHtmlFile=outputHtmlFile, CONMethod="spearman", CATMethod="kruskal", BINMethod="ranktest", fdrmethod="BH",pth=0.05,collapse_mode="maxSD")
}

\seealso{
	\code{\link{MatSAM}}
	\code{\link{NetSAM}}
}

\keyword{ methods }

\name{consensusNet}
\alias{consensusNet}

\title{
	Construction of a consensus coexpression network
}

\description{
  To increase robustness against errors in data, the consensusNet function uses a bootstrapping procedure to construct a coexpression network.
}

\usage{
  consensusNet(data, organism="hsapiens",bootstrapNum=100, naPer=0.5, meanPer=0.8,varPer=0.8,method="rank_unsig",value=3/1000,pth=1e-6, nMatNet=2, nThreads=4)
}

\arguments{
 \item{data}{
	\code{data} should contain a file name with extension "cct" or "cbt" or a matrix or data.frame object in R. The first column and first row of the "cct" or "cbt" file should be the row and column names, respectively and other parts are the numeric values. The detail information of "cct" or "cbt" format can be found in the manual of NetGestalt (www.netgestalt.org). A matrix or data.frame object should have row and column names and only contain numeric or integer values.
  }
 \item{organism}{
   	The organism of the input data. Currently, the package supports the following nine organisms: hsapiens, mmusculus, rnorvegicus, drerio, 
celegans, scerevisiae, cfamiliaris, dmelanogaster and athaliana. The default is "hsapiens".
 }
 \item{bootstrapNum}{
   Number of bootstrap data sets generated. Default is 100.
 }
   \item{naPer}{
	To remove ids with missing values in most of samples, the function calculates the percentage of missing values in all samples for each id and removes ids with over \code{naPer} missing values in all samples. The default \code{naPer} is 0.5.
 }
 \item{meanPer}{
	To remove ids with low values, the function calculates the mean of values for each id in all samples and remains top \code{meanPer} ids based on the mean. 
The default \code{meanPer} is 0.8.
  }
  \item{varPer}{
	Based on the remaining ids filtered by \code{meanPer}, the function can also remove less variable ids by calculating the standard deviation of values for each id in all
 samples and remaining top \code{varPer} ids based on the standard deviation. The default \code{varPer} is 0.8.
  }
  \item{method}{
  Method used for constructing correlation network with \code{MatNet}. Currently supports "rank", "value" and "rank_unsig". Default is "rank_unsig".
  }
  \item{value}{
  The corresponding value set for \code{method}. Default is 0.003.
  }
  \item{pth}{
  p-value threshold for including an edge. Default is 1.0e-6.
  }
  \item{nMatNet}{
   The number of concurrent running MatNet processes, default is 2.
  }
  \item{nThreads}{
	 consensusNet function supports parallel computing based on multiple cores. The default is 4.
  }
}

\author{
	Jing Wang
}

\examples{
  inputMatDir <- system.file("extdata","exampleExpressionData.cct",package="NetSAM")
  data <- read.table(inputMatDir, header=TRUE, row.names=1, stringsAsFactors=FALSE)
  net <- consensusNet(data, organism="hsapiens",bootstrapNum=10, naPer=0.5, meanPer=0.8,varPer=0.8,method="rank_unsig",value=3/1000,pth=1e-6, nMatNet=2, nThreads=4)
}

\keyword{ methods }

\name{MatNet}
\alias{MatNet}

\title{
	Construction of correlation network from a matrix
}

\description{
	 The MatNet function can use one of three different methods to construct correlation network based on the input data matrix. The output correlation network can be used as an input of NetSAM function to identify hierarchical modules.
}

\usage{
MatNet(inputMat, collapse_mode="maxSD", naPer=0.7, meanPer=0.8, varPer=0.8, corrType="spearman", matNetMethod="rank", valueThr=0.5, rankBest=0.003, networkType="signed", netFDRMethod="BH", netFDRThr=0.05, idNumThr=(-1),nThreads=3)
}

\arguments{
 \item{inputMat}{
	\code{inputMat} should contain a file name with extension "cct" or "cbt" or a matrix or data.frame object in R. The first column and first row of the "cct" or "cbt" file should be the row and column names, respectively and other parts are the numeric values. The detail information of "cct" or "cbt" format can be found in the manual of NetGestalt (www.netgestalt.org). A matrix or data.frame object should have row and column names and only contain numeric or integer values.
  }
  \item{collapse_mode}{
	If the input matrix data contains the duplicate ids, the function will collapse duplicate ids based on the \code{collapse_mode}. "mean", "median", "maxSD" and "maxIQR" represent the mean, median, max standard deviation or max interquartile range of id values in each sample. The default is "maxSD".
  }
   \item{naPer}{
	To remove ids with missing values in most of samples, the function calculates the percentage of missing values in all samples for each id and removes ids with over \code{naPer} missing values in all samples. The default \code{naPer} is 0.7.
 }
 \item{meanPer}{
	To remove ids with low values, the function calculates the mean of values for each id in all samples and remains top \code{meanPer} ids based on the mean. The default \code{meanPer} is 0.8.
  }
  \item{varPer}{
	Based on the remained ids filtered by \code{meanPer}, the function can also remove less variable ids by calculating the standard deviation of values for each id in all samples and remaining top \code{varPer} ids based on the standard deviation. The default \code{varPer} is 0.8.
  }
  \item{corrType}{
	The method to calculate correlation coefficient for each pair of ids. The function supports "spearman" (default) or "pearson" method.
  }
  \item{matNetMethod}{
	MatNet function supports three methods to construct correlation network: "value", "rank" and "directed". 1. "value" method: the correlation network only remains id pairs with correlations over cutoff threshold \code{valueThr}; 2. "rank" method: for each id A, the function first selects ids that significantly correlate with id A and then extracts a set of candidate neighbors (the number of ids is calculated based on \code{rankBest}) from the significant set that are most similar to id A. Then, for each id B in the candidate neighbors of id A, the function also extracts the same number of ids that are significant correlated and most similar to id B. If id A is also the candidate neighbors of id B, there will be an edge between id A and id B. Combining all edges can construct a correlation network; 3. "directed" method: the function will only remain the best significant id for each id as the edge.Combining all edges can construct a directed correlation network.
  }
  \item{valueThr}{
	Correlation cutoff threshold for "value" method. The default is 0.5.
  }
  \item{rankBest}{
	The percentage of ids that are most similar to one id for "rank" method. The default is 0.003 which means the "rank" method will select top 30 most similar ids for each id if the number of ids in the matrix is 10,000.
  }
  \item{networkType}{
	If \code{networkType} is "unsigned", the correlation of all pairs of ids will be changed to absolute values. The default is "signed".
  }
  \item{netFDRMethod}{
	p value adjustment methods for "rank" and "directed" methods. The default is "BH".
  }
  \item{netFDRThr}{
	fdr threshold for identifying significant pairs for "rank" and "directed" methods. The default is 0.05
  }
  \item{idNumThr}{
  	If the matrix contains too many ids, it will take a long time and use a lot of memory to identify the modules. Thus, the function provides the option to set the threshold of number of ids for further analysis. After filtering by meanPer and varPer, if the number of ids is still larger than \code{idNumThr}, the function will select top \code{idNumThr} ids with the largest variance. The default is -1, which means there is no limitation for the matrix.
  }
  \item{nThreads}{
	MatNet function supports parallel computing based on multiple cores. The default is 3.
  }
}

\note{
For data with missing values, the function will take longer time to calculate correlation between each pair of ids than data without missing value.
}

\author{
	Jing Wang
}

\examples{
	inputMatDir <- system.file("extdata","exampleExpressionData.cct",package="NetSAM")
	matNetwork <- MatNet(inputMat=inputMatDir, collapse_mode="maxSD", naPer=0.7, meanPer=0.8, varPer=0.8, corrType="spearman", matNetMethod="rank", valueThr=0.6, rankBest=0.003, networkType="signed", netFDRMethod="BH", netFDRThr=0.05, idNumThr=(-1),nThreads=3)
}

\keyword{ methods }
